/* ChiRK 1.2  (c) 1992 Bo Yang                                           */

#include "chirk.h"
#include "ASCbitmap.h"

#define TagXLow  0x40
#define TagXHigh 0x20
#define TagYLow  0x60
#define TagYHigh 0x20

extern BOOL     eightypl;
extern BOOL     doubleline;
extern BOOL     highfont;
extern unsigned int Xp, Yp;
extern FILE    *fp;
extern unsigned char *ccfont;
extern int      lfheight;

unsigned char   linebits[Fheight][2], linebytes[Fheight + 2];
unsigned char  *asc_bitmap = ASCbitmap;
unsigned int    fx, fy;

void 
outvct()
{				/* write a single Tektronics 4010 vector
				 * drawing command */
      unsigned char   chy, cly, chx, clx;
      static unsigned char chyl = 0xFF, clyl = 0xFF, chxl = 0xFF;

      chy = fy >> 5;
      cly = fy & MaskLow;
      chx = fx >> 5;
      clx = fx & MaskLow;
      if (chyl != chy) {
	    fputc(chy | TagYHigh, fp);
	    chyl = chy;
      }
      if (clyl != cly) {
	    if (chxl == chx)
		  fputc(cly | TagYLow, fp);
	    clyl = cly;
      }
      if (chxl != chx) {
	    fputc(cly | TagYLow, fp);
	    fputc(chx | TagXHigh, fp);
	    chxl = chx;
      }
      fputc(clx | TagXLow, fp);
}

void 
outcharV(len, code)		/* write a character with vectors */
      int             len, code;
{
      int             ind0, ind1, d;

      if (len == 1) {
	    if (highfont)
		  outcharB(len, code);
	    else if (code != 32) {
		  fx = (Xp >> 1);
		  fy = Yp - lfheight + 12;
		  fputc(ESC, fp);
/*
		  fputc('1',fp);
*/
		  fputc(GS, fp);
		  outvct();
		  fputc(US, fp);
		  fputc(code, fp);
		  fputc(GS, fp);
	    }
	    return;
      }
      d = code + code + code;
      ind0 = 22845 + (((((int) ccfont[d]) << 8) + ccfont[d + 1]) << 8) + ccfont[d + 2];
      ind1 = 22845 + (((((int) ccfont[d + 3]) << 8) + ccfont[d + 4]) << 8) + ccfont[d + 5];
      while (ind0 < ind1) {
	    if ((ccfont[ind0] & 0x80)) {
	       fputc(ESC,fp); 
/*
	       fputc('1',fp); 
*/
	       fputc(GS, fp);
	    }
	    fx = ((ccfont[ind0++] & 0x7f) + 0x4) >> 2;
	    fy = (ccfont[ind0++] + 0x2) >> 2;
	    if (highfont)
		  fy += fy >> 1;
	    if (eightypl) {
		  fx >>= 1;
		  fx += (fx >> 1) + (Xp >> 1);
	    } else
		  fx += (Xp >> 1);
	    fy = Yp - fy;
	    outvct();
      }
/*
      fputc(ESC, fp);
*/
      fputc(GS, fp);
}

void 
outcharB(len, code)		/* write a character with bitmaps  */
      int             len;
      unsigned int    code;
{
      register unsigned int j, k, j1;
      int             i, bytelen;
      register unsigned char byte;

      if (len == 2) {
	    code <<= 5;
	    for (i = 0; i < Fheight; i++) {
		  linebits[i][0] = ccfont[code + 2 * i];
		  linebits[i][1] = ccfont[code + 2 * i + 1];
	    }
      } else {
	    if (code == 32)
		  return;
	    for (i = 0; i < Fheight; i++)
		  linebits[i][0] = asc_bitmap[(code << 4) + i];
      }
      bytelen = Fheight >> (2 - len);
      fy = Yp;
      linebytes[bytelen] = 0;
      linebytes[bytelen + 1] = 1;
      for (i = 0; i < Fheight; i++) {
	    j1 = 0;
	    for (j = 0; j < len; j++) {
		  byte = linebits[i][j];
		  for (k = 0; k < 8; k++) {
			linebytes[j1++] = (byte >= 0x80);
			byte <<= 1;
		  }
	    }
	    for (k = 0; k < 1 + doubleline; k++) {
		  fy = fy > 0 ? fy - (highfont ? 3 : 2) + doubleline : 0;
		  j = 0;
		  while (j < bytelen && !linebytes[j])
			j++;
		  j1 = j;
		  while (j < bytelen) {
			if (eightypl)
			      j += (j >> 1);	/* 80 characters per line */
			else
			      j <<= 1;
			fx = j + (Xp >> 1);
			outvct();
			while (linebytes[++j1]);
			j = j1 - 1;
			if (eightypl)
			      j += (j >> 1);
			else
			      j <<= 1;
			fx = j + (Xp >> 1);
			outvct();
			fputc(ESC,fp);
/*
			fputc('1',fp);
*/
			fputc(GS, fp);
			while (!linebytes[++j1]);
			j = j1;
		  }
	    }
      }
}
