/* ChiRK 1.2a  (c) 1992 Bo Yang                                           */
 
#include <file.h>
#include <signal.h>
#include <string.h>
#include <setjmp.h>
#include <types.h>
#include <stat.h>

#include "chirk.h"
#include "control.h"

char           *getenv(), *malloc();

extern int      cwidth;		/* number of chars per line  */
extern int      cheight, lfheight;

char           *initstr = Tekinitstr;	/* Tektronics graphics initialization */
char           *overstr = Tekoverstr;	/* Tektronics graphics exit */
char           *clearstr = Tekclearstr;

#define  Cclibln   481000	/* Length of cclib.v	 */
#define  SizeStdBuf 256000	/* Length of Standard Input Buffer */

BOOL            big5 = BIG5;	/* view big5 encoded Chinese? */
BOOL            autowrap = TRUE;
BOOL            eightypl = TRUE;/* 80 chars per line?   */
BOOL            bitmapfont = FALSE;	/* default vector font  */
BOOL            doubleline = FALSE;	/* use with Hi-Res monitors  */
BOOL            highfont = FALSE;	/* higher font for VT2xx terminals */
BOOL            interactive = TRUE;	/* otherwise use as a filter */
BOOL		genuine4010 = FALSE;	/* real thing	*/
BOOL		HZon = HZ_ENCD;		/* HZ coding set by Makefile flag */
BOOL		zWon = zW_ENCD;		/* zW coding set by Makefile flag  */  
BOOL		traditional=FALSE;	/* use traditional fonts with GB */

void            (*outchar) ();
jmp_buf         env;
FILE           *fp;
unsigned char  *ccfont;
unsigned char *Fbuf;
int             pagenum = 0;
static int      load_font = 0;
/* interactive  interface   */

void 
tekccview(Hfile, Hcclib)
      int             Hfile, Hcclib;
{
      int             i, j, k, cb1, quwei, quitflag = 0, pageln = 1;
      unsigned char *ccbuf, kchr;
      long int        chpst = 0, fileln = 0;
      int             page = 1, num0 = 0, num = 1;

#if CHINESE_NEWS_READER
#else
      if( (Fbuf = allobuf(Hfile) ) == NULL)  return;
      while (!quitflag) {
	    if (( i=read(Hfile, &Fbuf[fileln], BUFSIZ)) > 0) 
		fileln += i;
	    else
		  quitflag = 1;
      }
#endif

      if (load_font == 0) {
         if( (ccbuf = allobuf( Hcclib)) == NULL) return;
         fileln = 0;
         quitflag = 0;
         while (!quitflag) {
	    if ((i=read(Hcclib, &ccbuf[fileln], BUFSIZ)) > 0)
	    	fileln += i;
	    else
		  quitflag = 1;
         }
         ccfont = ccbuf;
	 load_font = 1;
      }

      pagenum = 0;
      while (pageln) {		/* figure out the total pages:   */
	    pageln = showpage(0, &Fbuf[chpst += pageln]);
	    pagenum++;
      }

      chpst = 0;
      setjmp(env);		/* return here after being stopped	 */
      pageln = showpage(1, &Fbuf[chpst]);
      quitflag = 0;
      while (!quitflag) {
	    fflush(fp);
	    kchr = interactive ? getchr() : (page == pagenum ? 'q' : 'f');
	    switch (kchr) {
	    case ' ':
	    case 13:
	    case 'f':
	    case 'F':
		  if (page == pagenum)
			break;
		  if (page + num > pagenum)
			num = pagenum - page;
		  for (i = 0; i < num - 1; i++) {
			chpst += pageln;
			pageln = showpage(0, &Fbuf[chpst]);
			page++;
		  }
		  chpst += pageln;
		  setjmp(env);	/* return here also		 */
		  pageln = showpage(++page, &Fbuf[chpst]);
		  num0 = 0;
		  break;
	    case 'b':
	    case 'B':
		  if (page == 1)
			break;
		  chpst = 0;
		  page = page - num > 1 ? page - num : 1;
		  for (i = 1; i < page; i++) {
			pageln = showpage(0, &Fbuf[chpst]);
			chpst += pageln;
		  }
		  setjmp(env);	/* here too	 */
		  pageln = showpage(page, &Fbuf[chpst]);
		  num0 = 0;
		  break;
	    case '0':
	    case '1':
	    case '2':
	    case '3':
	    case '4':
	    case '5':
	    case '6':
	    case '7':
	    case '8':
	    case '9':
		  num0 = num0 > 1000 ? (num0 % 1000) * 10 + kchr - '0' :
			num0 * 10 + kchr - '0';
		  break;
	    case 'q':
	    case 'Q':
		  quitflag = 1;
		  break;
	    default:
		  num0 = 0;
	    }
	    num = num0 ? num0 : 1;
      }
}

unsigned char *allobuf( fd)
int fd;
{
struct stat stb;
unsigned char *p;

     if( fstat(fd, &stb) <0) {
	fprintf( stderr, "error in fstat() call");
	return( NULL);
	}
    if( !fd) stb.st_size = SizeStdBuf;
    if( (p = (unsigned char *) malloc(stb.st_size)) == NULL) {
	fprintf( stderr, "can't malloc %d\n", stb.st_size);
	return( NULL);
	}
    return p;
}

/*
 * interrupt and signal processing, make sure the terminal's OK when exiting
 * from the program 
 */

#ifdef SIGTSTP
void 
stopint()
{
      fflush(fp);
      tekover();
      (void) signal(SIGTSTP, SIG_DFL);
#if SIGSETMASK
      sigsetmask(0);
#endif
      kill(getpid(), SIGTSTP);	/* Leave here... Now returned */
      tekinit();
      longjmp(env, 1);
}
#endif

void 
interrupt()
{
      (void) signal(SIGINT, SIG_DFL);
      tekover();
      exit(0);
}

/* put the terminal to graphics mode, keyboard to raw mode */

void 
tekinit()
{

      (void) signal(SIGINT, interrupt);
#ifdef SIGTSTP
      (void) signal(SIGTSTP, stopint);
#endif
      fputs(initstr, fp);
      fputs(clearstr,fp);
      raw_mode(1);
}

/* switch back	 */

void 
tekover()
{
      fputs(clearstr,fp);
      fputs(overstr, fp);
      fflush(fp);
      if( genuine4010)
	sleep( 2);
      raw_mode(0);
}

#if CHINESE_NEWS_READER
news_chinese(buf)
      unsigned char *buf;
{
      int             i, j, Hfile = 0, Hcclib;
      char            filename[30], *termname, *cclibfile;

      fp = stdout;

      termname = getenv("TERM");/* use doubleline with Xterms  */
      if (strncmp(termname, "xterm", 5) == 0)
            doubleline = TRUE;
      else if(strncmp(termname, "tek", 3)==0)
        genuine4010 = TRUE;


      /* no vector font available for big5 (?) */
      if (big5) {
            bitmapfont = TRUE;
            HZon = zWon = FALSE;
            outchar = outcharB;
            if (!(cclibfile = getenv("CHINESE16")))
                  cclibfile = CHINESE16;
      } else if (bitmapfont) {
            outchar = outcharB;
            if (!(cclibfile = getenv( traditional ? "CCLIB16f": "CCLIB16")))
                  cclibfile = traditional ? CCLIB16f : CCLIB16;
      } else {
            outchar = outcharV;                                                
            if (!(cclibfile = getenv("CCLIBv")))
                  cclibfile = CCLIBv;
      }
      if ((Hcclib = open(cclibfile, O_RDONLY)) < 0) {                           
            fprintf(stderr, "Can't open chinese font file %s\n", cclibfile);
            exit(-1);
      }
      cheight = highfont ? HiCheight : Cheight;
      lfheight = highfont ? HiLFheight : LFheight;
      if (Hfile)
            fputs("\nChiRK 1.2a  by Bo Yang,  (c)1992\n\n", stderr);

      tekinit();
      Fbuf = buf;
      atexit(interrupt);
      tekccview(Hfile, Hcclib);
      tekover();
}                                                                               
#else CHINESE_NEWS_READER
main(argc, argv)
      int             argc;
      char           *argv[];
{
      int             i, j, Hfile = 0, Hcclib;
      char            filename[30], *termname, *cclibfile;

      fp = stdout;
      for (i = 1; i < argc; i++) {
	    if (argv[i][0] == '-') {
		  for (j = 1; j < strlen(argv[i]); j++)
			switch (argv[i][j]) {
			case '5':
			      big5 = TRUE;
		 	      break; 		
			case 'g':
			case 'G':
			      /* GouBiao encoded  */
			      big5 = FALSE;
			      break;
			case 'n':
			case 'N':
			      autowrap = FALSE;
			      break;
			case 'w':
			case 'W':
			      eightypl = FALSE;
			      break;
			case 'd':
			case 'D':
			      doubleline = TRUE;
			      break;
			case 'h':
			      HZon = !HZon;
			      break;
			case 'z': case 'Z':
			      zWon = !zWon;
			      break;
			case 'H':
			      highfont = TRUE;
			      break;
			case 'b':
			case 'B':
			      bitmapfont = TRUE;
			      break;
			case 'f':
			case 'F':
			      interactive = FALSE;
			      break;
			case 't':
			case 'T':
			      traditional = TRUE;
			      bitmapfont = TRUE;
			      break;
			case 'k':
			case 'K':
			      genuine4010 = TRUE;
			      break;
			default:
			      fprintf(stderr, "Invalid flag = %c\n", argv[i][j]);
			}
	    } else if (!Hfile) {
		  strcpy(filename, argv[i]);
		  if ((Hfile = open(filename, O_RDONLY)) < 0) {
			fprintf(stderr, "Can't open file %s\n", filename);
			exit(-1);
		  }
	    } else
		  fprintf(stderr, "Extra argument = %s\n", argv[i]);
      }

      termname = getenv("TERM");/* use doubleline with Xterms  */
      if (strncmp(termname, "xterm", 5) == 0)
	    doubleline = TRUE;
      else if(strncmp(termname, "tek", 3)==0)
	genuine4010 = TRUE;

      /* no vector font available for big5 (?) */
      if (big5) {
	    bitmapfont = TRUE;
	    HZon = zWon = FALSE;
	    outchar = outcharB;
	    if (!(cclibfile = getenv("CHINESE16")))
		  cclibfile = CHINESE16;
      } else if (bitmapfont) {
	    outchar = outcharB;
	    if (!(cclibfile = getenv( traditional ? "CCLIB16f": "CCLIB16")))
		  cclibfile = traditional ? CCLIB16f : CCLIB16;
      } else {
	    outchar = outcharV;
	    if (!(cclibfile = getenv("CCLIBv")))
		  cclibfile = CCLIBv;
      }
      if ((Hcclib = open(cclibfile, O_RDONLY)) < 0) {
	    fprintf(stderr, "Can't open chinese font file %s\n", cclibfile);
	    exit(-1);
      }
      cheight = highfont ? HiCheight : Cheight;
      lfheight = highfont ? HiLFheight : LFheight;
      if (Hfile)
	    fputs("\nChiRK 1.2a  by Bo Yang,  (c)1992\n\n", stderr);
      if (interactive)
	    tekinit();
      atexit(interrupt);
      tekccview(Hfile, Hcclib);
      if (interactive)
	    tekover();
}
#endif
