.TH CHIRK 1   "October 20, 1992" "Bo Yang"
.PD
.ad b
.SH NAME
\fIChiRK\fP \- A Terminal Chinese Viewer

.SH SYNOPSIS
\fBchirk\fR
[\|\fB-5ghztknbwHdf\fR \|] [\|\fIfilename\fR\|]

.SH DESCRIPTION

.PP


\fIChiRK\fP stands for "CHInese Reader on teKtronics compatible graphics 
terminals".  It's a UNIX based program for displaying GouBiao (GB) or BIG5 
encoded Chinese Characters in both 8bit(raw) or 7bit(HZ or zW encoding)
on terminals capable of emulating Tektronics 401x graphics. Those 
are the most common types of graphics terminals around.

When reading GuoBiao encoded Chinese characters, you have the option of
choosing a vector font (cclib.v), which works faster, or a bitmap font 
(cclib.16), which may look nicer on some of the terminals, or a traditional
(FanTi) bitmap font (cclibf.16).  Only a bitmap font (chinese.16) is available 
for displaying BIG5 encoded Chinese characters.
The default screen will display 40 Chinese characters, or 80 Roman
letters per line, and 18 lines each screen. With proper command line options,
you could choose 30 characters per line to make the bitmap font looks nicer,
or 12 line per screen to have a clearer view on some low resolution terminals.

\fIChiRK 1.0, 1.1, 1.1a, 1.2a\fP are copyrighted. Please read the copyright 
notice below.

.SH USAGE

If your cclib files are at the different places from that defined in Makefile,
you have to set the environmental variables CCLIBv and CCLIB16
to the full path name of your font files( only those you need), like:

     % setenv CCLIBv /u/grads/zhan1san1/cclib/cclib.v
     % setenv CCLIB16 /usr/local/lib/cclib/cclib.16
     % setenv CCLIB16a /usr/local/lib/cclib/cclibf.16
     % setenv CHINESE16 /usr/local/lib/cclib/chinese.16

\fIChiRK\fP takes one command line argument, the filename. Otherwise it assumes
the standard input. Type:

        % chirk -bw cmd9202b.gb         , or
        % cat cmd9202b.gb | chirk 

You could use it as a filter with flag -f. One nice thing about this is
that you could get the Postscript file printed if you have a Tek to PS filter
installed:

        % chirk -f -5 poem1.big5 | ps4014 > peom1.ps 

After first page being displayed, type <space> or <return> or \fIf\fP or 
\fIF\fP key to read the next page. Use \fIb\fP or \fIB\fP to page back. You
could also do something like \fI3f\fP or \fI12B\fP to skip pages. Type
\fIq\fP or \fIQ\fP will get you out of the program.

.SH OPTIONS
.TP 8
.B \-5
Display BIG5 encoded Chinese characters. You need this only when GuoBiao
encoding was chosen as the default at compiling time.
.TP 8
.B \-g
Display GuoBiao encoded Chinese characters. You need this only when BIG5
encoding was chosen as the default at compiling time.
.TP 8
.B \-h
Toggle HZ encoding on/off. HZ encoding can be choosen to be active or non-active
at compiling time.
.TP 8 
.B \-z
Toggle zW encoding on/off. HZ encoding can be choosen to be active or non-active
at compiling time.
.TP 8
.B \-k
Use with real Tektronics 4010/4014. A 1-2 seconds pause is added after erasing
the screen.
.TP 8
.B \-n
No autowrap. auto-wrap is set with the default, this flag put it off.
warning: some of the GB files ( like HuaXiaWenZhai) contains lines so
long that you only see the first line of each paragraph.
.TP 8
.B \-b
bitmap font. ChiRK works slower with bitmap fonts.
.TP 8
.B \-t
traditional bitmap font, use with GB encoded text.
.TP 8
.B \-w
wide font. With default settings, the original 16*16 bitmap font was
squeezed to 12*16 to fit 40 characters per line. Use this flag to get
original font displayed, but with only 30 characters per line.
.TP 8
.B \-H
high font. On some low resolution( 240 lines vertically) terminals
like DEC VT240, you might want a longer( higher) font to see the 
text clearly. This will reduce the default 18 lines per screen to
12 lines p.s.
.TP 8
.B \-d
Double line. On high resolution( up to 782 lines vertically)terminals
like original Tektronics 401x or xterm, this makes all the horizontal
scan lines be used so that the characters look solid. Useful only
with bitmap font and is automatically set when working on xterm.
.TP 8
.B \-f
Filter mode. This skips the interactive keyboard page control.

.SH "SEE ALSO..."
.br
ps4014(1)  \fIor\fP  tek2ps(1)

.SH COPYRIGHT
\fIChiRK 1.0, 1.1, 1.1a, 1.2, 1.2a\fP Copyright 1992 by Bo Yang.


\fIChiRK 1.2a\fP program may be freely used and/or modified, 
with the following provisions:
        1. This notice and the above copyright notice must remain intact.
        2. Neither this program, nor any modification of it,
          may be sold for profit without written consent of the author.

\fIChiRK 1.2a\fP is provided "as is" without any expressed or implied warranty.

 
The font files cclib.v and cclibf.16 are copyrighted by Zhi Biao Wu, translated
from \fIcc2tex-1.2a\fP package( originally elib.65 and cclibf.16).  THE FONT 
FILES cclib.v and cclibf.16 
ARE RESTRICTED ONLY FOR RESEARCH AND ACADEMIC USE. ANY COMMERCIAL USE 
IS STRICTLY PROHIBITED.

.SH AUTHOR
Bo Yang  ( eric@coeus.ucsd.edu )
.br
Department of Physics, 0319
.br
University of California, San Diego
.br
La Jolla, CA 92037






