/******************************************************************************
 *
 * VMS NEWS (part CMDCONF)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * Internal COMMAND file (CONFIGURATION FILES)
 * ----------------------------------------------------------------------------
 * display_config(int num)
 * display_default(int num)
 * insert_fkey(int num,char *txt,bool mode)
 * add_default(int num,char *txt,bool temp)
 * write_default(int num,FILE *fd)
 * add_config(int num,char *txt,bool temp)
 * write_config(int num,FILE *fd)
 * read_configuration()
 * write_configuration()
 * cmd_set_profile()
 * cmd_show_profile()
 * cmd_show_default()
 *
 ******************************************************************************/

#module CMDCONF "CMD V1.24"
#include "header.h"

/******************************************************************************/

display_config(num)
int num;
{
  int i;
  char *t,tmp[256],mask[256],attr;

  switch (num) {
    case NEWS_NUM_ADDRESS:	t="Internet addr:";	break;
    case NEWS_NUM_SERVER:	t="NEWS server:";	break;
    case NEWS_NUM_PORT:		t="NEWS port:";		break;
    case NEWS_NUM_ORGANISATION:	t="Organization:";	break;
    case NEWS_NUM_TIMEZONE:	t="Timezone:";		break;
    case NEWS_NUM_DISTRIBUTION:	t="Distributions:";	break;
    case NEWS_NUM_EDITOR:	t="Default editor:";	break;
    case NEWS_NUM_PERSONAL_NAME:t="Personal name:";	break;
    case NEWS_NUM_USERNAME:	t="Username:";		break;
    case NEWS_NUM_SIGNATURE:	t="Signature file:";	break;
    case NEWS_NUM_MARKER:	t="REPLY marker:";	break;
    case NEWS_NUM_HEADERDISPLAY:t="Article header:";	break;
    case NEWS_NUM_NEWSENTRY:	t="NEWS entry cmd:";	break;
    case NEWS_NUM_GROUPENTRY:	t="Group entry cmd:";	break;
    case NEWS_NUM_SORTGROUP:	t="Group sorted:";	break;
    case NEWS_NUM_GROUPAUTHORS:	t="Article authors:";	break;
    case NEWS_NUM_GROUPLINES:	t="Article lines:";	break;
    case NEWS_NUM_GROUPDATE:	t="Article date:";	break;
    case NEWS_NUM_DUMPTERM:	t="VT graphics dis.:";	break;
    case NEWS_NUM_MAILER:	t="MAIL Transport:";	break;
    case NEWS_NUM_BROADCASTS:	t="Broadcasts:";	break;
    case NEWS_NUM_AUTOSAVE:	t="Update news.rc:";	break;
    case NEWS_NUM_PRINT:	t="Default Printer:";	break;
    case NEWS_NUM_CLOCK:	t="Display Clock:";	break;
    case NEWS_NUM_GROUPMODE:	t="Group entry mode:";	break;
    case NEWS_NUM_KILLFILE:	t="Kill-file usage:";	break;
  }
  switch (conf[num].mode) {
    case NEWS_MODE_NOVALUE:
      sprintf(tmp,"%-18s<none>",t);
      put_text(text_id,tmp,0,0,TRUE);
      break;
    case NEWS_MODE_DEFAULT:
      sprintf(tmp,"%-18s%s",t,conf[num].text);
      put_text(text_id,tmp,0,0,TRUE);
      break;
    case NEWS_MODE_USER:
    case NEWS_MODE_TEMPORARY:
      attr=(conf[num].mode==NEWS_MODE_TEMPORARY)?SMG$M_BLINK:SMG$M_BOLD;
      sprintf(tmp,"%-18s%s",t,(conf[num].text[0])?conf[num].text:"<none>");
      if (conf[NEWS_NUM_DUMPTERM].value) {
        attr=SMG$M_NOATTR;
        strcat(tmp,conf[num].mode==NEWS_MODE_TEMPORARY?" [temp]":" [user]");
      }
      for (i=0;i<strlen(tmp);i++) mask[i]=(i>=18)?attr:SMG$M_NOATTR;
      mask[strlen(tmp)]='\0';
      put_multi(text_id,tmp,mask,0,TRUE);
      break;
  }
}

/*----------------------------------------------------------------------------*/

display_default(num)
int num;
{
  int i;
  char *t,tmp[256],mask[256],attr;

  switch (num) {
    case DEFAULT_NUM_NEWSGROUPS:	t="Newsgroups:";	break;
    case DEFAULT_NUM_SUBJECT:		t="Subject:";		break;
    case DEFAULT_NUM_DISTRIBUTION:	t="Distribution:";	break;
    case DEFAULT_NUM_REPLY_TO:		t="Reply Address:";	break;
    case DEFAULT_NUM_FOLLOWUP_TO:	t="Followup Newsgroup:";break;
    case DEFAULT_NUM_SUMMARY:		t="Summary:";		break;
    case DEFAULT_NUM_KEYWORDS:		t="Keywords:";		break;
    case DEFAULT_NUM_EXPIRE:		t="Expire:";		break;
    case DEFAULT_NUM_CONTROL:		t="Control:";		break;
    case DEFAULT_NUM_APPROVED:		t="Approved Address:";	break;
    case DEFAULT_NUM_USER_NAME_1:	t="User header 1:";	break;
    case DEFAULT_NUM_USER_TEXT_1:	t="User text 1:";	break;
    case DEFAULT_NUM_USER_NAME_2:	t="User header 2:";	break;
    case DEFAULT_NUM_USER_TEXT_2:	t="User text 2:";	break;
  }
  switch (userdefault[num].mode) {
    case NEWS_MODE_NOVALUE:
      sprintf(tmp,"%-20s<none>",t);
      put_text(text_id,tmp,0,0,TRUE);
      break;
    case NEWS_MODE_DEFAULT:
      sprintf(tmp,"%-20s%s",t,userdefault[num].text);
      put_text(text_id,tmp,0,0,TRUE);
      break;
    case NEWS_MODE_USER:
    case NEWS_MODE_TEMPORARY:
      attr=(userdefault[num].mode==NEWS_MODE_TEMPORARY)?SMG$M_BLINK:SMG$M_BOLD;
      sprintf(tmp,"%-20s%s",t,(userdefault[num].text[0])?userdefault[num].text:"<none>");
      if (conf[NEWS_NUM_DUMPTERM].value) {
        attr=SMG$M_NOATTR;
        strcat(tmp,userdefault[num].mode==NEWS_MODE_TEMPORARY?" [temp]":" [user]");
      }
      for (i=0;i<strlen(tmp);i++) mask[i]=(i>=20)?attr:SMG$M_NOATTR;
      mask[strlen(tmp)]='\0';
      put_multi(text_id,tmp,mask,0,TRUE);
      break;
  }
}

/*----------------------------------------------------------------------------*/

insert_fkey(num,txt,mode)
int num;
char *txt;
bool mode;
{
  char *tp,*tp2;

  tp=tp2=txt+1; while (*tp && *tp!='"') tp++; *tp++ ='\0';
  strcpy(fkeys[num].command,tp2);
  while (*tp && *tp!='"') tp++; tp2= ++tp;
  while (*tp && *tp!='"') tp++; *tp='\0';
  strcpy(fkeys[num].helptext,tp2);
  fkeys[num].mode=mode;
}

/*----------------------------------------------------------------------------*/

add_default(num,txt,mode)
int num;
char *txt;
bool mode;
{
  if (*txt=='"') { *(txt+strlen(txt)-1)='\0'; txt++; }
  strcpy(userdefault[num].text,txt);
  if (mode!=NEWS_MODE_TEMPORARY) strcpy(userdefault[num].orig,txt);
  userdefault[num].mode=mode;
}

/*----------------------------------------------------------------------------*/

write_default(num,fd)
int num;
FILE *fd;
{
  char *t,txt[256];

  switch (num) {
    case DEFAULT_NUM_NEWSGROUPS:	t=DEFAULT_CNF_NEWSGROUPS;	break;
    case DEFAULT_NUM_SUBJECT:		t=DEFAULT_CNF_SUBJECT;		break;
    case DEFAULT_NUM_DISTRIBUTION:	t=DEFAULT_CNF_DISTRIBUTION;	break;
    case DEFAULT_NUM_REPLY_TO:		t=DEFAULT_CNF_REPLY_TO;		break;
    case DEFAULT_NUM_FOLLOWUP_TO:	t=DEFAULT_CNF_FOLLOWUP_TO;	break;
    case DEFAULT_NUM_SUMMARY:		t=DEFAULT_CNF_SUMMARY;		break;
    case DEFAULT_NUM_KEYWORDS:		t=DEFAULT_CNF_KEYWORDS;		break;
    case DEFAULT_NUM_EXPIRE:		t=DEFAULT_CNF_EXPIRE;		break;
    case DEFAULT_NUM_CONTROL:		t=DEFAULT_CNF_CONTROL;		break;
    case DEFAULT_NUM_APPROVED:		t=DEFAULT_CNF_APPROVED;		break;
    case DEFAULT_NUM_USER_NAME_1:	t=DEFAULT_CNF_USER_NAME_1;	break;
    case DEFAULT_NUM_USER_TEXT_1:	t=DEFAULT_CNF_USER_TEXT_1;	break;
    case DEFAULT_NUM_USER_NAME_2:	t=DEFAULT_CNF_USER_NAME_2;	break;
    case DEFAULT_NUM_USER_TEXT_2:	t=DEFAULT_CNF_USER_TEXT_2;	break;
  }
  if (userdefault[num].mode==NEWS_MODE_USER) fprintf(fd,"DEFAULT_%s: %s\n",t,userdefault[num].orig);
}

/*----------------------------------------------------------------------------*/

add_config(num,txt,mode)
int num;
char *txt;
bool mode;
{
  int i;

  if (*txt=='"') { *(txt+strlen(txt)-1)='\0'; txt++; }
  strcpy(conf[num].text,txt);
  if (mode!=NEWS_MODE_TEMPORARY) strcpy(conf[num].orig,txt);
  if ((i=atoi(txt))>0) conf[num].value=i;
  if (num==NEWS_NUM_AUTOSAVE) {
    if (!strcmp(txt,"ON_EXIT")) conf[num].value=0;
    if (!strcmp(txt,"PERIODIC")) conf[num].value=1;
  }
  if (num==NEWS_NUM_BROADCASTS) {
    if (!strcmp(txt,"DISABLED")) conf[num].value=0;
    if (!strcmp(txt,"VISIBLE")) conf[num].value=1;
  }
  if (num==NEWS_NUM_HEADERDISPLAY) {
    if (!strcmp(txt,"SHORT")) conf[num].value=0;
    if (!strcmp(txt,"FULL")) conf[num].value=1;
  }
  if (num==NEWS_NUM_CLOCK    || num==NEWS_NUM_GROUPLINES ||
      num==NEWS_NUM_KILLFILE || num==NEWS_NUM_GROUPDATE  ||
      num==NEWS_NUM_DUMPTERM) {
    if (!strcmp(txt,"NO")) conf[num].value=0;
    if (!strcmp(txt,"YES")) conf[num].value=1;
  }
  if (num==NEWS_NUM_GROUPAUTHORS) {
    if (!strcmp(txt,"NO")) conf[num].value=0;
    if (!strcmp(txt,"YES")) conf[num].value=1;
    if (!strcmp(txt,"FULL")) conf[num].value=2;
  }
  if (num==NEWS_NUM_SORTGROUP) {
    if (!strcmp(txt,"NUMBER")) conf[num].value=0;
    if (!strcmp(txt,"SUBJECT")) conf[num].value=1;
    if (!strcmp(txt,"THREAD")) conf[num].value=2;
  }
  if (num==NEWS_NUM_NEWSENTRY) {
    if (!strcmp(txt,"UNREAD/USED")) conf[num].value=7;
    if (!strcmp(txt,"UNREAD")) conf[num].value=6;
    if (!strcmp(txt,"REGISTERED/USED")) conf[num].value=3;
    if (!strcmp(txt,"REGISTERED")) conf[num].value=2;
    if (!strcmp(txt,"USED")) conf[num].value=1;
    if (!strcmp(txt,"ALL")) conf[num].value=0;
  }
  if (num==NEWS_NUM_GROUPENTRY) {
    if (!strcmp(txt,"TOP/READ")) conf[num].value=3;
    if (!strcmp(txt,"TOP")) conf[num].value=2;
    if (!strcmp(txt,"BOTTOM/READ")) conf[num].value=1;
    if (!strcmp(txt,"BOTTOM")) conf[num].value=0;
  }
  if (num==NEWS_NUM_GROUPMODE) {
    if (!strcmp(txt,"ALL")) conf[num].value=0;
    if (!strcmp(txt,"NEW")) conf[num].value=1;
  }
  conf[num].mode=mode;
}

/*----------------------------------------------------------------------------*/

write_config(num,fd)
int num;
FILE *fd;
{
  char *t,txt[256];

  switch (num) {
    case NEWS_NUM_EDITOR:	t=NEWS_CNF_EDITOR;		break;
    case NEWS_NUM_MARKER:	t=NEWS_CNF_MARKER;		break;
    case NEWS_NUM_SIGNATURE:	t=NEWS_CNF_SIGNATURE;		break;
    case NEWS_NUM_ORGANISATION:	t=NEWS_CNF_ORGANISATION;	break;
    case NEWS_NUM_PERSONAL_NAME:t=NEWS_CNF_PERSONAL_NAME;	break;
    case NEWS_NUM_HEADERDISPLAY:t=NEWS_CNF_HEADERDISPLAY;	break;
    case NEWS_NUM_NEWSENTRY:	t=NEWS_CNF_NEWSENTRY;		break;
    case NEWS_NUM_GROUPENTRY:	t=NEWS_CNF_GROUPENTRY;		break;
    case NEWS_NUM_SORTGROUP:	t=NEWS_CNF_SORTGROUP;		break;
    case NEWS_NUM_GROUPLINES:	t=NEWS_CNF_GROUPLINES;		break;
    case NEWS_NUM_GROUPDATE:	t=NEWS_CNF_GROUPDATE;		break;
    case NEWS_NUM_DUMPTERM:	t=NEWS_CNF_DUMPTERM;		break;
    case NEWS_NUM_GROUPAUTHORS:	t=NEWS_CNF_GROUPAUTHORS;	break;
    case NEWS_NUM_GROUPMODE:	t=NEWS_CNF_GROUPMODE;		break;
    case NEWS_NUM_BROADCASTS:	t=NEWS_CNF_BROADCASTS;		break;
    case NEWS_NUM_AUTOSAVE:	t=NEWS_CNF_AUTOSAVE;		break;
    case NEWS_NUM_PRINT:	t=NEWS_CNF_PRINT;		break;
    case NEWS_NUM_CLOCK:	t=NEWS_CNF_CLOCK;		break;
    case NEWS_NUM_KILLFILE:	t=NEWS_CNF_KILLFILE;		break;
  }
  if (conf[num].mode==NEWS_MODE_USER) fprintf(fd,"%s: %s\n",t,conf[num].orig);
}

/*----------------------------------------------------------------------------*/

read_configuration()
{
  char image[256],filename[256],*ptr,tmp[256];
  FILE *fd;
  bool vflag=FALSE;
  int i;
  globalvalue int NEWS$_NOCNF,NEWS$_OLDCNF,NEWS$_CNFTXT,NEWS$_CNFKEY;

  for (i=0;i<NEWS_MAX_CONFIG;i++) {
    conf[i].text[0]='\0';
    conf[i].value=0;
    conf[i].mode=NEWS_MODE_NOVALUE;
  }
  for (i=0;i<DEFAULT_MAX_CONFIG;i++) {
    userdefault[i].text[0]='\0';
    userdefault[i].value=0;
    userdefault[i].mode=NEWS_MODE_NOVALUE;
  }
  for (i=0;i<34;i++) fkeys[i].mode=NEWS_MODE_NOVALUE;
  strcpy(image,get_path());
  sprintf(filename,"%sNEWS_CONFIG.DAT",image);
  if (fd=fopen(filename,"r")) {
    while (fgets(tmp,255,fd)) {
      ptr=tmp; while (*ptr) if (*ptr=='\n' || *ptr=='\r') *ptr='\0'; else ptr++;
      if (*tmp!='!') {
        ptr=tmp; while (*ptr && *ptr!=':') ptr++; *ptr++ ='\0';
        while (*ptr && (*ptr==' ' || *ptr=='\t')) ptr++;
        if (!strcmp(tmp,NEWS_CNF_ADDRESS)) add_config(NEWS_NUM_ADDRESS,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_SERVER)) add_config(NEWS_NUM_SERVER,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_PORT)) add_config(NEWS_NUM_PORT,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_ORGANISATION)) add_config(NEWS_NUM_ORGANISATION,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_TIMEZONE)) add_config(NEWS_NUM_TIMEZONE,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_MAILER)) add_config(NEWS_NUM_MAILER,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_DISTRIBUTION)) add_config(NEWS_NUM_DISTRIBUTION,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_EDITOR)) add_config(NEWS_NUM_EDITOR,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_MARKER)) add_config(NEWS_NUM_MARKER,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_HEADERDISPLAY)) add_config(NEWS_NUM_HEADERDISPLAY,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_GROUPAUTHORS)) add_config(NEWS_NUM_GROUPAUTHORS,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_GROUPLINES)) add_config(NEWS_NUM_GROUPLINES,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_GROUPDATE)) add_config(NEWS_NUM_GROUPDATE,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_DUMPTERM)) add_config(NEWS_NUM_DUMPTERM,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_NEWSENTRY)) add_config(NEWS_NUM_NEWSENTRY,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_GROUPENTRY)) add_config(NEWS_NUM_GROUPENTRY,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_GROUPMODE)) add_config(NEWS_NUM_GROUPMODE,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_SORTGROUP)) add_config(NEWS_NUM_SORTGROUP,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_BROADCASTS)) add_config(NEWS_NUM_BROADCASTS,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_AUTOSAVE)) add_config(NEWS_NUM_AUTOSAVE,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_PRINT)) add_config(NEWS_NUM_PRINT,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_CLOCK)) add_config(NEWS_NUM_CLOCK,ptr,NEWS_MODE_DEFAULT);
        if (!strcmp(tmp,NEWS_CNF_KILLFILE)) add_config(NEWS_NUM_KILLFILE,ptr,NEWS_MODE_DEFAULT);
        if (!strncmp(tmp,"KEY_",4)) for (i=0;i<34;i++)
          if (!strcmp(&tmp[4],fkeys[i].key)) insert_fkey(i,ptr,NEWS_MODE_DEFAULT);
      } else if (!strncmp("![end of file",tmp,13)) {
        if ((ptr=strchr(tmp,')'))!=NULL) *ptr='\0';
        ptr=strchr(tmp,'('); if (ptr!=NULL) { ptr++; vflag= !strcmp(ptr,VERSION); }
      }
    }
  } else { geterror(-1,NEWS$_NOCNF); sys$exit(SS$_NORMAL); }
  fclose(fd);
  add_config(NEWS_NUM_USERNAME,getenv("USER"),NEWS_MODE_DEFAULT);
  add_config(NEWS_NUM_PERSONAL_NAME,get_uaf_entry(),NEWS_MODE_DEFAULT);
  strcpy(filename,get_conf());
  if (fd=fopen(filename,"r")) {
    while (fgets(tmp,255,fd)) {
      ptr=tmp; while (*ptr) if (*ptr=='\n' || *ptr=='\r') *ptr='\0'; else ptr++;
      if (*tmp!='!') {
        ptr=tmp; while (*ptr && *ptr!=':') ptr++; *ptr++ ='\0';
        while (*ptr && (*ptr==' ' || *ptr=='\t')) ptr++;
        if (!strcmp(tmp,NEWS_CNF_EDITOR)) add_config(NEWS_NUM_EDITOR,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_MARKER)) add_config(NEWS_NUM_MARKER,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_ORGANISATION)) add_config(NEWS_NUM_ORGANISATION,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_PERSONAL_NAME)) add_config(NEWS_NUM_PERSONAL_NAME,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_SIGNATURE)) add_config(NEWS_NUM_SIGNATURE,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_HEADERDISPLAY)) add_config(NEWS_NUM_HEADERDISPLAY,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_NEWSENTRY)) add_config(NEWS_NUM_NEWSENTRY,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_GROUPENTRY)) add_config(NEWS_NUM_GROUPENTRY,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_GROUPMODE)) add_config(NEWS_NUM_GROUPMODE,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_GROUPAUTHORS)) add_config(NEWS_NUM_GROUPAUTHORS,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_GROUPLINES)) add_config(NEWS_NUM_GROUPLINES,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_GROUPDATE)) add_config(NEWS_NUM_GROUPDATE,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_DUMPTERM)) add_config(NEWS_NUM_DUMPTERM,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_SORTGROUP)) add_config(NEWS_NUM_SORTGROUP,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_BROADCASTS)) add_config(NEWS_NUM_BROADCASTS,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_AUTOSAVE)) add_config(NEWS_NUM_AUTOSAVE,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_PRINT)) add_config(NEWS_NUM_PRINT,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_CLOCK)) add_config(NEWS_NUM_CLOCK,ptr,NEWS_MODE_USER);
        if (!strcmp(tmp,NEWS_CNF_KILLFILE)) add_config(NEWS_NUM_KILLFILE,ptr,NEWS_MODE_USER);
        if (!strncmp(tmp,"KEY_",4)) for (i=0;i<34;i++)
          if (!strcmp(&tmp[4],fkeys[i].key)) insert_fkey(i,ptr,NEWS_MODE_USER);
        if (!strncmp(tmp,"DEFAULT_",8)) {
          if (!strcmp(&tmp[8],DEFAULT_CNF_NEWSGROUPS)) add_default(DEFAULT_NUM_NEWSGROUPS,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_SUBJECT)) add_default(DEFAULT_NUM_SUBJECT,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_DISTRIBUTION)) add_default(DEFAULT_NUM_DISTRIBUTION,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_REPLY_TO)) add_default(DEFAULT_NUM_REPLY_TO,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_FOLLOWUP_TO)) add_default(DEFAULT_NUM_FOLLOWUP_TO,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_SUMMARY)) add_default(DEFAULT_NUM_SUMMARY,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_KEYWORDS)) add_default(DEFAULT_NUM_KEYWORDS,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_EXPIRE)) add_default(DEFAULT_NUM_EXPIRE,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_CONTROL)) add_default(DEFAULT_NUM_CONTROL,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_APPROVED)) add_default(DEFAULT_NUM_APPROVED,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_USER_NAME_1)) add_default(DEFAULT_NUM_USER_NAME_1,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_USER_TEXT_1)) add_default(DEFAULT_NUM_USER_TEXT_1,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_USER_NAME_2)) add_default(DEFAULT_NUM_USER_NAME_2,ptr,NEWS_MODE_USER);
          if (!strcmp(&tmp[8],DEFAULT_CNF_USER_TEXT_2)) add_default(DEFAULT_NUM_USER_TEXT_2,ptr,NEWS_MODE_USER);
        }
      }
    }
  }
  fclose(fd);
  if (!vflag) { strcpy(fao,c$asc(VERSION)); geterror(-1,NEWS$_OLDCNF,fao); sys$exit(SS$_NORMAL); }
  for (i=0;i<NEWS_MAX_CONFIG;i++)
    if (conf[i].mode==NEWS_MODE_NOVALUE && i!=NEWS_NUM_SIGNATURE) {
      geterror(-1,NEWS$_CNFTXT,i); strcpy(fao,c$asc(VERSION)); geterror(-1,NEWS$_OLDCNF,fao);
      sys$exit(SS$_NORMAL);
    }
  for (i=0;i<34;i++)
    if (fkeys[i].mode==NEWS_MODE_NOVALUE) {
      strcpy(fao,c$asc(fkeys[i].key)); geterror(-1,NEWS$_CNFKEY,fao);
      strcpy(fao,c$asc(VERSION)); geterror(-1,NEWS$_OLDCNF,fao);
      sys$exit(SS$_NORMAL);
    }
  if (!strncmp(conf[NEWS_NUM_ADDRESS].text,"$NODE.",6)) {
    ptr=conf[NEWS_NUM_ADDRESS].text+5;
    strcpy(tmp,get_local_hostname(TRUE));
    strcat(tmp,ptr);
    add_config(NEWS_NUM_ADDRESS,tmp,NEWS_MODE_DEFAULT);
  }
  if (!strncmp(conf[NEWS_NUM_ADDRESS].text,"$LOGICAL",8)) {
    ptr=conf[NEWS_NUM_ADDRESS].text+8;
    strcpy(tmp,getenv("NNTP_LOCALHOST"));
    strcat(tmp,ptr);
    add_config(NEWS_NUM_ADDRESS,tmp,NEWS_MODE_DEFAULT);
  }
}

/*----------------------------------------------------------------------------*/

write_configuration()
{
  FILE *fd;
  char txt[256];
  bool flag=FALSE;
  int i;

  strcpy(txt,get_conf());
  delete(txt);
  if (fd=fopen(txt,"w+")) {
    fprintf(fd,"!===============================================\n");
    fprintf(fd,"! Private VMS NEWS configuration file\n");
    fprintf(fd,"!===============================================\n");
    fprintf(fd,"!\n");
    write_config(NEWS_NUM_PERSONAL_NAME,fd);
    write_config(NEWS_NUM_ORGANISATION,fd);
    write_config(NEWS_NUM_SIGNATURE,fd);
    write_config(NEWS_NUM_EDITOR,fd);
    write_config(NEWS_NUM_CLOCK,fd);
    write_config(NEWS_NUM_MARKER,fd);
    write_config(NEWS_NUM_HEADERDISPLAY,fd);
    write_config(NEWS_NUM_NEWSENTRY,fd);
    write_config(NEWS_NUM_GROUPENTRY,fd);
    write_config(NEWS_NUM_GROUPMODE,fd);
    write_config(NEWS_NUM_GROUPLINES,fd);
    write_config(NEWS_NUM_GROUPDATE,fd);
    write_config(NEWS_NUM_GROUPAUTHORS,fd);
    write_config(NEWS_NUM_DUMPTERM,fd);
    write_config(NEWS_NUM_SORTGROUP,fd);
    write_config(NEWS_NUM_BROADCASTS,fd);
    write_config(NEWS_NUM_PRINT,fd);
    write_config(NEWS_NUM_AUTOSAVE,fd);
    write_config(NEWS_NUM_KILLFILE,fd);
    fprintf(fd,"!\n");
    for (i=0;i<34;i++) if (fkeys[i].mode==NEWS_MODE_USER) {
      flag=TRUE;
      fprintf(fd,"KEY_%s: \"%s\" \"%s\"\n",fkeys[i].key,fkeys[i].command,fkeys[i].helptext);
    }
    if (flag) fprintf(fd,"!\n");
    write_default(DEFAULT_NUM_NEWSGROUPS,fd);
    write_default(DEFAULT_NUM_SUBJECT,fd);
    write_default(DEFAULT_NUM_DISTRIBUTION,fd);
    write_default(DEFAULT_NUM_REPLY_TO,fd);
    write_default(DEFAULT_NUM_FOLLOWUP_TO,fd);
    write_default(DEFAULT_NUM_SUMMARY,fd);
    write_default(DEFAULT_NUM_KEYWORDS,fd);
    write_default(DEFAULT_NUM_EXPIRE,fd);
    write_default(DEFAULT_NUM_CONTROL,fd);
    write_default(DEFAULT_NUM_APPROVED,fd);
    write_default(DEFAULT_NUM_USER_NAME_1,fd);
    write_default(DEFAULT_NUM_USER_TEXT_1,fd);
    write_default(DEFAULT_NUM_USER_NAME_2,fd);
    write_default(DEFAULT_NUM_USER_TEXT_2,fd);
  }
  fclose(fd);
}

/*----------------------------------------------------------------------------*/

cmd_set_profile()
{
  bool flag=FALSE,temp=FALSE;
  char result[256];
  uword retlen;
  globalvalue int NEWS$_IVEDTLSE,NEWS$_IVEDTTPU,NEWS$_IVMRKR,NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  temp=(cli$present(c$dsc("TEMPORARY"))==CLI$_PRESENT);
  if (cli$present(c$dsc("EDITOR"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("EDITOR"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    if (*result!='@'
        && strcmp("TECO",result) && strcmp("EDT",result) && strcmp("TPU",result)
#ifdef LSE
        && strcmp("LSE",result)) geterror(fac,NEWS$_IVEDTLSE);
#else
        ) geterror(fac,NEWS$_IVEDTTPU);
#endif
    else { add_config(NEWS_NUM_EDITOR,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE; }
  }
  if (cli$present(c$dsc("ORGANISATION"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_ORGANISATION,"",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE; }
  if (cli$present(c$dsc("ORGANISATION"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("ORGANISATION"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    add_config(NEWS_NUM_ORGANISATION,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("PERSONAL_NAME"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_PERSONAL_NAME,"",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("PERSONAL_NAME"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("PERSONAL_NAME"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    add_config(NEWS_NUM_PERSONAL_NAME,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("SIGNATURE"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_SIGNATURE,"",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("SIGNATURE"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("SIGNATURE"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    add_config(NEWS_NUM_SIGNATURE,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("MARKER"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_MARKER,"",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("MARKER"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("MARKER"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    if (strlen(result)<(result[0]=='"'?6:4)) {
      add_config(NEWS_NUM_MARKER,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
    } else geterror(fac,NEWS$_IVMRKR);
  }
  if (cli$present(c$dsc("BROADCASTS"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_BROADCASTS,"DISABLED",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("BROADCASTS"))==CLI$_PRESENT) {
    add_config(NEWS_NUM_BROADCASTS,"VISIBLE",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("AUTOSAVE"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_AUTOSAVE,"ON_EXIT",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("AUTOSAVE"))==CLI$_PRESENT) {
    add_config(NEWS_NUM_AUTOSAVE,"PERIODIC",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("VTTERM"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_DUMPTERM,"YES",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("VTTERM"))==CLI$_PRESENT) {
    add_config(NEWS_NUM_DUMPTERM,"NO",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("CLOCK"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_CLOCK,"NO",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
    if (clock_id) clock_handle(FALSE);
  }
  if (cli$present(c$dsc("CLOCK"))==CLI$_PRESENT) {
    add_config(NEWS_NUM_CLOCK,"YES",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
    if (!clock_id) clock_handle(TRUE);
  }
  if (cli$present(c$dsc("PRINTER"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("PRINTER"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    add_config(NEWS_NUM_PRINT,result,temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("KILLFILE"))==CLI$_NEGATED) {
    add_config(NEWS_NUM_KILLFILE,"NO",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (cli$present(c$dsc("KILLFILE"))==CLI$_PRESENT) {
    add_config(NEWS_NUM_KILLFILE,"YES",temp?NEWS_MODE_TEMPORARY:NEWS_MODE_USER); flag=TRUE;
  }
  if (flag && !temp) write_configuration();
}

/*----------------------------------------------------------------------------*/

cmd_show_profile()
{
  int i;
  uword key=0;
  char txt[256];
  globalvalue int NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  clear_display(text_id);
  strcpy(txt,flag_description());
  show_header(" VMS NEWS v%s - Profile for user %s%s",VERSION,conf[NEWS_NUM_USERNAME].text,txt);
  set_cursor(text_id,2,1);
  i=0; while(disp_order[i]>=0) {
    display_config(disp_order[i]);
    if ((i+1)%(xROWS-7)==0 && disp_order[i+1]>=0) {
      set_cursor(text_id,xROWS-4,1);
      put_text(text_id,"<Press RETURN to continue>",SMG$M_BOLD,0,TRUE);
      while (key!=0xffff) {
        key=read_key(kbd_id,NEWS_PROMPT,input_id);
        switch (key) {
          case SMG$K_TRM_CTRLW:
          case SMG$K_TRM_CTRLL:
            redraw_screen(paste_id); break;
          case SMG$K_TRM_CTRLR:
            cmd_quit(); break;
          case SMG$K_TRM_CTRLZ:
            cmd_exit(); break;
          case SMG$K_TRM_CR:
          case SMG$K_TRM_ENTER:
            key=0xffff; break;
          default:
            break;
        }
      }
      key=0;
      clear_display(text_id);
      set_cursor(text_id,2,1);
    }
    i++;
  }
  set_cursor(text_id,xROWS-4,1);
  put_text(text_id,"<Press RETURN to continue>",SMG$M_BOLD,0,TRUE);
  while (key!=0xffff) {
    key=read_key(kbd_id,NEWS_PROMPT,input_id);
    switch (key) {
      case SMG$K_TRM_CTRLW:
      case SMG$K_TRM_CTRLL:
        redraw_screen(paste_id); break;
      case SMG$K_TRM_CTRLR:
        cmd_quit(); break;
      case SMG$K_TRM_CTRLZ:
        cmd_exit(); break;
      case SMG$K_TRM_CR:
      case SMG$K_TRM_ENTER:
        key=0xffff; break;
      default:
        break;
    }
  }
  switch (internal_mode) {
    case 1: newsgroups_header(TRUE); break;
    case 2: group_header();
            group_redraw(subjectscreen,articlepos,TRUE); break;
    case 3: article_header();
            article_redraw(articlescreen); break;
  }
}

/*----------------------------------------------------------------------------*/

cmd_show_default()
{
  int i;
  uword key=0;
  char txt[256];
  globalvalue int NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  clear_display(text_id);
  strcpy(txt,flag_description());
  show_header(" VMS NEWS v%s - Defaults for user %s%s",VERSION,conf[NEWS_NUM_USERNAME].text,txt);
  set_cursor(text_id,2,1);
  i=0; while(i<DEFAULT_MAX_CONFIG) {
    display_default(i);
    if ((i+1)%(xROWS-7)==0 && i+1<DEFAULT_MAX_CONFIG) {
      set_cursor(text_id,xROWS-4,1);
      put_text(text_id,"<Press RETURN to continue>",SMG$M_BOLD,0,TRUE);
      while (key!=0xffff) {
        key=read_key(kbd_id,NEWS_PROMPT,input_id);
        switch (key) {
          case SMG$K_TRM_CTRLW:
          case SMG$K_TRM_CTRLL:
            redraw_screen(paste_id); break;
          case SMG$K_TRM_CTRLR:
            cmd_quit(); break;
          case SMG$K_TRM_CTRLZ:
            cmd_exit(); break;
          case SMG$K_TRM_CR:
          case SMG$K_TRM_ENTER:
            key=0xffff; break;
          default:
            break;
        }
      }
      key=0;
      clear_display(text_id);
      set_cursor(text_id,2,1);
    }
    i++;
  }
  set_cursor(text_id,xROWS-4,1);
  put_text(text_id,"<Press RETURN to continue>",SMG$M_BOLD,0,TRUE);
  while (key!=0xffff) {
    key=read_key(kbd_id,NEWS_PROMPT,input_id);
    switch (key) {
      case SMG$K_TRM_CTRLW:
      case SMG$K_TRM_CTRLL:
        redraw_screen(paste_id); break;
      case SMG$K_TRM_CTRLR:
        cmd_quit(); break;
      case SMG$K_TRM_CTRLZ:
        cmd_exit(); break;
      case SMG$K_TRM_CR:
      case SMG$K_TRM_ENTER:
        key=0xffff; break;
      default:
        break;
    }
  }
  switch (internal_mode) {
    case 1: newsgroups_header(TRUE); break;
    case 2: group_header();
            group_redraw(subjectscreen,articlepos,TRUE); break;
    case 3: article_header();
            article_redraw(articlescreen); break;
  }
}

/******************************************************************************/
