/******************************************************************************
 *
 * VMS NEWS (part CMDSYS)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * Internal COMMAND file (OS/system dependend calls)
 * ----------------------------------------------------------------------------
 *      char *get_uaf_entry()
 *      char *get_local_hostname(bool flag)
 *            call_editor(char *infile)
 *            send_mail(char *file,char *addr,char *subj,char *cc)
 *            print_file(char *file,char *queue)
 * (optional) write_logging(char *text)
 *            hlp_output(struct dsc$descriptor *out_str)
 *            hlp_input(struct dsc$descriptor *inp_str,*prompt,uword *outlen)
 *            hlp_help(char *filename,char *param)
 *            cmd_help()
 *            cmd_version()
 *            cmd_list()
 *            cmd_kill()
 *            cmd_spawn()
 *            cmd_reply()
 *            cmd_mail()
 *            cmd_print()
 *            cmd_coffee()
 *
 ******************************************************************************/

#module CMDSYS "CMD V1.24"
#include "header.h"
#include <jpidef.h>
#include <dvidef.h>
#include <syidef.h>
#include <prvdef.h>
#include <hlpdef.h>
#include <maildef.h>
#include <uaidef.h>
#define UAI$M_RESTRICTED	8
#define UAI$M_CAPTIVE		65536
#include <jbcmsgdef.h>
#include <sjcdef.h>

globalref int news_table;

/******************************************************************************/

char *get_uaf_entry()
{
  char uaf_owner[40],loc_username[13],t[40],*usrptr,txt[256];
  int i,pos;
  uword retlen;
  ulong cntxt=0,uic,flags,right;
  quad id;
  struct ItemList getuai_itmlist[] = {
      { sizeof(uaf_owner), UAI$_OWNER, &uaf_owner[0], 0 },
      { sizeof(uic),       UAI$_UIC,   &uic,          0 },
      { sizeof(flags),     UAI$_FLAGS, &flags,        0 },
      { 0, 0, 0, 0 }
  };

  usrptr=getenv("USER"); strcpy(loc_username,usrptr);
  for (i=strlen(loc_username);i<12;++i) loc_username[i]=' ';
  loc_username[i]='\0';
  c$cks(sys$getuai(0,0,c$dsc(loc_username),getuai_itmlist,0,0,0));
  uaf_owner[uaf_owner[0]+1]='\0';
  sprintf(t,"%s",&uaf_owner[1]);
  restricted=flags&(UAI$M_RESTRICTED|UAI$M_CAPTIVE);
  newsmgr=FALSE; right=uic;
  id.l1=right; id.l2=0; right=0;
  while (sys$find_held(&id,&right,0,&cntxt)!=SS$_NOSUCHID) {
    c$cks(sys$idtoasc(right,&retlen,c$ldsc(txt,256),0,0,0));
    txt[retlen]='\0';
    if (!strcmp(txt,NEWSMGR_RIGHT)) newsmgr=TRUE;
  }
  sys$finish_rdb(&cntxt);
  return(t);
}

/******************************************************************************/

char *get_local_hostname(flag)
bool flag;
{
  char nodename[16],tmp[32];
  ulong area,number,nodelen;
  struct ItemList getsyi_itmlist[] = {
      { sizeof(nodename), SYI$_NODENAME,    &nodename[0], &nodelen },
      { sizeof(area),     SYI$_NODE_AREA,   &area,        0 },
      { sizeof(number),   SYI$_NODE_NUMBER, &number,      0 },
      { 0, 0, 0, 0 }
  };

  c$cks(sys$getsyi(0,0,0,getsyi_itmlist,0,0,0));
  sprintf(tmp,"%d.%d",area,number);
  if (flag) return(nodename);
  else return(tmp);
}

/******************************************************************************/

#define TPU_QUIT 0x13f2af59
#define TPU_EXIT 0x13f2af01
#define LSE_QUIT 0x13f2af59
#define LSE_EXIT 0x13f2af01

call_editor(infile) /* 2=quit, 1=exit, 0=unknown */
char *infile;
{
  char tpucallstr[100];
  int status;
  long substatus;

  save_smg_contents();
  restore_smg_update();
  clear_pasteboard(paste_id);
  stop_smg_update();
  if (!strcmp(conf[NEWS_NUM_EDITOR].text,"TECO") && !restricted) {
    sprintf(tpucallstr,"%s",infile);
    status=teco$edit(c$dsc(tpucallstr));
    status=0;
  } else if (!strcmp(conf[NEWS_NUM_EDITOR].text,"EDT")) {
    sprintf(tpucallstr,"%s",infile);
    status=edt$edit(c$dsc(tpucallstr),0,0,0,0,0,0,0);
    status=0;
  } else if (!strcmp(conf[NEWS_NUM_EDITOR].text,"TPU")) {
    sprintf(tpucallstr,"TPU %s",infile);
    if ((status=tpu$tpu(c$dsc(tpucallstr)))==TPU_QUIT) status=2;
    else if (status==TPU_EXIT) status=1;
    else status=0;
  } else if (*conf[NEWS_NUM_EDITOR].text=='@' && !restricted) {
    sprintf(tpucallstr,"%s %s",conf[NEWS_NUM_EDITOR].text,infile);
    status=lib$spawn(c$dsc(tpucallstr),0,0,0,0,0,&substatus,0,0,0,c$dsc(NEWS_QUERY),0,0);
    if (status<0 || status>2) status=0;
  } else {
#ifdef LSE
    sprintf(tpucallstr,"LSEDIT %s",infile);
    if ((status=lse$lse(c$dsc(tpucallstr)))==LSE_QUIT) status=2;
    else if (status==LSE_EXIT) status=1;
    else status=0;
#else
    sprintf(tpucallstr,"TPU %s",infile);
    if ((status=tpu$tpu(c$dsc(tpucallstr)))==TPU_QUIT) status=2;
    else if (status==TPU_EXIT) status=1;
    else status=0;
#endif
  }
  restore_smg_contents();
  return(status);
}

/******************************************************************************/

send_mail(file,addr,subj,cc)
char *file,*addr,*subj,*cc;
{
#ifndef NO_MAIL
  int send_context=0,user_context=0,cc_prompt;
  char to_user[256],cc_user[256],filename[256],subject[256],tmp[256],
  t1[256],t2[256];
  long to_user_len=0,cc_user_len=0,filename_len=0,subject_len=0;
  uword to_type=MAIL$_TO;
  char enbflg=1,*al,*dp;
  quad prv={PRV$M_SYSPRV,0};
  ulong sysprv_flag=SS$_NOTALLPRIV,status;
  extern establish();
  struct ItemList
    nulllist[]={ {0,0,0,0} },
    address_itm[]={ {sizeof(to_user),MAIL$_SEND_USERNAME,to_user,&to_user_len},
                    {sizeof(to_type),MAIL$_SEND_USERNAME_TYPE,&to_type,0},
                    {0,0,0,0} },
    body_itm[]={ {sizeof(filename),MAIL$_SEND_FILENAME,filename,&filename_len},
                 {0,0,0,0} },
    attrib_itm[]={ {sizeof(to_user),MAIL$_SEND_TO_LINE,to_user,&to_user_len},
                   {sizeof(subject),MAIL$_SEND_SUBJECT,subject,&subject_len},
                   {0,0,0,0} },
    user_itm[]={ {0, MAIL$_USER_USERNAME,0,0},{0,0,0,0} },
    out_itm[]={ {sizeof(cc_prompt),MAIL$_USER_CC_PROMPT,&cc_prompt,0},
                {0,0,0,0} };
  globalvalue int NEWS$_MAILSUB,NEWS$_MAILCALL;

  user_itm[0].buffer_length =strlen(conf[NEWS_NUM_USERNAME].text);
  user_itm[0].buffer_address=conf[NEWS_NUM_USERNAME].text;
  c$cks(mail$user_begin(&user_context,&nulllist,&nulllist));
  c$cks(mail$user_get_info(&user_context,user_itm,out_itm));
  c$cks(mail$user_end(&user_context,&nulllist,&nulllist));
  strcpy(to_user,read_string(kbd_id,"To: ",input_id,addr));
  to_user_len=strlen(to_user); redraw_lines(paste_id,xROWS-1,2);
  if (cc_prompt || *cc) {
    strcpy(cc_user,read_string(kbd_id,"CC: ",input_id,cc));
    cc_user_len=strlen(cc_user); redraw_lines(paste_id,xROWS-1,2);
  }
  strcpy(subject,read_string(kbd_id,"Subject: ",input_id,subj));
  subject_len=strlen(subject);
  set_cursor(input_id,1,1); redraw_lines(paste_id,xROWS-1,2);
  strcpy(filename,file); filename_len=strlen(filename);
  if ((strchr(to_user,'@')!=NULL || strchr(to_user,'%')!=NULL)
      && strincmp(to_user,conf[NEWS_NUM_MAILER].text,strlen(conf[NEWS_NUM_MAILER].text)))
    if (*conf[NEWS_NUM_MAILER].text=='"') {
      sprintf(t1,"%s%s\"",conf[NEWS_NUM_MAILER].text,to_user);
      strcpy(t2,t1);
    } else {
      sprintf(t1,"%s%s\"",conf[NEWS_NUM_MAILER].text,to_user);
      sprintf(t2,"%s\"\"%s\"\"\"",conf[NEWS_NUM_MAILER].text,to_user);
    }
  else { strcpy(t1,to_user); strcpy(t2,to_user); }
#ifndef CALLABLE_MAIL
  dp=strchr(t1,':'); al=strchr(t1,'%'); if (al==NULL) al=strchr(t1,'@');
  if (al!=NULL)
    if (dp!=NULL && *(dp+1)==':' && dp<al) strcpy(to_user,t1);
    else {
      sysprv_flag=sys$setprv(&enbflg,&prv,0,0);
      if (sysprv_flag==SS$_NOTALLPRIV) {
        sprintf(tmp,"MAIL %s %s/SUBJECT=\"%s\"",filename,t2,subject);
        lib$spawn(c$dsc(tmp),c$dsc("NL:"),c$dsc("NL:"),0,0,0,0,0,0,0,0,0);
        strcpy(fao,c$asc(t2)); geterror(fac,NEWS$_MAILSUB,fao); return;
      } else strcpy(to_user,t1);
    }
  else strcpy(to_user,t1);
#else
  strcpy(to_user,t1);
#endif
  c$cks(mail$send_begin(&send_context,&nulllist,&nulllist));
  address_itm[0].buffer_length =strlen(to_user);
  address_itm[0].buffer_address=to_user;
  lib$establish(establish);
  status=mail$send_add_address(&send_context,address_itm,&nulllist);
  if (status!=SS$_NORMAL) goto label;
  if (cc_user_len) {
    to_type=MAIL$_CC;
    address_itm[0].buffer_length =strlen(cc_user);
    address_itm[0].buffer_address=cc_user;
    status=mail$send_add_address(&send_context,address_itm,&nulllist);
    if (status!=SS$_NORMAL) goto label;
  }
  attrib_itm[0].buffer_length =strlen(to_user);
  attrib_itm[0].buffer_address=to_user;
  attrib_itm[1].buffer_length =strlen(subject);
  attrib_itm[1].buffer_address=subject;
  status=mail$send_add_attribute(&send_context,attrib_itm,&nulllist);
  if (status!=SS$_NORMAL) goto label;
  body_itm[0].buffer_length =strlen(filename);
  body_itm[0].buffer_address=filename;
  status=mail$send_add_bodypart(&send_context,body_itm,&nulllist);
  if (status!=SS$_NORMAL) goto label;
  status=mail$send_message(&send_context,&nulllist,&nulllist);
label:
  c$cks(mail$send_end(&send_context,&nulllist,&nulllist));
#ifndef CALLABLE_MAIL
  if (sysprv_flag==SS$_NORMAL) { enbflg=0; sys$setprv(&enbflg,&prv,0,0); }
#endif
  if (status==SS$_NORMAL) { strcpy(fao,c$asc(to_user)); geterror(fac,NEWS$_MAILCALL,fao); }
#endif
}

/******************************************************************************/

print_file(file,queue)
char *file,*queue;
{
  char name[20]="NEWS Print\0";
  unsigned int iosb[2];
  struct ItemList
    itmlst[]={ {0,SJC$_QUEUE,0,0},
               {0,SJC$_FILE_SPECIFICATION,0,0},
               {0,SJC$_JOB_NAME,0,0},
               {0,SJC$_DELETE_FILE,0,0},
               {0,SJC$_NOTIFY,0,0},
               {0,0,0,0} };
  globalvalue int NEWS$_NOSUCHQUE,NEWS$_PRNTSTRT;

  itmlst[0].buffer_length =strlen(queue);
  itmlst[0].buffer_address=queue;
  itmlst[1].buffer_length =strlen(file);
  itmlst[1].buffer_address=file;
  itmlst[2].buffer_length =strlen(name);
  itmlst[2].buffer_address=name;
  c$cks(sys$sndjbc(0,SJC$_ENTER_FILE,0,itmlst,iosb,0,0));
  if (iosb[0]==JBC$_NOSUCHQUE) { strcpy(fao,c$asc(queue)); geterror(fac,NEWS$_NOSUCHQUE,fao); }
  else geterror(fac,NEWS$_PRNTSTRT);
}

/******************************************************************************/

#ifdef LOGGING
write_logging(txt)
char *txt;
{
  FILE *fd;
  char tim[256],t[256],*ptr=t;
  quad prv={PRV$M_SYSPRV,0};
  uword timlen;
  ulong sysprv_flag=SS$_NOTALLPRIV,status;
  char enbflg=1;
  globalvalue int NEWS$_LOGFAIL;

  c$cks(sys$asctim(&timlen,c$ldsc(tim,255),0,0)); tim[timlen]='\0';
  sprintf(t,"%s --- %s --- %s\r\n",tim,conf[NEWS_NUM_USERNAME].text,txt);
  if (access(NEWSMGR_LOGGING,ACCESS_WRITE)) {
    sysprv_flag=sys$setprv(&enbflg,&prv,0,0);
    if (sysprv_flag==SS$_NOTALLPRIV) {
      geterror(-1,NEWS$_LOGFAIL);
      sys$exit(SS$_NOSYSPRV);
    } else {
      fd=fopen(NEWSMGR_LOGGING,"a+");
      fprintf(fd,"%s",t);
      fclose(fd);
    }
    if (sysprv_flag==SS$_NORMAL) { enbflg=0; sys$setprv(&enbflg,&prv,0,0); }
  } else {
    fd=fopen(NEWSMGR_LOGGING,"a+");
    fprintf(fd,"%s",t);
    fclose(fd);
  }
}
#endif

/******************************************************************************/

hlp_output(out_str)
struct dsc$descriptor *out_str;
{
  char txt[256],*tp;

  tp = out_str->dsc$a_pointer; strcpy(txt,tp);
  txt[out_str->dsc$w_length]='\0';
  put_text(text_id,txt,0,0,TRUE);
  return(SS$_NORMAL);
}

/******************************************************************************/

hlp_input(inp_str,prompt,outlen)
struct dsc$descriptor *inp_str,*prompt;
unsigned short *outlen;
{
  char txt[256],*tp,inp[256];

  tp = prompt->dsc$a_pointer + 2; strcpy(txt,tp);
  txt[prompt->dsc$w_length - 2]='\0';
  if (noscr) { printf("%s",txt); gets(inp); }
  else strcpy(inp,tp=read_string(kbd_id,txt,input_id,0));
  if (!*tp && *(tp+1)=='*') { inp[0]=SMG$K_TRM_CTRLZ; inp[1]='\0'; }
  inp_str->dsc$w_length  = strlen(inp);
  inp_str->dsc$b_dtype   = DSC$K_DTYPE_T;
  inp_str->dsc$b_class   = DSC$K_CLASS_S;
  strcpy(inp_str->dsc$a_pointer,inp);
  *outlen = strlen(inp);
  return(SS$_NORMAL);
}

/******************************************************************************/

hlp_help(filename,param)
char *filename,*param;
{
  char helpcomm[256];
  int qualifier;
  extern lib$put_output(),lib$get_input();

  if (access(filename,ACCESS_READ)) return(FALSE);
  if (*param) { strcpy(helpcomm,"Commands "); strcat(helpcomm,param); }
  else helpcomm[0]='\0';
  qualifier=HLP$M_PROMPT|HLP$M_HELP;
  clear_display(text_id);
  c$cks(lbr$output_help(hlp_output,&xCOLS,c$dsc(helpcomm),c$dsc(filename),
        &qualifier,hlp_input));
  clear_display(text_id);
  return(TRUE);
}

/******************************************************************************/

cmd_help()
{
  bool cmd,prot,form,keyp;
  char image[256],filename[256],path[256];
  uword pathlen;
  globalvalue int NEWS$_IVCMD;

  cmd=(cli$present(c$dsc("COMMANDS"))==CLI$_PRESENT);
  prot=(cli$present(c$dsc("PROTOCOL"))==CLI$_PRESENT);
  form=(cli$present(c$dsc("FORMAT"))==CLI$_PRESENT);
  keyp=(cli$present(c$dsc("KEYPAD"))==CLI$_PRESENT);
  if (!prot && !form && !keyp) cmd=TRUE;
  if (noscr && !cmd) { geterror(fac,NEWS$_IVCMD); return; }
  path[0]='\0';
  if (cmd && cli$present(c$dsc("Path"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("Path"),c$ldsc(path,256),&pathlen); path[pathlen]='\0';
  }
  strcpy(image,get_path());
  if (prot) sprintf(filename,"%sNEWS_RFC977.DAT",image);
  if (form) sprintf(filename,"%sNEWS_RFC1036.DAT",image);
  if (cmd) sprintf(filename,"%sNEWS_HELP.HLB",image);
  if (cmd && getenv("NEWS$HELP")!=NULL) strcpy(filename,getenv("NEWS$HELP"));
  if (keyp) { filename[0]='\0'; internal_mode|=0x40; }
  if (cmd) {
    if (hlp_help(filename,path)) switch (internal_mode) {
      case 1: newsgroups_redraw(groupscreen,grouppos,TRUE); break;
      case 2: group_redraw(subjectscreen,articlepos,TRUE); break;
      case 3: article_redraw(articlescreen); break;
    }
  } else if (read_help(filename)) {
    help_handle();
    internal_mode&=0x3f;
    switch (internal_mode) {
      case 1: newsgroups_redraw(groupscreen,grouppos,TRUE); break;
      case 2: group_redraw(subjectscreen,articlepos,TRUE); break;
      case 3: article_redraw(articlescreen); break;
    }
  }
}

/******************************************************************************/

static char *copyright[]=
{" ",
"  ##   ##    ##     ##      #####      _   _ ___ _    _  ___",
"  ##   ##    ###   ###     ##   ##     |\\  | |   |    | (__",
"   ## ##     #### ####      ###    ==  | \\ | |-  | /\\ |    \\",
"   ## ##     ## ### ##        ###      |  \\| |__  V  V  (__/",
"    ###      ##  #  ##     ##   ##",
"    ### ery  ##     ## ad   ##### tudents [Version %s]",
" ",
" Copyright 1990 by Bernd Onasch, University of Karlsruhe, FRG",
" ",
" This NEWSreader was last modified %s",
" and uses the %s TCP/IP implementation.",
" ",
" VMS is trademark of Digital Equipment Corporation",
" "};

cmd_version()
{
  uword key;
  ulong disp;
  int i,j;
  char t[256],mask[256];
  globalvalue int NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  disp=open_display(paste_id,15,62,1+((xROWS-15)>>1),1+((xCOLS-62)>>1),SMG$M_BORDER,SMG$M_BOLD);
  for (i=0;i<15;i++) {
    if (i==6) sprintf(t,copyright[i],VERSION);
    else if (i==10) sprintf(t,copyright[i],MOD_TIME);
    else if (i==11) {
      if (decnet) strcpy(t," and uses DECnet objects for communications.");
      else sprintf(t,copyright[i],TRANSPORT);
    } else strcpy(t,copyright[i]);
    if (i>0 && i<7) {
      for(j=0;j<strlen(t);j++)
        if (conf[NEWS_NUM_DUMPTERM].value) mask[j]=SMG$M_NOATTR;
        else mask[j]=(t[j]=='#' || (j>38 && i<6))?SMG$M_BLINK:SMG$M_NOATTR;
      mask[strlen(t)]='\0';
      put_multi(disp,t,mask,0,TRUE);
    } else put_text(disp,t,0,0,TRUE);
  }
  key=read_key(kbd_id,NEWS_PROMPT,input_id);
  close_display(disp);
}

/******************************************************************************/

cmd_list()
{
  bool grps,subj,body;
  int start,finish,cnt,i;
  char t[16];
  globalvalue int NEWS$_IVCMDINT,NEWS$_IVLIST,NEWS$_IVARTNUM;

  if (!noscr) { geterror(fac,NEWS$_IVCMDINT); return; }
  grps=(cli$present(c$dsc("GROUPS"))==CLI$_PRESENT);
  subj=(cli$present(c$dsc("SUBJECTS"))==CLI$_PRESENT);
  body=(cli$present(c$dsc("ARTICLE"))==CLI$_PRESENT);
  if (internal_mode==1 && body) { geterror(fac,NEWS$_IVLIST); return; }
  if (!grps && !subj && !body) {
    grps=(internal_mode==1);
    body=(internal_mode==2);
  }
  if (grps) {
    start=newsgroups_last(grouppos,10); if (start<0) start=newsgroups_next(-1,1);
    finish=newsgroups_next(start,20);
    if (finish<0) {
      finish=groupanz-1;
      start=newsgroups_last(finish,20); if (start<0) start=newsgroups_next(-1,1);
    }
    cnt=start; while(cnt<=finish && cnt>=0) {
      i=newsgroups_diff(newsgroups_next(-1,1),cnt)+1;
      switch (groups[cnt].mode) {
        case NEWS_GRP_MODERATED: strcpy(t,"(moderated) "); break;
        case NEWS_GRP_POSTING:   strcpy(t,posting?"":"(disallowed) "); break;
        case NEWS_GRP_NOPOSTING: strcpy(t,"(disallowed) "); break;
        case NEWS_GRP_CROSSREF:  strcpy(t,"(cross-ref.) "); break;
      }
      printf("%s %4d %s %swith %d article(s)\n",(cnt==grouppos?"==>":"   "),
        i,groups[cnt].name,t,groups[cnt].articles);
      cnt=newsgroups_next(cnt,1);
    }
  }
  if (subj) {
    start=articlepos-10; if (start<0) start=0;
    finish=start+20; if (finish>=articleanz) finish=articleanz-1;
    if (finish>=20) start=finish-20;
    cnt=start; while (cnt<=finish) {
      printf("%s %6d %s\n",(cnt==articlepos?"==>":"   "),
        articles[cnt].number,articles[cnt].subject);
      cnt++;
    }
  }
  if (body) {
    if (!article_start(articles[articlepos].number)) {
      article_end(); geterror(fac,NEWS$_IVARTNUM);
    } else {
      if (conf[NEWS_NUM_HEADERDISPLAY].value) {
        i=0; while (i<header_lines) printf("%s\n",header[i++]);
      } else {
        printf("Subject:      %s\n",article_search("Subject"));
        printf("Date:         %s\n",article_search("Date"));
        printf("From:         %s\n",article_search("From"));
        printf("Organization: %s\n",article_search("Organization"));
      }
      i=0; while (i<article_lines) put_text(0,article_text[i++],0,0,0);
    }
  }
}

/******************************************************************************/

cmd_kill()
{
  uword retlen;
  int pos,cnt;
  char remove,sens=FALSE,result[256],author[256]="\0",subject[256]="\0",
       group[256]="\0";
  globalvalue int NEWS$_KILADDMAX,NEWS$_KILADD,NEWS$_KILREM,NEWS$_KILRMV;

  if (cli$present(c$dsc("AUTHOR"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("AUTHOR"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    if (result[0]=='"') {
      sens=TRUE;
      result[strlen(result)-1]='\0'; strcpy(author,&result[1]);
    }
    else strcpy(author,result);
  }
  if (cli$present(c$dsc("SUBJECT"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("SUBJECT"),c$ldsc(result,256),&retlen);
    result[retlen]='\0';
    if (result[0]=='"') {
      sens=TRUE;
      result[strlen(result)-1]='\0'; strcpy(subject,&result[1]);
    }
    else strcpy(subject,result);
  }
  if (cli$present(c$dsc("GROUP"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("GROUP"),c$ldsc(result,256),&retlen); result[retlen]='\0';
    if (result[0]=='"') { result[strlen(result)-1]='\0'; strcpy(group,&result[1]); }
    else strcpy(group,result);
  } else strcpy(group,groups[grouppos].name);
  if (cli$present(c$dsc("CASE_SENSITIVE"))==CLI$_NEGATED) sens=FALSE;
  if (cli$present(c$dsc("CASE_SENSITIVE"))==CLI$_PRESENT) sens=TRUE;
  remove=(cli$present(c$dsc("REMOVE"))==CLI$_PRESENT);
  if (!remove) {
    pos=0; while (pos<MAXKILL && kills[pos].group!=NIL) pos++;
    if (pos==MAXKILL) geterror(fac,NEWS$_KILADDMAX,pos);
    else {
      kills[pos].sensitive=(sens?NEWS_KILL_SENSITIVE:NEWS_KILL_INSENSITIVE);
      if (!stricmp(group,"all")) strcpy(group,"ALL");
      strcpy(kills[pos].group=malloc(strlen(group)+1),group);
      if (*subject) {
        strcpy(kills[pos].pattern=malloc(strlen(subject)+1),subject);
        kills[pos].mode=NEWS_KILL_SUBJECT;
      } else {
        strcpy(kills[pos].pattern=malloc(strlen(author)+1),author);
        kills[pos].mode=NEWS_KILL_AUTHOR;
      }
      write_killfile();
      strcpy(fao,c$asc(kills[pos].pattern)); strcpy(fao2,c$asc(group));
      geterror(fac,NEWS$_KILADD,fao,fao2);
    }
  } else {
    cnt=0; pos=0; while (pos<MAXKILL) {
      while(pos<MAXKILL && kills[pos].group==NIL) pos++;
      if (pos<MAXKILL && !stricmp(group,kills[pos].group))
        if ((*subject && kills[pos].mode==NEWS_KILL_SUBJECT && !stricmp(subject,kills[pos].pattern)) ||
            (*author  && kills[pos].mode==NEWS_KILL_AUTHOR  && !stricmp(author,kills[pos].pattern)) ||
            (!*subject && !*author)) {
          strcpy(fao,c$asc(kills[pos].pattern)); geterror(fac,NEWS$_KILREM,fao);
          free(kills[pos].group);   kills[pos].group=NIL;
          free(kills[pos].pattern); kills[pos].pattern=NIL;
          kills[pos].sensitive=0;   kills[pos].mode=0;
          write_killfile();
          cnt++;
        }
      pos++;
    }
    geterror(fac,NEWS$_KILRMV,cnt);
  }
}

/******************************************************************************/

cmd_spawn()
{
  long substatus;
  struct dsc$descriptor *cdscp;
  globalvalue int NEWS$_IVCMD,NEWS$_RESTRICT;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  if (restricted) { geterror(fac,NEWS$_RESTRICT); return; }
  set_cursor(error_id,2,1);
  cursor_mode(TRUE);
  disable_broadcasts();
  printf("\n------------------------------------\n");
  printf("Reenter NEWS with the command LOGOUT\n");
  printf("------------------------------------\n");
  cdscp=0;
  lib$spawn(cdscp,0,0,0,0,0,&substatus,0,0,0,c$dsc(NEWS_QUERY),0);
  enable_broadcasts();
  cursor_mode(FALSE);
  redraw_screen(paste_id);
}

/******************************************************************************/

cmd_reply()
{
  char txt[256],file[256];
  uword retlen;
  globalvalue int NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  if (cli$present(c$dsc("Filename"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("Filename"),c$ldsc(file,256),&retlen); file[retlen]='\0';
  } else file[0]='\0';
  sprintf(txt,"MAIL/FOLLOWUP %s",file);
  cli$dcl_parse(c$dsc(txt),&news_table,0,0,0); cli$dispatch();
}

/******************************************************************************/

cmd_mail()
{
#ifdef NO_MAIL
  globalvalue int NEWS$_NOMAIL;

  geterror(fac,NEWS$_NOMAIL);
  return;
#else
  uword retlen,cclen,key;
  int i;
  char tmp[1024],t[1024],file[256],*tp,fp[256],inrepl[256],r_from[256]="\0",
       r_date[256]="\0",refer[1024],r_refer[1024]="\0",r_msgid[256]="\0",
       r_repl[256]="\0",*tp2,t1[256],subj[256]="\0",cc[256];
  FILE *fd,*fd2;
  bool follow,flag,flag2;
  globalvalue int NEWS$_IVFLWUP,NEWS$_IVCMD,NEWS$_RESTRICT;;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  if (restricted) { geterror(fac,NEWS$_RESTRICT); return; }
  i=JPI$_PID;
  c$cks(lib$getjpi(&i,0,0,0,c$ldsc(tmp,10),&retlen)); tmp[retlen]='\0';
  sprintf(t1,"sys$scratch:news_mail_%s.tmp",tmp);
  follow=(cli$present(c$dsc("FOLLOWUP"))==CLI$_PRESENT);
  if (cli$present(c$dsc("CC"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("CC"),c$ldsc(cc,256),&cclen); cc[cclen]='\0';
    if (*cc=='"') { tp=cc+1; while (*tp) {*(tp-1)= *tp; tp++; } *(tp-1)='\0'; }
  } else cc[0]='\0';
  if (follow && internal_mode==1) { geterror(fac,NEWS$_IVFLWUP); return; }
  if (cli$present(c$dsc("Filename"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("Filename"),c$ldsc(file,256),&retlen); file[retlen]='\0';
  } else { delete(t); file[0]='\0'; }
  if (follow) {
    if (!strincmp(articles[articlepos].subject,"Re: ",4) ||
        !strincmp(articles[articlepos].subject,"Re^",3))
      strcpy(subj,articles[articlepos].subject);
    else sprintf(subj,"Re: %s",articles[articlepos].subject);
    sprintf(fp,"sys$scratch:news_reply_%s.tmp",tmp);
    sprintf(tmp,"SAVE %s",fp);
    cli$dcl_parse(c$dsc(tmp),&news_table,0,0,0); cli$dispatch();
    fd=fopen(fp,"r"); fd2=fopen(t1,"w");
    flag=TRUE; flag2=FALSE;
    while (fgets(tmp,1024,fd)) {
      while (tmp[strlen(tmp)-1]=='\r'||tmp[strlen(tmp)-1]=='\n') tmp[strlen(tmp)-1]='\0';
      if (flag) {
        if (!*tmp) {
          flag=FALSE;
          sprintf(inrepl,"%s's message of %s",r_from,r_date);
          sprintf(refer,"%s %s",r_refer,r_msgid);
          fprintf(fd2,"References: %s\n",refer);
          fprintf(fd2,"In-Reply-To: %s\n",inrepl);
          fprintf(fd2,"\n");
          fprintf(fd2,"In %s %s writes:\n",r_msgid,r_from);
          fprintf(fd2,"\n");
        } else {
          if (!strncmp(tmp,"References:",11)) { flag2=TRUE; strcpy(r_refer,get_text(tmp)); }
          else if ((*tmp==' ' || *tmp=='\t') && flag2) { strcat(r_refer," "); strcat(r_refer,get_text(tmp)); }
          else {
            flag2=FALSE;
            if (!strncmp(tmp,"Message-ID:",11)) strcpy(r_msgid,get_text(tmp));
            else fprintf(fd2,"%s\n",tmp);
            if (!strncmp(tmp,"Date:",5)) strcpy(r_date,get_text(tmp));
            if (!strncmp(tmp,"From:",5)) { strcpy(r_from,get_text(tmp));
              if (tp2=strchr(r_from,' ')) *tp2='\0'; }
            if (!strncmp(tmp,"Reply-To:",9)) { strcpy(r_repl,get_text(tmp));
              if (tp2=strchr(r_repl,' ')) *tp2='\0'; }
          }
        }
      } else { sprintf(t,"%s %s\n",conf[NEWS_NUM_MARKER].text,tmp); fputs(t,fd2); }
    }
    fclose(fd2); fclose(fd); delete(fp);
  }
  if (*conf[NEWS_NUM_SIGNATURE].text) {
    if (fd=fopen(conf[NEWS_NUM_SIGNATURE].text,"r")) {
      fd2=fopen(t1,"a"); fprintf(fd2,"\n");
      while (fgets(t,1024,fd)) fputs(t,fd2);
      fclose(fd2);
    }
    fclose(fd);
  }
  if (fd=fopen(file,"r")) {
    fd2=fopen(t1,"w"); while (fgets(tmp,1024,fd)) fputs(tmp,fd2); fclose(fd2);
  }
  fclose(fd);
  i=call_editor(t1);
  if (i==1) tp="Send MAIL [Y|Abort=Ctrl-Z] ? ";
  else tp="Do not send MAIL [Y|Send=S] ? ";
  do key=read_key(kbd_id,tp,input_id);
  while (key!=SMG$K_TRM_UPPERCASE_Y && key!=SMG$K_TRM_LOWERCASE_Y &&
         key!=SMG$K_TRM_UPPERCASE_N && key!=SMG$K_TRM_LOWERCASE_N &&
         key!=SMG$K_TRM_UPPERCASE_S && key!=SMG$K_TRM_LOWERCASE_S &&
         key!=SMG$K_TRM_CR          && key!=SMG$K_TRM_ENTER &&
         key!=SMG$K_TRM_CTRLZ) ;
  if ((i==1 && (key==SMG$K_TRM_UPPERCASE_Y || key==SMG$K_TRM_LOWERCASE_Y ||
                key==SMG$K_TRM_CR || key==SMG$K_TRM_ENTER)) ||
      (i!=1 && (key==SMG$K_TRM_UPPERCASE_S || key==SMG$K_TRM_LOWERCASE_S)))
    send_mail(t1,*r_repl?r_repl:r_from,subj,cc);
  delete(t1); delete(t1);
#endif
}

/******************************************************************************/

cmd_print()
{
  bool hold;
  uword retlen;
  quad tim;
  char queue[256],file[256],tmp[256],t[256];
  globalvalue int NEWS$_IVPRNT,NEWS$_IVCMD;

  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  if (internal_mode==1) { geterror(fac,NEWS$_IVPRNT); return; }
  if (cli$present(c$dsc("Queue"))==CLI$_PRESENT) {
    cli$get_value(c$dsc("Queue"),c$ldsc(queue,256),&retlen); queue[retlen]='\0';
  } else strcpy(queue,conf[NEWS_NUM_PRINT].text);
  hold=(cli$present(c$dsc("HOLD"))==CLI$_PRESENT);
  c$cks(sys$gettim(&tim));
  if (hold) strcpy(file,"sys$scratch:news_hold.tmp");
  else sprintf(file,"sys$scratch:news_%08x%08x.tmp",tim.l2,tim.l1);
  sprintf(t,"SAVE %s",file);
  cli$dcl_parse(c$dsc(t),&news_table,0,0,0); cli$dispatch();
  if (!hold) print_file(file,queue);
  else print_flag=TRUE;
}

/******************************************************************************/

cmd_coffee()
{
  char tmp[64];
  uword retlen;
  int i,status;
  globalvalue int NEWS$_IVCOFFEE,NEWS$_COFFEE;

  i=DVI$_DEVNAM;
  status=lib$getdvi(&i,0,c$dsc("COF0:"),0,c$ldsc(tmp,64),&retlen);
  if (status==SS$_NORMAL) geterror(fac,NEWS$_COFFEE);
  else geterror(fac,NEWS$_IVCOFFEE);
  return;
}

/******************************************************************************/
