/******************************************************************************
 *
 * VMS NEWS (part COMMAND)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * Internal COMMAND file
 * ----------------------------------------------------------------------------
 *       cmd_up()
 *       cmd_down()
 *       cmd_top()
 *       cmd_bottom()
 *       cmd_go()
 *       cmd_group()
 *       cmd_article()
 *       cmd_scan()
 *       cmd_exit()
 *       cmd_quit()
 *       cmd_reread()
 *       cmd_dir()
 *       cmd_register()
 *       cmd_deregister()
 *       cmd_next()
 *       cmd_last()
 *       cmd_rotate()
 *  bool do_save(int num,char *filename)
 *  bool do_check_equal(char *txt,char *pattern,bool sensitive)
 *       cmd_save()
 *       cmd_edit()
 *       cmd_mark()
 *       cmd_enter()
 *
 ******************************************************************************/

#module COMMAND "CMD V1.24"
#include "header.h"
#include <jpidef.h>

globalref int news_table;
globalvalue unsigned STR$_MATCH;

/******************************************************************************/

#define ESC 27
#define GS 29
#define ETX 3
#define US 31
#define SUB 26
#define FF 12
#define CAN 24

cmd_chirk()
{
#if CHINESE_NEWS_READER
   bool grps;
   unsigned char *text;
   char txt[256];
   int num, first=1;
   globalvalue int NEWS$_WRGCHIRK;

   if (internal_mode == 1) {
      geterror(fac,NEWS$_WRGCHIRK);
      return;
   }
   grps = (cli$present(c$dsc("GROUPS"))==CLI$_PRESENT);
   if (!grps) {
      if (internal_mode == 2) {
         internal_mode= 3|(internal_mode&0x20);
         if(!article_start(articles[articlepos].number)) { article_end(); return; }
      }
      for (num = article_top; num < 0; num ++) {
         switch (-num) {
           case 4:  sprintf(txt,"Subject:      %-*.*s",xCOLS-14,xCOLS-14,article_search("Subject")); break;
           case 3:  sprintf(txt,"Date:         %-*.*s",xCOLS-14,xCOLS-14,article_search("Date")); break;
           case 2:  sprintf(txt,"From:         %-*.*s",xCOLS-14,xCOLS-14,article_search("From")); break;
           case 1:  sprintf(txt,"Organization: %-*.*s",xCOLS-14,xCOLS-14,article_search("Organization")); break;
           default: break;
         }
         if (first == 1) {
            text = (unsigned char *)malloc((1+strlen(txt))*sizeof(unsigned char));
            strcpy(text,txt);
            strcat(text,"\n");
            first = 0;
         } else {
            text = (unsigned char *)realloc(text, 
           	(strlen(text) + strlen(txt) + 1)*sizeof(unsigned char));
            strcat(text,txt);
            strcat(text,"\n");
         }
      }
      
      for (num = 0; num < article_lines; num ++) {
         if (first == 1) {
            text = (unsigned char *)malloc((2+strlen(article_text[num]))
                * sizeof(unsigned char));
            strcpy(text,article_text[num]);
            strcat(text,"\n");
            first = 0;
         } else {
            text = (unsigned char *)realloc(text, 
           	(strlen(text) + strlen(article_text[num]) + 2)
           	* sizeof(unsigned char));
            strcat(text,article_text[num]);
            strcat(text,"\n");
         }
      }
   } else if (grps) {
      txt[0] = '\0';
      strcpy(txt, group_line(0,-1));
      text = (unsigned char *)malloc((strlen(txt) + 2)
	   * sizeof(unsigned char));
      strcpy(text, txt);
      strcat(text, "\n");
      for (num = 1; num < articleanz; num ++) {
         strcpy(txt, group_line(num,-1));
         text = (unsigned char *)realloc(text, 
           	(strlen(text) + strlen(txt) + 2)
           	* sizeof(unsigned char));
         strcat(text, txt);
         strcat(text, "\n");
      }
   }
   news_chinese(text);
   free(text);
   if (chinese_read == 0) 
      chinese_read = 1;
   internal_mode = 2;
   redraw_screen(paste_id);
#endif
}

/******************************************************************************/

cmd_up()
{
  char result[256];
  uword retlen;
  int num,i;
  globalvalue int NEWS$_IVVAL;

  if (cli$present(c$dsc("Number"))==CLI$_ABSENT) num=noscr?1:xROWS-4;
  else {
    c$cks(cli$get_value(c$dsc("Number"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; num=atoi(result);
    if (num<=0) { geterror(fac,NEWS$_IVVAL); return; }
  }
  switch (internal_mode) {
    case 1:
      if (num<xROWS+6) groupscreen=newsgroups_up(groupscreen,num);
      else {
        i=newsgroups_last(grouppos,num);
        groupscreen=grouppos=(i>=0)?i:newsgroups_next(-1,1);
        newsgroups_redraw(groupscreen,grouppos,FALSE); }
      break;
    case 2:
      if (num<xROWS+6) subjectscreen=group_up(subjectscreen,num);
      else {
        subjectscreen=articlepos=(num>articlepos)?0:articlepos-num;
        group_redraw(subjectscreen,articlepos,FALSE); }
      break;
    case 3:
      if (num<xROWS+6) articlescreen=article_up(articlescreen,num);
      else {
        articlescreen=(num>articlescreen-article_top)?article_top:articlescreen-num;
        article_redraw(articlescreen); }
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_down()
{
  char result[256];
  uword retlen;
  int num,i;
  globalvalue int NEWS$_IVVAL;

  if (cli$present(c$dsc("Number"))==CLI$_ABSENT) num=noscr?1:xROWS-4;
  else {
    c$cks(cli$get_value(c$dsc("Number"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; num=atoi(result);
    if (num<=0) { geterror(fac,NEWS$_IVVAL); return; }
  }
  switch (internal_mode) {
    case 1:
      if (num<xROWS+6) groupscreen=newsgroups_down(groupscreen,num);
      else {
        i=newsgroups_next(grouppos,num);
        grouppos=(i>=0)?i:newsgroups_last(groupanz,1);
        groupscreen=newsgroups_last(grouppos,xROWS-5);
        newsgroups_redraw(groupscreen,grouppos,FALSE); }
      break;
    case 2:
      if (num<xROWS+6) subjectscreen=group_down(subjectscreen,num);
      else {
        articlepos=(num+articlepos>=articleanz)?articleanz-1:articlepos+num;
        subjectscreen=(articlepos<=xROWS-4)?0:articlepos-xROWS+5;
        group_redraw(subjectscreen,articlepos,FALSE); }
      break;
    case 3:
      if (num<xROWS+6) articlescreen=article_down(articlescreen,num);
      else {
        articlescreen=(num+articlescreen>=article_lines-xROWS+4)?article_lines-xROWS+5:articlescreen+num;
        article_redraw(articlescreen); }
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_top()
{
  bool top;
  int i;

  top=(cli$present(c$dsc("READ"))==CLI$_PRESENT);
  switch (internal_mode) {
    case 1:
      groupscreen=grouppos=newsgroups_next(-1,1);
      newsgroups_redraw(groupscreen,grouppos,FALSE); break;
    case 2:
      subjectscreen=articlepos=0;
      if (top && groups[grouppos].registered) {
        i=0; while (i<articleanz) { if (articles[i].unread) break; i++; }
        if (i<articleanz) { articlepos=i; subjectscreen=(i<=xROWS-5)?0:articlepos-xROWS+5; }
      }
      group_redraw(subjectscreen,articlepos,FALSE); break;
    case 3:
      articlescreen=article_top; article_redraw(articlescreen); break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_bottom()
{
  bool bottom;
  int i;

  bottom=(cli$present(c$dsc("READ"))==CLI$_PRESENT);
  switch (internal_mode) {
    case 1:
      grouppos=newsgroups_last(groupanz,1);
      groupscreen=newsgroups_last(grouppos,xROWS-5);
      newsgroups_redraw(groupscreen,grouppos,FALSE);
      break;
    case 2:
      articlepos=articleanz-1;
      if (bottom && groups[grouppos].registered) {
        i=articleanz-1; while (i>=0) { if (!articles[i].unread) break; i--; }
        i++; if (i<articleanz) articlepos=i;
      }
      subjectscreen=(articlepos<xROWS-4)?0:articlepos-xROWS+5;
      group_redraw(subjectscreen,articlepos,FALSE);
      break;
    case 3:
      articlescreen=article_lines-xROWS+4;
      article_redraw(articlescreen);
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_go()
{
  char result[256];
  uword retlen;
  int i,num;
  globalvalue int NEWS$_IVNUM,NEWS$_IVVAL,NEWS$_IVGO;

  if (cli$present(c$dsc("Number"))==CLI$_ABSENT) num=0;
  else {
    c$cks(cli$get_value(c$dsc("Number"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; num=atoi(result);
  }
  switch (internal_mode) {
    case 1:
      i=newsgroups_diff(newsgroups_next(-1,1),newsgroups_last(groupanz,1));
      if (num>0 && num<=i+1) {
        grouppos=newsgroups_next(-1,num);
        groupscreen=(num==1)?grouppos:newsgroups_last(grouppos,xROWS-5);
        newsgroups_redraw(groupscreen,grouppos,FALSE);
      } else geterror(fac,NEWS$_IVNUM);
      break;
    case 2:
      i=0; while(i<articleanz && articles[i].number!=num) i++;
      if (i<articleanz) {
        articlepos=i;
        subjectscreen=(articlepos<xROWS-4)?0:articlepos-xROWS+5;
        group_redraw(subjectscreen,articlepos,FALSE);
      } else geterror(fac,NEWS$_IVVAL);
      break;
    case 3:
      geterror(fac,NEWS$_IVGO); break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_group()
{
  char result[256],txt[256];
  uword retlen;
  int i,j;
  bool wrap=FALSE;
  globalvalue int NEWS$_IVGRP,NEWS$_NOGRPNAM,NEWS$_NOSUCHGRP;

  if (internal_mode!=1) { geterror(fac,NEWS$_IVGRP); return; }
  if (cli$present(c$dsc("GroupName"))==CLI$_ABSENT) { geterror(fac,NEWS$_NOGRPNAM); return; }
  c$cks(cli$get_value(c$dsc("GroupName"),c$ldsc(result,256),&retlen));
  result[retlen]='\0';
  i=newsgroups_next(grouppos,1); if (i<0) i=grouppos;
  while (i<groupanz) {
    c$cks(str$upcase(c$ldsc(txt,255),c$dsc(groups[i].name)));
    txt[strlen(groups[i].name)]='\0';
    if (str$match_wild(c$dsc(txt),c$dsc(result))==STR$_MATCH) break;
    if (!strcmp(txt,result)) break;
    if (newsgroups_next(i,1)<0) i=groupanz;
    else i=newsgroups_next(i,1);
    if (i==groupanz && !wrap) {
      wrap=TRUE; i=newsgroups_next(-1,1);
      if (i<0) i=groupanz;
    }
  }
  if (i==groupanz) { strcpy(fao,c$asc(result)); geterror(fac,NEWS$_NOSUCHGRP,fao); return; }
  grouppos=i;
  j=newsgroups_diff(grouppos,groupanz);
  groupscreen=(j>=xROWS-5 || j<0)?grouppos:newsgroups_last(grouppos,xROWS-5-j);
  newsgroups_redraw(groupscreen,grouppos,FALSE);
  if (noscr) internal_mode|=0x020;
}

/******************************************************************************/

cmd_article()
{
  char result[256],txt[256];
  bool keywords,summary,casesense=FALSE;
  uword retlen;
  int i,j;
  globalvalue int NEWS$_IVART,NEWS$_NOARTHD,NEWS$_NOSUCHART;

  keywords = (cli$present(c$dsc("KEYWORDS"))==CLI$_PRESENT);
  summary = (cli$present(c$dsc("SUMMARY"))==CLI$_PRESENT);
  if (internal_mode!=2) { geterror(fac,NEWS$_IVART); return; }
  if (cli$present(c$dsc("ArtName"))==CLI$_ABSENT) { geterror(fac,NEWS$_NOARTHD); return; }
  c$cks(cli$get_value(c$dsc("ArtName"),c$ldsc(txt,255),&retlen));
  if (*txt=='"') casesense=TRUE;
  txt[retlen]='\0'; if (txt[retlen-1]=='"') txt[retlen-1]='\0';
  strcpy(result,&txt[(*txt=='"')?1:0]);
  if (keywords && articles[0].keywords==NIL) xhdr_call("keywords",0,0,TRUE);
  if (summary && articles[0].summary==NIL) xhdr_call("summary",0,0,TRUE);
  i=articlepos+1;
  while (i<articleanz) {
    if (casesense) strcpy(txt,articles[i].subject);
    else {
      c$cks(str$upcase(c$ldsc(txt,255),c$dsc(articles[i].subject)));
      txt[strlen(articles[i].subject)]='\0';
    }
    if (str$match_wild(c$dsc(txt),c$dsc(result))==STR$_MATCH) break;
    if (!strcmp(txt,result)) break;
    if (articles[i].from!=NIL) {
      if (casesense) strcpy(txt,articles[i].from);
      else {
        c$cks(str$upcase(c$ldsc(txt,255),c$dsc(articles[i].from)));
        txt[strlen(articles[i].from)]='\0';
      }
      if (str$match_wild(c$dsc(txt),c$dsc(result))==STR$_MATCH) break;
      if (!strcmp(txt,result)) break;
    }
    if (articles[i].summary!=NIL && summary) {
      if (casesense) strcpy(txt,articles[i].summary);
      else {
        c$cks(str$upcase(c$ldsc(txt,255),c$dsc(articles[i].summary)));
        txt[strlen(articles[i].summary)]='\0';
      }
      if (str$match_wild(c$dsc(txt),c$dsc(result))==STR$_MATCH) break;
      if (!strcmp(txt,result)) break;
    }
    if (articles[i].keywords!=NIL && keywords) {
      if (casesense) strcpy(txt,articles[i].keywords);
      else {
        c$cks(str$upcase(c$ldsc(txt,255),c$dsc(articles[i].keywords)));
        txt[strlen(articles[i].keywords)]='\0';
      }
      if (str$match_wild(c$dsc(txt),c$dsc(result))==STR$_MATCH) break;
      if (!strcmp(txt,result)) break;
    }
    i++;
  }
  if (i==articleanz) { strcpy(fao,c$asc(result)); geterror(fac,NEWS$_NOSUCHART,fao); return; }
  sprintf(txt,"DOWN %d",i-articlepos);
  cli$dcl_parse(c$dsc(txt),&news_table,0,0,0); cli$dispatch();
}

/******************************************************************************/

cmd_scan()
{
  bool casesense;
  char result[256],pattern[256],tmp[1024];
  uword retlen;
  int start,loop;
  globalvalue int NEWS$_IVSCAN,NEWS$_PNF;
  extern bool do_check_equal();

  if (internal_mode!=3) { geterror(fac,NEWS$_IVSCAN); return; }
  c$cks(cli$get_value(c$dsc("Pattern"),c$ldsc(result,256),&retlen));
  result[retlen]='\0';
  if (result[0]=='"') {
    result[strlen(result)-1]='\0'; sprintf(pattern,"*%s*",&result[1]);
    casesense=TRUE;
  } else { sprintf(pattern,"*%s*",result); casesense=FALSE; }
  start=articlescreen; if (start<0) start=0;
  loop=start+1; while (loop!=start) {
    loop++; if (loop==article_lines) loop=0;
    if (loop+1!=article_lines) sprintf(tmp,"%s%s",article_text[loop],article_text[loop+1]);
    else strcpy(tmp,article_text[loop]);
    if (do_check_equal(tmp,pattern,casesense)) break;
  }
  if (loop==start) { geterror(fac,NEWS$_PNF); return; }
  if (loop<start) sprintf(tmp,"UP %d",start-loop);
  else sprintf(tmp,"DOWN %d",loop-start);
  cli$dcl_parse(c$dsc(tmp),&news_table,0,0,0); cli$dispatch();
}

/******************************************************************************/

cmd_exit()
{
  int i;
  char txt[256];
  FILE *fd;

  i=(internal_mode<0)?(-internal_mode)&3:internal_mode&3;
  if ((i==2 || i==3) && groups[grouppos].registered) group_save_parser(grouppos,"");
  if (write_resource(TRUE)) {
    strcpy(txt,get_file()); strcat(txt,"_tmp"); delete(txt);
    printf("\n");
    do_exit();
  }
}

/******************************************************************************/

cmd_quit()
{
  uword key;

  key=read_key(kbd_id,"Really Quit ? [Y]",input_id);
  if (key==SMG$K_TRM_UPPERCASE_N || key==SMG$K_TRM_LOWERCASE_N) return;
  if (key==SMG$K_TRM_UPPERCASE_X || key==SMG$K_TRM_LOWERCASE_X) cmd_exit();
  do_exit();
}

/******************************************************************************/

cmd_reread()
{
  bool flag;
  char tmp[256];
  globalvalue int NEWS$_REREAD;

  geterror(fac,NEWS$_REREAD);
  if (internal_mode!=1)
    if (groups[grouppos].registered) group_save_parser(grouppos);
  write_resource(FALSE);
  strcpy(tmp,actual_time); flag=newgr; newgr=FALSE;
  groupanz=0;
  news_start(TRUE);
  strcpy(actual_time,tmp); newgr=flag;
  groupscreen=grouppos=newsgroups_next(-1,1);
  internal_mode= -1;
}

/******************************************************************************/

cmd_dir()
{
  bool grps,articles,reg,all,used,unread,ptn;
  int i,j,k,n_pattern;
  char result[256]="\0", *pattern[128], *pt;
  uword retlen;
  globalvalue int NEWS$_IVDIRQL,NEWS$_IVDIRGRP,NEWS$_IVDIRART,NEWS$_IVDIRUNR,
		  NEWS$_IVDIRPTN;

  grps    =(cli$present(c$dsc("GROUPS"))==CLI$_PRESENT);
  articles=(cli$present(c$dsc("ARTICLES"))==CLI$_PRESENT);
  reg     =(cli$present(c$dsc("REGISTERED"))==CLI$_PRESENT);
  all     =(cli$present(c$dsc("ALL"))==CLI$_PRESENT);
  used    =(cli$present(c$dsc("USED"))==CLI$_PRESENT);
  unread  =(cli$present(c$dsc("UNREAD"))==CLI$_PRESENT);
  ptn     =(cli$present(c$dsc("Pattern"))==CLI$_PRESENT);

  if (unread) reg=TRUE;
  if (ptn || reg || all || used || unread) grps=TRUE;
  if (!ptn && (grps || reg || all || used || unread)) pattern_mode = FALSE;

  if (internal_mode == 1 && ptn) {
    for (i=0;i<groupanz;i++)
      groups[i].pattern = TRUE;
    c$cks(cli$get_value(c$dsc("Pattern"),c$ldsc(result,256),&retlen));
    result[retlen]='\0';
    for(i=0; i<retlen; i++)
      result[i] = tolower(result[i]);
    n_pattern = 0;
    for(i=0; i<retlen;) {
      pattern[n_pattern] = &result[i];
      while(*pattern[n_pattern] == ' ' || *pattern[n_pattern] == '*'
            || *pattern[n_pattern] == '\0')
            i++;
      while(i < retlen && result[i] != '*' && result[i] != '\0') i++;
      result[i] = '\0';
      n_pattern ++; i++;
    }
    if (n_pattern > 0) {
      for (i=0; i < groupanz; i++) {
        pt = groups[i].name;
        for (j=0; j < n_pattern; j++) {
          pt = strstr(pt, pattern[j]);
          if (pt == NIL) {
            groups[i].pattern = FALSE;
            break;
          }
          for (k=0; pattern[j][k] != '\0'; k++)
            pt ++;
          pt ++;
        }
      }
    }
  }

  if (!grps && !articles) internal_mode*= -1;
  if (grps) internal_mode= -1;
  if (articles) switch (internal_mode) {
    case 1: geterror(fac,NEWS$_IVDIRQL); break;
    case 2: group_redraw(subjectscreen,articlepos,TRUE); break;
    case 3: internal_mode*= -1; break;
    default: break;
  }
  if (ptn || reg || used || unread) {
    j=newsgroups_diff(groupscreen,grouppos);
    if (reg) registered_mode=TRUE;
    if (used) allgroups_mode=FALSE;
    if (unread) unreadonly_mode=TRUE;
    if (ptn) pattern_mode=TRUE;
    if ((!groups[grouppos].registered && registered_mode) ||
        (groups[grouppos].articles==0 && !allgroups_mode) ||
        (groups[grouppos].unread==0 && unreadonly_mode) ||
        (!groups[grouppos].pattern && pattern_mode)) {
      i=newsgroups_next(grouppos,1); if (i<0) i=newsgroups_last(grouppos,1);
    } else i=grouppos;
    if (i>=0) {
      grouppos=i;
      groupscreen=(j<=0)?grouppos:newsgroups_last(grouppos,j);
      if (groupscreen<0) groupscreen=grouppos;
    } else {
      if (reg) { registered_mode=FALSE; geterror(fac,NEWS$_IVDIRGRP); }
      if (ptn) { pattern_mode=FALSE; geterror(fac,NEWS$_IVDIRPTN); }
      if (used) { allgroups_mode=TRUE; geterror(fac,NEWS$_IVDIRART); }
      if (unread) { unreadonly_mode=TRUE; geterror(fac,NEWS$_IVDIRUNR); }
    }
  }
  if (all) {
    i=newsgroups_diff(groupscreen,grouppos);
    registered_mode=FALSE; allgroups_mode=TRUE; unreadonly_mode=FALSE;
    pattern_mode=FALSE;
    groupscreen=(i==0)?grouppos:newsgroups_last(grouppos,i);
  }
}

/******************************************************************************/

cmd_register()
{
  char result[256],txt[256],*ptr,*tp;
  uword retlen,key;
  int i,matches=0;
  struct dsc$descriptor *desc1,*desc2;

  if (cli$present(c$dsc("GroupName"))==CLI$_ABSENT) {
    if (!groups[grouppos].registered) matches++;
    groups[grouppos].registered=TRUE;
    if (internal_mode==1) groups[grouppos].unread=groups[grouppos].articles;
    else groups[grouppos].unread=articleanz;
    result[0]='\0';
  } else {
    c$cks(cli$get_value(c$dsc("GroupName"),c$ldsc(result,256),&retlen));
    result[retlen]='\0';
    if (strchr(result,'*')) {
      sprintf(txt,"Select really all '%s' ? [Y]",result);
      key=read_key(kbd_id,txt,input_id);
      if (key==SMG$K_TRM_UPPERCASE_N || key==SMG$K_TRM_LOWERCASE_N) return;
    }
    inp_comment("[Searching the list of newsgroups]");
    desc1=c$dsc(txt); desc2=c$dsc(result);
    for(i=0;i<groupanz;i++) {
      ptr=txt; tp=groups[i].name; while(*tp) { *ptr=upcase(*tp); ptr++; tp++; }
      *ptr='\0'; desc1->dsc$w_length=strlen(txt);
      if (str$match_wild(desc1,desc2)==STR$_MATCH || !strcmp(txt,result)) {
        if (!groups[i].registered) matches++;
        groups[i].registered=TRUE;
        if (internal_mode==1) groups[grouppos].unread=groups[grouppos].articles;
        else groups[grouppos].unread=articleanz;
      }
    }
  }
  inp_comment("[Subscribed to %d new newsgroups]",matches);
  switch (internal_mode) {
    case 1:
      if (registered_mode) {
        if (newsgroups_diff(groupscreen,grouppos)>xROWS-5) {
          groupscreen=newsgroups_last(grouppos,xROWS-5);
          if (groupscreen<0) groupscreen=grouppos;
        }
        newsgroups_header(FALSE);
      } else {
        newsgroups_header(FALSE);
        cli$dcl_parse(c$dsc("DOWN 1"),&news_table,0,0,0); cli$dispatch();
      }
      break;
    case 2:
      group_redraw(subjectscreen,articlepos,FALSE); break;
    case 3:
      break;
  }
}

/******************************************************************************/

cmd_deregister()
{
  char result[256],txt[256],*ptr,*tp;
  uword retlen,key;
  int i,matches=0;
  bool all;
  struct dsc$descriptor *desc1,*desc2;
  globalvalue int NEWS$_DEREGALL;

  if (all=(cli$present(c$dsc("ALL"))==CLI$_PRESENT)) strcpy(result,"*");
  if (!all && cli$present(c$dsc("GroupName"))==CLI$_ABSENT) {
    if (groups[grouppos].registered) matches++;
    groups[grouppos].registered=FALSE;
    groups[grouppos].unread=groups[grouppos].articles;
  } else {
    if (!all) {
      c$cks(cli$get_value(c$dsc("GroupName"),c$ldsc(result,256),&retlen));
      result[retlen]='\0';
    }
    if (strchr(result,'*')) {
      sprintf(txt,"Remove really all '%s' ? [Y]",result);
      key=read_key(kbd_id,txt,input_id);
      if (key==SMG$K_TRM_UPPERCASE_N || key==SMG$K_TRM_LOWERCASE_N) return;
    }
    inp_comment("[Searching the list of newsgroups]");
    desc1=c$dsc(txt); desc2=c$dsc(result);
    for(i=0;i<groupanz;i++) {
      ptr=txt; tp=groups[i].name; while(*tp) { *ptr=upcase(*tp); ptr++; tp++; }
      *ptr='\0'; desc1->dsc$w_length=strlen(txt);
      if (str$match_wild(desc1,desc2)==STR$_MATCH || !strcmp(txt,result)) {
        if (groups[i].registered && groups[i].read_art!=NIL) { free(groups[i].read_art); groups[i].read_art=NIL; }
        if (groups[i].registered) matches++;
        groups[i].registered=FALSE;
        groups[i].read_art=NIL;
        groups[i].unread=groups[i].articles;
      }
    }
  }
  inp_comment("[Unsubscribed from %d newsgroups]",matches);
  switch (internal_mode) {
    case 1:
      if (registered_mode && newsgroups_next(-1,1)<0) {
        registered_mode=FALSE; geterror(fac,NEWS$_DEREGALL);
        groupscreen=(grouppos==0)?0:newsgroups_last(grouppos,xROWS-5);
      }
      if (registered_mode) {
        if (!groups[grouppos].registered) {
          i=newsgroups_next(grouppos,1);
          grouppos=(i>=0)?i:newsgroups_last(grouppos,1);
        }
        if (newsgroups_diff(groupscreen,grouppos)>xROWS-5 || !groups[groupscreen].registered) {
          groupscreen=newsgroups_last(grouppos,xROWS-5);
          if (groupscreen<0) groupscreen=grouppos;
        }
        newsgroups_header(TRUE);
      } else {
        newsgroups_header(FALSE);
        cli$dcl_parse(c$dsc("DOWN 1"),&news_table,0,0,0); cli$dispatch();
      }
      break;
    case 2:
      group_redraw(subjectscreen,articlepos,FALSE); break;
    case 3:
      break;
  }
}

/******************************************************************************/

cmd_next()
{
  bool follow,author,unread;
  int value;
  char t[256],t2[256],*tp;
  globalvalue int NEWS$_NOFLWUP,NEWS$_IVFLWAUTH,NEWS$_NOFLWAUTH,NEWS$_IVNXT,NEWS$_LASTART;

  follow=(cli$present(c$dsc("FOLLOWUP"))==CLI$_PRESENT);
  author=(cli$present(c$dsc("AUTHOR"))==CLI$_PRESENT);
  unread=(cli$present(c$dsc("UNREAD"))==CLI$_PRESENT);
  if (unread) { internal_mode|=0x10; return; }
  if ((follow || author) && internal_mode!=1) {
    if (follow) {
      strcpy(tp=t,articles[articlepos].subject);
      while (TRUE) {
        if (strlen(tp)<3) break;
        if (upcase(*tp)=='R' && upcase(*(tp+1))=='E' &&
            (*(tp+2)==':' || *(tp+2)=='^')) {
          tp+=3; while (*tp && *tp!=' ') tp++; whilespace(tp);
        } else break;
      }
      sprintf(t2,"*%s",tp); value=articlepos+1;
      while (value<articleanz) {
        if (str$match_wild(c$dsc(articles[value].subject),c$dsc(t2))==STR$_MATCH) break;
        if (!strcmp(tp,articles[value].subject)) break;
        value++;
      }
      if (value<articleanz) value-=articlepos;
      else { geterror(fac,NEWS$_NOFLWUP); return; }
    } else {
      if (articles[articlepos].from==NIL) { geterror(fac,NEWS$_IVFLWAUTH); return; }
      strcpy(tp=t,articles[articlepos].from);
      while (*tp && *tp!=' ') tp++; *tp='\0';
      value=articlepos+1;
      while (value<articleanz) {
        if (!strincmp(articles[value].from,t,strlen(t))) break;
        value++;
      }
      if (value<articleanz) value-=articlepos;
      else { geterror(fac,NEWS$_NOFLWAUTH); return; }
    }
  } else value=1;
  sprintf(t,"DOWN %d",value);
  switch (internal_mode) {
    case 1:
      geterror(fac,NEWS$_IVNXT); break;
    case 2:
      cli$dcl_parse(c$dsc(t),&news_table,0,0,0); cli$dispatch();
      break;
    case 3:
      if (articlepos<articleanz-value) {
        articlepos+=value;
        if (articlepos-subjectscreen>xROWS-5) subjectscreen+=value;
        article_end();
        article_header();
        if(!article_start(articles[articlepos].number)) {
          cli$dcl_parse(c$dsc("DIR"),&news_table,0,0,0); cli$dispatch();
          return;
        }
        articlescreen=article_top;
        article_redraw(articlescreen);
      } else geterror(fac,NEWS$_LASTART);
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_last()
{
  int i;
  bool rd;
  char tmp[256];
  globalvalue int NEWS$_IVLST,NEWS$_FRSTART,NEWS$_NOLST;

  rd = (cli$present(c$dsc("READ"))==CLI$_PRESENT);
  switch (internal_mode) {
    case 1:
      geterror(fac,NEWS$_IVLST); break;
    case 2:
      if (old_read== -1 && rd) { geterror(fac,NEWS$_NOLST); break; }
      if (rd) {
        sprintf(tmp,"GO %d",old_read);
        old_read= -1;
        cli$dcl_parse(c$dsc(tmp),&news_table,0,0,0);
      } else cli$dcl_parse(c$dsc("UP 1"),&news_table,0,0,0);
      cli$dispatch();
      break;
    case 3:
      if (rd) {
        if (old_read== -1) { geterror(fac,NEWS$_NOLST); break; }
        i=0; while (articles[i].number!=old_read) i++;
        articlepos=i; old_read= -1;
        if (articlepos<subjectscreen) subjectscreen=articlepos;
        if (articlepos-xROWS-4>subjectscreen) subjectscreen=articlepos-xROWS-4;
        article_end();
        article_header();
        if(!article_start(articles[articlepos].number)) {
          cli$dcl_parse(c$dsc("DIR"),&news_table,0,0,0); cli$dispatch();
          return;
        }
        articlescreen=article_top;
        article_redraw(articlescreen);
      }
      if (articlepos) {
        articlepos--; if (articlepos<subjectscreen) subjectscreen--;
        article_end();
        article_header();
        if(!article_start(articles[articlepos].number)) {
          cli$dcl_parse(c$dsc("DIR"),&news_table,0,0,0); cli$dispatch();
          return;
        }
        articlescreen=article_top;
        article_redraw(articlescreen);
      } else geterror(fac,NEWS$_FRSTART);
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_rotate()
{
  int i;
  globalvalue int NEWS$_IVROT;

  if (internal_mode!=3) { geterror(fac,NEWS$_IVROT); return; }
  for (i=0;i<article_lines;i++) rot13(article_text[i]);
  article_redraw(articlescreen);
}

/******************************************************************************/

do_save(num,name)
int num;
char *name;
{
  char txt[256];
  globalvalue int NEWS$_SAVAPND,NEWS$_SAVWRT,NEWS$_IVSAVFIL;

  if (save_fd=fopen(name,cli$present(c$dsc("APPEND"))==CLI$_NEGATED?"w":"a")) {
    sprintf(txt,"%d",articles[num].number);
    strcpy(fao2,c$asc(name)); strcpy(fao,c$asc(txt));
    if (ftell(save_fd)) {
      geterror(fac,NEWS$_SAVAPND,fao,fao2);
      fprintf(save_fd,"\n");
      fprintf(save_fd,"+---+ appended article #%d ---\n",articles[num].number);
      fprintf(save_fd,"\f\n");
    } else { geterror(fac,NEWS$_SAVWRT,fao,fao2); }
    do_savearticle=TRUE;
    sprintf(txt,"%s %d\r\n",CMD_ARTICLE,articles[num].number);
    do_send(txt); nntp_data.article++;
    while (do_savearticle) wait_sync();
    articles[num].unread=FALSE;
    return(TRUE);
  } else {
    strcpy(fao,c$asc(name)); geterror(fac,NEWS$_IVSAVFIL,fao); fclose(save_fd);
    return(FALSE);
  }
}

/******************************************************************************/

bool do_check_equal(txt,pattern,sensitive)
char *txt,*pattern;
bool sensitive;
{
  char txt1[256],txt2[256];

  if (!*pattern || !*txt) return (FALSE);
  if (!sensitive) {
    strcpy(txt1,txt); strcpy(txt2,pattern);
  } else {
    c$cks(str$upcase(c$ldsc(txt1,255),c$dsc(txt))); txt1[strlen(txt)]='\0';
    c$cks(str$upcase(c$ldsc(txt2,255),c$dsc(pattern))); txt2[strlen(pattern)]='\0';
  }
  if (str$match_wild(c$dsc(txt1),c$dsc(txt2))==STR$_MATCH) return (TRUE);
  if (!strcmp(txt1,txt2)) return (TRUE);
  return (FALSE);
}

/******************************************************************************/

cmd_save()
{
  char result[256],subject[256],author[256]="\0",*txtp;
  uword retlen;
  char result_a[256]="\0", *tp, ch;
  int i, start, fin;
  bool all,unread,flag,casesense;
  globalvalue int NEWS$_IVSAV, NEWS$_IVSAVRNG, NEWS$_IVSAVCHR, NEWS$_IVSAVITEM;

  all=(cli$present(c$dsc("ALL"))==CLI$_PRESENT);
  unread=(cli$present(c$dsc("UNREAD"))==CLI$_PRESENT);
  if (cli$present(c$dsc("SUBJECT"))==CLI$_PRESENT) {
    c$cks(cli$get_value(c$dsc("SUBJECT"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; casesense=FALSE;
    if (result[0]=='"') {
      casesense=TRUE;
      result[strlen(result)-1]='\0'; strcpy(subject,&result[1]);
    }
    else strcpy(subject,result);
    if (!all && !unread) unread=TRUE;
  }
  if (cli$present(c$dsc("AUTHOR"))==CLI$_PRESENT) {
    c$cks(cli$get_value(c$dsc("SUBJECT"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; casesense=FALSE;
    if (result[0]=='"') {
      casesense=TRUE;
      result[strlen(result)-1]='\0'; strcpy(author,&result[1]);
    }
    else strcpy(author,result);
    if (!all && !unread) unread=TRUE;
  }
  if (internal_mode==1) geterror(fac,NEWS$_IVSAV);
  else {
    if (author[0]!='\0' && articles[0].from==NIL) xhdr_call("from",0,0,TRUE);
    if (cli$present(c$dsc("Name"))==CLI$_ABSENT) {
      strcpy(result,groups[grouppos].name);
      txtp=result; while (*txtp) { if (*txtp=='.') *txtp='_'; txtp++; }
      strcat(result,".LIS");
    } else {
      c$cks(cli$get_value(c$dsc("Name"),c$ldsc(result,256),&retlen));
      result[retlen]='\0';
    }
    if (!all && !unread) {
      if (cli$present(c$dsc("Area"))==CLI$_ABSENT) {
        do_save(articlepos,result);
      } else {
        c$cks(cli$get_value(c$dsc("Area"),c$ldsc(result_a,256),&retlen));
        result_a[retlen]='\0'; tp=result_a;
        if (!strcmp(result_a,"-")) { geterror(fac,NEWS$_IVSAVRNG); return; }
        while (*tp && (isdigit(*tp) || *tp=='-')) tp++;
        if (*tp) { geterror(fac,NEWS$_IVSAVCHR); return; }
        if (tp=strchr(result_a,'-')) 
	  if (strchr(tp+1,'-')) { geterror(fac,NEWS$_IVSAVCHR); return; }
        tp=result_a;
        if (result_a[0]=='-') { start=0; ch='-'; tp++; }
        else {
          while (*tp && *tp!='-') tp++;
          ch= *tp; *tp='\0'; start=search_article(atoi(result_a));
	  if (start == -1) {
	    strcpy(fao,c$asc(result_a));
	    geterror(fac,NEWS$_IVSAVITEM,fao);
	    return(FALSE);
          }
          tp++;
        }
        if (ch=='-' && *tp) {
	  fin=search_article(atoi(tp));
	  if (fin == -1) {
	    strcpy(fao,c$asc(tp));
	    geterror(fac,NEWS$_IVSAVITEM,fao);
	    return(FALSE);
          }
        } else fin=articleanz-1;
        i=start; while (i <= fin && do_save(i,result)) i++;
      }
    }
    if (all) {
      i=0; flag=TRUE; while (i<articleanz && flag) {
        if ((!*author && !*subject) ||
            (*author && do_check_equal(articles[i].from,author,casesense)) ||
            (*subject && do_check_equal(articles[i].subject,subject,casesense)))
          flag=do_save(i,result);
        i++;
      }
    }
    if (unread) {
      i=0;
      while (i<articleanz) {
        if (articles[i].unread && ((!*author && !*subject) ||
           (*author && do_check_equal(articles[i].from,author,casesense)) ||
           (*subject && do_check_equal(articles[i].subject,subject,casesense))))
          if (!do_save(i,result)) break;
        i++;
      }
    }
  }
  if (internal_mode==2) group_redraw(subjectscreen,articlepos,FALSE);
}

/******************************************************************************/
int search_article(num)
int num;
{
  int n;
  for (n=0; n<articleanz; n++) {
    if (num == articles[n].number)
      return(n);
  }
  return(-1);
}

/******************************************************************************/

cmd_edit()
{
  char result[256]="\0",t[256];
  bool flag=FALSE;
  uword retlen;
  int i;
  globalvalue int NEWS$_IVEDT,NEWS$_IVCMD;


  if (noscr) { geterror(fac,NEWS$_IVCMD); return; }
  if (internal_mode==1) { geterror(fac,NEWS$_IVEDT); return; }
  if (cli$present(c$dsc("Filename"))==CLI$_PRESENT) {
    c$cks(cli$get_value(c$dsc("Filename"),c$ldsc(result,256),&retlen));
    result[retlen]='\0';
  } else {
    i=JPI$_PID; flag=TRUE;
    c$cks(lib$getjpi(&i,0,0,0,c$ldsc(t,10),&retlen)); t[retlen]='\0';
    sprintf(result,"sys$scratch:news_edit_%s.tmp",t);
  }
  sprintf(t,"SAVE %s",result);
  cli$dcl_parse(c$dsc(t),&news_table,0,0,0); cli$dispatch();
  i=call_editor(result);
  if (flag) { delete(result); delete(result); }
}

/******************************************************************************/

cmd_mark()
{
  char result[256]="\0",*tp,ch,txt[16],t[256],auth[256],pattern[256]="\0";
  uword retlen,key;
  int start,fin,i,j=0;
  bool all=FALSE,mark,subject,author,casesense,area_exist=FALSE;
  globalvalue int NEWS$_IVSKP,NEWS$_IVMRK,NEWS$_MRKD,NEWS$_IVMRKITEM,
	NEWS$_IVSKPAUTH,NEWS$_IVMRKRNG,NEWS$_IVMRKCHR;

  subject=(cli$present(c$dsc("SUBJECT"))==CLI$_PRESENT);
  author=(cli$present(c$dsc("AUTHOR"))==CLI$_PRESENT);
  area_exist=(cli$present(c$dsc("Area"))==CLI$_PRESENT);
  if ((subject || author) && internal_mode==1) { geterror(fac,NEWS$_IVSKP); return; }
  mark= !(cli$present(c$dsc("READ"))==CLI$_NEGATED);
  if (cli$present(c$dsc("UNREAD"))==CLI$_PRESENT) mark=FALSE;
  if (cli$present(c$dsc("PATTERN"))==CLI$_PRESENT) {
    c$cks(cli$get_value(c$dsc("PATTERN"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; casesense=FALSE;
    if (result[0]=='"') {
      casesense=TRUE;
      result[strlen(result)-1]='\0'; strcpy(pattern,&result[1]);
    }
    else strcpy(pattern,result);
  }
  if (*pattern && internal_mode==1) { geterror(fac,NEWS$_IVSKP); return; }
  if (!area_exist) {
    if (subject) {
      strcpy(tp=result,articles[articlepos].subject);
      while (TRUE) {
        if (strlen(tp)<3) break;
        if (upcase(*tp)=='R' && upcase(*(tp+1))=='E' &&
            (*(tp+2)==':' || *(tp+2)=='^')) {
          tp+=3; while (*tp && *tp!=' ') tp++; whilespace(tp);
        } else break;
      }
      sprintf(t,"*%s",tp);
    } else if (author) {
      if (articles[articlepos].from==NIL) { geterror(fac,NEWS$_IVSKPAUTH); return; }
      strcpy(tp=auth,articles[articlepos].from);
      while (*tp && *tp!=' ') tp++; if (*tp) *tp='\0';
    } else {
      all=(cli$present(c$dsc("ALL"))==CLI$_PRESENT);
      if (all) { start=0; fin=articleanz-1; }
      else {area_exist = TRUE; start=fin=articlepos;}
    }
  } else {
    c$cks(cli$get_value(c$dsc("Area"),c$ldsc(result,256),&retlen));
    result[retlen]='\0'; tp=result;
    if (!strcmp(result,"-")) { geterror(fac,NEWS$_IVMRKRNG); return; }
    while (*tp && (isdigit(*tp) || *tp=='-')) tp++;
    if (*tp) { geterror(fac,NEWS$_IVMRKCHR); return; }
    if (tp=strchr(result,'-')) if (strchr(tp+1,'-')) { geterror(fac,NEWS$_IVMRKCHR); return; }
    tp=result;
    if (result[0]=='-') { start=0; ch='-'; tp++; }
    else {
      while (*tp && *tp!='-') tp++;
      ch= *tp; *tp='\0'; start=search_article(atoi(result));
	  if (start == -1) {
	    strcpy(fao,c$asc(result));
	    geterror(fac,NEWS$_IVMRKITEM,fao);
	    return(FALSE);
          }
          tp++;
    }
    if (ch=='-' && *tp) {
      fin=search_article(atoi(tp));
      if (fin == -1) {
	strcpy(fao,c$asc(tp));
	geterror(fac,NEWS$_IVMRKITEM,fao);
	return(FALSE);
      }
    } else fin=articleanz-1;
  }
  switch (internal_mode) {
    case 1:
      if (*result) { geterror(fac,NEWS$_IVMRK); return; }
      if (all) {
        key=read_key(kbd_id,"MARK really all groups ? [Y]",input_id);
        if (key==SMG$K_TRM_UPPERCASE_N || key==SMG$K_TRM_LOWERCASE_N) break;
      }
      for(i=0;i<groupanz;i++) {
        sprintf(txt,"<%d",groups[i].finish);
        if (groups[i].registered && (all || i==grouppos)) {
          if (groups[i].read_art!=NIL) { free(groups[i].read_art); groups[i].read_art=NIL; }
          if (groups[i].finish>=groups[i].use_start && mark) {
            strcpy(groups[i].read_art=malloc(strlen(txt)+1),txt);
            groups[i].unread=0;
          } else {
            groups[i].read_art=NIL;
            groups[i].unread=groups[i].articles;
          }
        }
      }
      i=newsgroups_next(grouppos,1);
      if (i<0) {
        if (unreadonly_mode) i=newsgroups_last(grouppos,1);
        else i=grouppos;
      }
      if (i<0) {
        if (unreadonly_mode) unreadonly_mode=FALSE;
        groupscreen=grouppos=newsgroups_next(-1,1);
      } else {
        if (groupscreen>grouppos) groupscreen=i;
        j=newsgroups_next(groupscreen,xROWS-5);
        if (j>=0 && j<i) groupscreen=newsgroups_next(groupscreen,1);
        grouppos=i;
      }
      newsgroups_header(FALSE);
      break;
    case 2:
      for(i=0;i<articleanz;i++)
        if (all || (area_exist && i>=start && i<=fin) ||
	  (*pattern && do_check_equal(articles[i].subject,pattern,casesense)) ||
            (author && !strincmp(articles[i].from,auth,strlen(auth))) ||
            (subject && (!strcmp(&t[1],articles[i].subject) ||
             str$match_wild(c$dsc(articles[i].subject),c$dsc(t))==STR$_MATCH))) {
          if (articles[i].unread==mark) j++; articles[i].unread= !mark; }
      geterror(fac,NEWS$_MRKD,j);
      group_redraw(subjectscreen,articlepos,FALSE);
      subjectscreen=group_down(subjectscreen,1);
      break;
    case 3:
      for(i=0;i<articleanz;i++)
        if (all || (area_exist && i>= start && i<=fin) ||
	  (*pattern && do_check_equal(articles[i].subject,pattern,casesense)) ||
            (author && !strincmp(articles[i].from,auth,strlen(auth))) ||
            (subject && (!strcmp(&t[1],articles[i].subject) ||
             str$match_wild(c$dsc(articles[i].subject),c$dsc(t))==STR$_MATCH))) {
          if (articles[i].unread==mark) j++; articles[i].unread= !mark; }
      geterror(fac,NEWS$_MRKD,j);
      break;
    default:
      break;
  }
}

/******************************************************************************/

cmd_enter()
{
  bool new;
  globalvalue NEWS$_IVENT;

  if (internal_mode!=1) { geterror(fac,NEWS$_IVENT); return; }
  new=(cli$present(c$dsc("NEW"))==CLI$_PRESENT);
  if (conf[NEWS_NUM_GROUPMODE].value) new=TRUE;
  if (cli$present(c$dsc("NEW"))==CLI$_NEGATED) new=FALSE;
  internal_mode2=(new?2:1);
}

/******************************************************************************/
