/******************************************************************************
 *
 * VMS NEWS (part DATA)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * DATA definitions (variables)
 * ----------------------------------------------------------------------------
 *            int stricmp(char *src1,char *src2)
 *            int strincmp(char *src1,char *src2,int cnt)
 *            int compare(GrpList *a,GrpList *b)
 *            int compare2(ArtList *a,ArtList *b)
 *            int compare3(TmpArtList *a,TmpArtList *b)
 *           bool in_ast()
 *           int *c$alloc_tmp(int size)
 * dsc$descriptor c$dsc(char *c$_str)
 * dsc$descriptor c$ldsc(char *c$_str,int c$_len)
 *          char *c$asc(char *c$_str)
 *            int c$cks(int c$_status)
 *          char *rot13(char *line)
 *          char *get_path()
 *          char *get_file()
 *          char *get_conf()
 *          char *get_kill()
 *          char *get_date()
 *          char *get_time()
 *          char *geterror(va_alist)
 *            int establish(unsigned int sigargs[],unsigned int mechargs[])
 *                cli_handle(uword key)
 *                inp_comment(va_alist)
 *                clock_ast()
 *                clock_handle(bool flag)
 *                display_order()
 *                do_send(char *text)
 *                write_killfile()
 *                read_killfile()
 *                flag_description()
 * (optional)     traceback(status)
 *
 ******************************************************************************/

#module DATA "SYS V1.24"
#include "header.h"
#include <rmsdef.h>
#include <jpidef.h>
#include <varargs.h>

globalref int news_table;

/******************************************************************************/

#define GBL	globaldef
#define GBLSTR	globaldef struct

GBL bool	noscr,				/* FLag: SMG/Dump mode */
                all_article,                    /* Flag: Show ALL articles */
		newgr,				/* Flag: Show NEW groups */
		newsmgr,			/* Flag: Is NEWS MANAGER */
		restricted,			/* Flag: Restricted account */
		print_flag=FALSE,		/* Flag: Print on exit */
		decnet=FALSE,			/* Flag: DECnet transport */
		fac,				/* Error facility */
		clock_disp=0;			/* Diplay mode in Clock AST */
GBL char	fao[256],fao2[256];		/* Temp. space for FAO */
GBL int		errcnt=0;			/* Number of errors occured */
GBL long	clock_id=0;			/* ID of Clock AST */
GBL quad	clock_time={0,0};		/* Startvalue of Clock AST */
GBL uword	net_chan;			/* Network Channel */
GBL unsigned int iosb[2],			/* IO Status Block */
		read_iosb[2];			/* NetAST IO Status Block */
GBL int		net_chan_tcp=0;			/* TCP Flushmode */
GBL char	outl[NETBUFFER],		/* Network Buffer */
		*nr_pos=outl;			/* Pointer in Buffer */
GBL bool	do_netexit=FALSE;		/* Flag: Restart NetAST */
GBL ulong	xROWS,				/* Terminal ROWS */
		xCOLS,				/* Terminal COLUMNS */
		paste_id=0,			/* SMG-Pasteboard-ID */
		kbd_id=0,			/* SMG-Keyboard-ID */
		save_vd=0,			/* SMG-Virtual Screen Backup */
                header_id=0,			/* SMG-Display Headerline */
		text_id=0,			/* SMG-Display Textwindow */
		input_id=0,			/* SMG-Display Inputline */
		error_id=0,			/* SMG-Display Errorwindow */
		brdhdr_id=0,			/* SMG-Display BrdCst Header */
		brdcst_id=0;			/* SMG-Display for Broadcasts */
GBL bool	brdcst_active=FALSE,		/* Flag: Text/Brdcst-Window */
		posting=2,			/* Flag: Posting allowed */
		in_text_mode=FALSE,		/* Flag: NetAST receives text */
		post_status=NEWS_POST_OK,	/* POST command status values */
		xhdr_mode=FALSE,		/* Flag: XHDR command active */
		do_savearticle=FALSE,		/* Flag: Save article to file */
                do_newsgroups=FALSE,		/* Flag: Receive newsgroups */
		do_articlelist=FALSE,		/* Flag: Receive list of art. */
		do_getarticle=FALSE,		/* Flag: Receive article */
		do_ngroups=FALSE,		/* Flag: Receive newgroups */
		do_queryngroups=NEWS_NG_QUERY;	/* Flag: Query in rec. newsgr.*/
GBL FILE	*save_fd;			/* Filedescr. for SAVE art. */
GBL int		groupanz=0,			/* Total number of GROUPS */
                articleanz=0,			/* Total number of ARTICLES */
		grouppos=0,			/* Actual GROUP */
		oldanz=0,			/* Total number of last GROUP */
		old_read= -1,			/* Last read article */
		articlepos=0,			/* Actual ARTICLE */
		groupscreen=0,			/* GROUP on top of screen */
		subjectscreen=0,		/* ARTICLE on top of screen */
		articlescreen=0,		/* ART.-LINE on top of screen */
		header_lines=0,			/* # HEADER lines in article */
		article_lines=0,		/* # DATA lines in article */
		help_lines=0,			/* # HELP lines in help text */
		ngroups=0;			/* Newgroups Counter */
GBL char	actual_time[256]="\0",		/* Time used for NEWGROUPS */
		internal_mode=0,		/* Display mode (GRP,ART,TEXT)*/
		internal_mode2=0,		/* Group entry mode (NEW,ALL)*/
		prefix[256]="",			/* Prefix for group entry hack*/
		registered_mode=FALSE,		/* Flag: Display ALL/REG grps.*/
                pattern_mode=FALSE,             /* Flag: Display pattern grps.*/
		allgroups_mode=TRUE,		/* Flag: Display all/used grps*/
		unreadonly_mode=FALSE,		/* Flag: Display all/unrd.grps*/
		oldgroup[256]="",		/* Last GROUP */
		rcfile[256]="";			/* optional resource file */
GBL int		*header[MAXHEADER],		/* Pointer for article header */
		*article_text[MAXLINES],	/* Pointer for article text */
		*help[MAXHELP];			/* Pointer for help text */
GBL int		disp_order[NEWS_MAX_CONFIG];	/* Display order SHOW PROFILE */
GBLSTR TCPdata	tcp_data;			/* TCP/IP connection data */
GBLSTR NNTPdata	nntp_data;			/* NNTP connection data */
GBLSTR Config	conf[NEWS_MAX_CONFIG],		/* Configuration array */
		userdefault[DEFAULT_MAX_CONFIG];/* Default answer array */
GBLSTR KillLine	kills[MAXKILL];			/* KILL data array */
GBLSTR GrpList	groups[MAXGROUPS];		/* GROUP data array */
GBLSTR ArtList	articles[MAXARTICLES];		/* ARTICLE data array */

#undef GBLSTR
#undef GBL

/******************************************************************************/

globaldef struct FunctionKeys fkeys[34] = {
{"HELP",	SMG$K_TRM_HELP,		"",0, 1, 1,""},
{"DO",		SMG$K_TRM_DO,		"",0, 1, 9,""},
{"FIND",	SMG$K_TRM_FIND,		"",0, 5, 1,""},
{"SELECT",	SMG$K_TRM_SELECT,	"",0, 8, 1,""},
{"INSERT",	SMG$K_TRM_INSERT_HERE,	"",0, 5, 9,""},
{"REMOVE",	SMG$K_TRM_REMOVE,	"",0, 5,17,""},
{"PREVIOUS",	SMG$K_TRM_PREV_SCREEN,	"",0, 8, 9,""},
{"NEXT",	SMG$K_TRM_NEXT_SCREEN,	"",0, 8,17,""},
{"UP",		SMG$K_TRM_UP,		"",0,11, 9,""},
{"LEFT",	SMG$K_TRM_LEFT,		"",0,14, 1,""},
{"DOWN",	SMG$K_TRM_DOWN,		"",0,14, 9,""},
{"RIGHT",	SMG$K_TRM_RIGHT,	"",0,14,17,""},
{"F17",		SMG$K_TRM_F17,		"",0, 1,28,""},
{"F18",		SMG$K_TRM_F18,		"",0, 1,36,""},
{"F19",		SMG$K_TRM_F19,		"",0, 1,44,""},
{"F20",		SMG$K_TRM_F20,		"",0, 1,52,""},
{"PF1",		SMG$K_TRM_PF1,		"",0, 5,28,""},
{"PF2",		SMG$K_TRM_PF2,		"",0, 5,36,""},
{"PF3",		SMG$K_TRM_PF3,		"",0, 5,44,""},
{"PF4",		SMG$K_TRM_PF4,		"",0, 5,52,""},
{"KP0",		SMG$K_TRM_KP0,		"",0,17,28,""},
{"KP1",		SMG$K_TRM_KP1,		"",0,14,28,""},
{"KP2",		SMG$K_TRM_KP2,		"",0,14,36,""},
{"KP3",		SMG$K_TRM_KP3,		"",0,14,44,""},
{"KP4",		SMG$K_TRM_KP4,		"",0,11,28,""},
{"KP5",		SMG$K_TRM_KP5,		"",0,11,36,""},
{"KP6",		SMG$K_TRM_KP6,		"",0,11,44,""},
{"KP7",		SMG$K_TRM_KP7,		"",0, 8,28,""},
{"KP8",		SMG$K_TRM_KP8,		"",0, 8,36,""},
{"KP9",		SMG$K_TRM_KP9,		"",0, 8,44,""},
{"ENTER",	SMG$K_TRM_ENTER,	"",0,14,52,""},
{"PERIOD",	SMG$K_TRM_PERIOD,	"",0,17,44,""},
{"COMMA",	SMG$K_TRM_COMMA,	"",0,11,52,""},
{"MINUS",	SMG$K_TRM_MINUS,	"",0, 8,52,""}
};

/******************************************************************************/

int stricmp(src1,src2)
char *src1,*src2;
{
  while(*src1) {
    if (!(*src2)) return(upcase(*src1));
    if (upcase(*src1)!=upcase(*src2))
      return(upcase(*src1)-upcase(*src2));
    src1++; src2++;
  }
  return(-upcase(*src2));
}

/******************************************************************************/

int strincmp(src1,src2,cnt)
char *src1,*src2;
int cnt;
{
  while(*src1 && cnt--) {
    if (!*src2) return(upcase(*src1));
    if (upcase(*src1) != upcase(*src2))
      return(upcase(*src1)-upcase(*src2));
    src1++; src2++;
  }
  return(cnt?-upcase(*src2):0);
}

/******************************************************************************/

int compare(a,b)
struct GrpList *a,*b;
{
  return strcmp(a->name,b->name);
}

/******************************************************************************/

int compare2(a,b)
struct ArtList *a,*b;
{
  char *tp1,*tp2;

  tp1= a->subject;
  tp2= b->subject;
  while (TRUE) {
    if (strlen(tp1)<3) break;
    if (upcase(*tp1)=='R' && upcase(*(tp1+1))=='E' &&
        (*(tp1+2)==':' || *(tp1+2)=='^')) {
      tp1+=3; while (*tp1 && *tp1!=' ') tp1++; whilespace(tp1);
    } else break;
  }
  while (TRUE) {
    if (strlen(tp2)<3) break;
    if (upcase(*tp2)=='R' && upcase(*(tp2+1))=='E' &&
        (*(tp2+2)==':' || *(tp2+2)=='^')) {
      tp2+=3; while (*tp2 && *tp2!=' ') tp2++; whilespace(tp2);
    } else break;
  }
  if (!stricmp(tp1,tp2)) return (a->number - b->number);
  return stricmp(tp1,tp2);
}

/******************************************************************************/

int compare3(a,b)
struct TmpArtList *a,*b;
{
  return (a->number - b->number);
}

/******************************************************************************/

bool in_ast()
{
  int i,erg;
  i=JPI$_ASTACT;
  lib$getjpi(&i,0,0,&erg,0,0);
  return (erg>0);
}

/******************************************************************************/

int *c$_tmphead = NIL;
int *c$_asthead = NIL;

int *c$alloc_tmp(size)
int size;
{
  int *tmp;

  if (in_ast()) {
    tmp=malloc(size+4); *tmp=c$_asthead; c$_asthead=tmp;
    return(c$_asthead+1);
  } else {
    tmp=malloc(size+4); *tmp=c$_tmphead; c$_tmphead=tmp;
    return(c$_tmphead+1);
  }
}

/*----------------------------------------------------------------------------*/

c$dsc(c$_str)
char *c$_str;
{
  struct dsc$descriptor *c$_tmpdesc;

  c$_tmpdesc=c$alloc_tmp(8);
  c$_tmpdesc->dsc$w_length = strlen(c$_str);
  c$_tmpdesc->dsc$b_dtype  = DSC$K_DTYPE_T;
  c$_tmpdesc->dsc$b_class  = DSC$K_CLASS_S;
  c$_tmpdesc->dsc$a_pointer= c$_str;
  return(c$_tmpdesc);
}

/*----------------------------------------------------------------------------*/

c$ldsc(c$_str,c$_len)
char *c$_str;
int c$_len;
{
  struct dsc$descriptor *c$_tmpdesc;

  c$_tmpdesc=c$alloc_tmp(8);
  c$_tmpdesc->dsc$w_length = c$_len;
  c$_tmpdesc->dsc$b_dtype  = DSC$K_DTYPE_T;
  c$_tmpdesc->dsc$b_class  = DSC$K_CLASS_S;
  c$_tmpdesc->dsc$a_pointer= c$_str;
  return(c$_tmpdesc);
}

/******************************************************************************/

char *c$asc(c$_str)
char *c$_str;
{
  char tmp[256];

  sprintf(tmp,"%c%s",strlen(c$_str),c$_str);
  return(tmp);
}

/******************************************************************************/

int c$cks(c$_status)
int c$_status;
{
  int *c$_tmp;

  if (!(c$_status&1) && c$_status!=SS$_ABORT) {
    lib$signal(c$_status); do_exit(); }
  if (in_ast()) while (c$_asthead!=NIL) {
      c$_tmp= *c$_asthead; free(c$_asthead); c$_asthead=c$_tmp; }
  else while (c$_tmphead!=NIL) {
      c$_tmp= *c$_tmphead; free(c$_tmphead); c$_tmphead=c$_tmp; }
  return(c$_status);
}

/******************************************************************************/

char *rot13(src)
char *src;
{
  char *p=src;
  while (*p) {
    *p = ('a' <= *p && *p <= 'm') || ('A' <= *p && *p <= 'M') ? *p+13 :
         ('n' <= *p && *p <= 'z') || ('N' <= *p && *p <= 'Z') ? *p-13 : *p;
    p++; }
  return(src);
}

/******************************************************************************/

char *get_path()
{
  char image[256],*ptr;
  uword imaglen,item;

  if (getenv("NEWS$DATA")!=NULL) strcpy(image,getenv("NEWS$DATA"));
  else {
    item=JPI$_IMAGNAME;
    c$cks(lib$getjpi(&item,0,0,0,c$ldsc(image,256),&imaglen)); image[imaglen]='\0';
    ptr=image+strlen(image); while (*ptr!=']' && *ptr!='>') ptr--; *(ptr+1)='\0';
  }
  return(image);
}

/******************************************************************************/

char *get_file()
{
  char *ptr;

  if (*rcfile) return(rcfile);
  if((ptr=getenv("NEWS$RC"))==NULL) ptr="sys$login:news.rc";
  return(ptr);
}

/******************************************************************************/

char *get_conf()
{
  char *ptr;

  if((ptr=getenv("NEWS$CONFIG"))==NULL) ptr="sys$login:news.config";
  return(ptr);
}

/******************************************************************************/

char *get_kill()
{
  char *ptr;

  if((ptr=getenv("NEWS$KILL"))==NULL) ptr="sys$login:news.kill";
  return(ptr);
}

/******************************************************************************/

char *get_date()
{
  uword timlen;
  char tim[256],erg[256],*ptr,*daytext;
  ulong day,i;

  c$cks(sys$asctim(&timlen,c$ldsc(tim,256),0,0)); tim[timlen]='\0';
  c$cks(lib$day_of_week(0,&day));
  switch (day) {
    case 1: daytext="Mon"; break;
    case 2: daytext="Tue"; break;
    case 3: daytext="Wed"; break;
    case 4: daytext="Thu"; break;
    case 5: daytext="Fri"; break;
    case 6: daytext="Sat"; break;
    case 7: daytext="Sun"; break;
  }
  strcpy(erg,daytext); ptr=erg+strlen(erg);
  *ptr++ =','; *ptr++ =' ';
  for (i=(tim[0]==' ')?1:0;i<2;i++) *ptr++ =tim[i];
  *ptr++ =' ';
  *ptr++ =tim[3];
  for (i=4;i<6;i++) *ptr++ =locase(tim[i]);
  *ptr++ =' ';
  for (i=7;i<20;i++) *ptr++ =tim[i];
  *ptr++ =' '; *ptr='\0';
  strcat(erg,conf[NEWS_NUM_TIMEZONE].text);
  return(erg);
}

/******************************************************************************/

char *get_time()
{
  uword timlen;
  char tim[256],erg[256],*ptr,mon[4];
  int i;

  c$cks(sys$asctim(&timlen,c$ldsc(tim,256),0,0)); tim[timlen]='\0';
  ptr=mon; for (i=3;i<6;i++) *ptr++ = tim[i]; *ptr='\0';
  ptr=erg;
  *ptr++ = tim[9]; *ptr++ = tim[10]; *ptr='\0'; ptr+=2;
  if (!strcmp("JAN",mon)) strcat(erg,"01");
  if (!strcmp("FEB",mon)) strcat(erg,"02");
  if (!strcmp("MAR",mon)) strcat(erg,"03");
  if (!strcmp("APR",mon)) strcat(erg,"04");
  if (!strcmp("MAY",mon)) strcat(erg,"05");
  if (!strcmp("JUN",mon)) strcat(erg,"06");
  if (!strcmp("JUL",mon)) strcat(erg,"07");
  if (!strcmp("AUG",mon)) strcat(erg,"08");
  if (!strcmp("SEP",mon)) strcat(erg,"09");
  if (!strcmp("OCT",mon)) strcat(erg,"10");
  if (!strcmp("NOV",mon)) strcat(erg,"11");
  if (!strcmp("DEC",mon)) strcat(erg,"12");
  *ptr++ = (tim[0]==' '?'0':tim[0]);  *ptr++ = tim[1];
  *ptr++ = ' ';
  *ptr++ = (tim[12]==' '?'0':tim[12]); *ptr++ = tim[13];
  *ptr++ = tim[15]; *ptr++ = tim[16];
  *ptr++ = tim[18]; *ptr++ = tim[19];
  *ptr='\0';
  return(erg);
}

/******************************************************************************/

char *geterror(va_alist)	/* Facility,MessageID,Parameter(s) */
va_dcl
{
  va_list args;
  char *fmt,tmp[256],msg[256];
  int i;
  ubyte otherargs[4];
  uword msglen;
  ulong msgvec,msgcode[8];

  for (i=0;i<8;i++) msgcode[i]=0;
  for (i=0;i<256;i++) { msg[i]='\0'; tmp[i]='\0'; }
  va_start(args);
  va_count(msgcode[1]);
  msgvec=va_arg(args,long);
  msgcode[0]=va_arg(args,long);
  for(i=2;i<msgcode[1];i++) msgcode[i]=va_arg(args,long);
  va_end(args);
  c$cks(sys$getmsg(msgcode[0],&msglen,c$ldsc(msg,256),msgvec&0x0f,otherargs));
  if (otherargs[1]!=0)
    sys$faol(c$dsc(msg),&msglen,c$ldsc(tmp,256),&msgcode[2]);
  else strcpy(tmp,msg);
  if (msgvec<32) show_error(fac&0x10?"%s [%d]":"%s",tmp,++errcnt);
  else printf("%s\n",tmp);
  return(tmp);
}

/******************************************************************************/

int establish(sigargs,mechargs)
unsigned int sigargs[],mechargs[];
{
  char buf1[256],buf2[256];
  ubyte otherargs[4];
  uword i,strlen;
  globalvalue CLI$_FACILITY;

  if ( (sigargs[1]>>16 & 0xfff)==CLI$_FACILITY ||
       (sigargs[1] & 0x07)==2 ||
      ((sigargs[1] & 0x07)==4 && sigargs[1]!=SS$_ACCVIO)) {
    for(i=0;i<256;i++) { buf1[i]='\0'; buf2[i]='\0'; }
    sys$getmsg(sigargs[1],&strlen,c$ldsc(buf1,256),fac,otherargs);
    if (otherargs[1]!=0)
      sys$faol(c$dsc(buf1),&strlen,c$ldsc(buf2,256),&sigargs[3]);
    else strcpy(buf2,buf1);
    show_error(fac&0x10?"%s [%d]":"%s",buf2,++errcnt);
    return(SS$_CONTINUE);
    }
  else return(SS$_RESIGNAL);
}

/******************************************************************************/

cli_handle(key)
uword key;
{
  int status,num;
  char txt[256];
  globalvalue int NEWS$_NOCMD;

  if (!noscr) {
    for (num=0;num<xCOLS;num++) txt[num]=' '; txt[xCOLS]='\0';
    set_cursor(input_id,1,1); put_text(input_id,txt,0,0,TRUE);
  }
  txt[0]=noscr?0:key; txt[1]=0;
  strcpy(txt,read_string(kbd_id,NEWS_QUERY,input_id,txt));
  redraw_lines(paste_id,xROWS-1,2);
  if (num=atoi(txt)) sprintf(txt,"go %d",num);
  lib$establish(establish);
  status=cli$dcl_parse(c$dsc(txt),&news_table,0,0,0);
  switch(status) {
    case CLI$_ABSENT:
    case CLI$_NORMAL: cli$dispatch(); break;
    case CLI$_NOCOMD:
    case RMS$_EOF:    geterror(fac,NEWS$_NOCMD); break;
    default:          break;
  }
}

/******************************************************************************/

inp_comment(va_alist)
va_dcl
{
  va_list args;
  int j;
  char *fmt,tmp[256],t[256],mask[256],format[256];

  if (noscr) return;
  va_start(args);
  fmt=va_arg(args,char *);
  vsprintf(t,fmt,args);
  va_end(args);
  sprintf(tmp,"%-20s%*s",NEWS_PROMPT,xCOLS-20,t);
  for (j=0;j<strlen(tmp);j++) mask[j]=(j>=xCOLS-strlen(t))?SMG$M_REVERSE:SMG$M_NOATTR;
  mask[strlen(tmp)]='\0';
  set_cursor(input_id,1,1);
  put_multi(input_id,tmp,mask,0,TRUE);
  set_cursor(input_id,1,7);
}

/******************************************************************************/

clock_ast()
{
  quad interval_time;
  char tim[]="17-NOV-1858 00:00:00.00",t[256];
  int tim_len;

  c$cks(sys$asctim(&tim_len,c$dsc(tim),&clock_time,0)); tim[17]='\0';
  if (clock_disp<2) {
    sprintf(t,"Time %s\0",&tim[12]);
    put_chars(header_id,t,0,1,6);
    clock_disp++;
  } else {
    sprintf(t,"NEWS v%s\0",VERSION);
    put_chars(header_id,t,0,1,6);
    clock_disp=0;
  }
  set_cursor(header_id,1,1); set_cursor(input_id,1,1);
  c$cks(sys$bintim(c$dsc(CLOCKINTERVAL),&interval_time));
  c$cks(lib$add_times(&clock_time,&interval_time,&clock_time));
  c$cks(sys$setimr(0,&clock_time,clock_ast,&clock_id,0));
}

/******************************************************************************/

clock_handle(flag)
bool flag;
{
  char tim[]="17-NOV-1858 00:00:00.00";
  int tim_len;

  if (noscr) return;
  if (flag) {
    c$cks(sys$gettim(&clock_time));
    c$cks(sys$asctim(&tim_len,c$dsc(tim),&clock_time,0));
    strcpy(&tim[18],"00.00");
    c$cks(sys$bintim(c$dsc(tim),&clock_time));
    c$cks(sys$setimr(0,&clock_time,clock_ast,&clock_id,0));
  } else {
    c$cks(sys$cantim(&clock_id,0));
    clock_time.l1=0; clock_time.l2=0;
  }
}

/******************************************************************************/

wait_sync()
{
  char tim[]="0 00:00:00.25";
  quad wtime={0,0};

  sys$bintim(c$dsc(tim),&wtime);
  sys$schdwk(0,0,&wtime,0);
  sys$hiber();
}

/******************************************************************************/

display_order()
{
  int i;

  for (i=0;i<MAXKILL;i++) { kills[i].group=NIL; kills[i].pattern=NIL; }
  disp_order[0] =NEWS_NUM_ADDRESS;
  disp_order[1] =NEWS_NUM_SERVER;
  disp_order[2] =NEWS_NUM_PORT;
  disp_order[3] =NEWS_NUM_MAILER;
  disp_order[4] =NEWS_NUM_PERSONAL_NAME;
  disp_order[5] =NEWS_NUM_ORGANISATION;
  disp_order[6] =NEWS_NUM_NEWSENTRY;
  disp_order[7] =NEWS_NUM_GROUPENTRY;
  disp_order[8] =NEWS_NUM_SORTGROUP;
  disp_order[9] =NEWS_NUM_GROUPMODE;
  disp_order[10]=NEWS_NUM_KILLFILE;
  disp_order[11]=NEWS_NUM_GROUPLINES;
  disp_order[12]=NEWS_NUM_GROUPAUTHORS;
  disp_order[13]=NEWS_NUM_GROUPDATE;
  disp_order[14]=NEWS_NUM_HEADERDISPLAY;
  disp_order[15]=NEWS_NUM_DUMPTERM;
  disp_order[16]=NEWS_NUM_AUTOSAVE;
  disp_order[17]=NEWS_NUM_PRINT;
  disp_order[18]=NEWS_NUM_EDITOR;
  disp_order[19]=NEWS_NUM_SIGNATURE;
  disp_order[20]=NEWS_NUM_MARKER;
  disp_order[21]=NEWS_NUM_CLOCK;
  disp_order[22]=NEWS_NUM_BROADCASTS;
  disp_order[23]= -1;
}

/******************************************************************************/

do_send(txt)
char *txt;
{
  if (decnet) decnet_send(txt);
  else net_send(txt);
}

/******************************************************************************/

write_killfile()
{
  char name[256];
  int i;
  FILE *fd;
  globalvalue int NEWS$_KILWRT;

  strcpy(name,get_kill());
  delete(name);
  if (fd=fopen(name,"w+")) {
    fprintf(fd,"!===============================================\n");
    fprintf(fd,"! Private VMS NEWS KILL file - do not touch!\n");
    fprintf(fd,"!===============================================\n");
    fprintf(fd,"!\n");
    i=0; while (i<MAXKILL) {
      if (kills[i].group!=NIL)
        fprintf(fd,"%s:%c%c:%s\n",kills[i].group,kills[i].sensitive,kills[i].mode,kills[i].pattern);
      i++;
    }
  } else geterror(fac,NEWS$_KILWRT);
  fclose (fd);
}

/******************************************************************************/

read_killfile()
{
  int pos=0;
  bool flag=TRUE;
  char name[256],tmp[256],*ptr;
  FILE *fd;
  globalvalue int NEWS$_KILMAX,NEWS$_KILFILE;

  strcpy(name,get_kill());
  if (fd=fopen(name,"r")) {
    while (fgets(tmp,255,fd) && flag) {
      ptr=tmp; while (*ptr) if (*ptr=='\n' || *ptr=='\r') *ptr='\0'; else ptr++;
      if (*tmp!='!') {
        ptr=tmp; while (*ptr && *ptr!=':') ptr++; *ptr++ ='\0';
        strcpy(kills[pos].group=malloc(strlen(tmp)+1),tmp);
        kills[pos].sensitive= *ptr++;
        kills[pos].mode= *ptr++;
        strcpy(kills[pos++].pattern=malloc(strlen(ptr)+1),++ptr);
        if (pos==MAXKILL) { flag=FALSE; strcpy(fao,c$asc(name)); geterror(fac,NEWS$_KILMAX,fao,pos); }
      }
    }
    if (flag) { strcpy(fao,c$asc(name)); geterror(fac,NEWS$_KILFILE,fao); }
  }
  fclose(fd);
}

/******************************************************************************/

flag_description()
{
  char tmp[256]="\0";

  strcpy(tmp," ");
  if (newsmgr)    strcpy(tmp," [News Manager]");
  if (restricted) strcpy(tmp," [Restricted]");
  return(tmp);
}

/******************************************************************************/

#ifdef DEBUG
traceback(status)
int status;
{
  int i;

  lib$signal(status);
  i = 0;
  i = i / i;
}
#endif

/******************************************************************************/
