$ TYPE sys$input
!*******************************************************************************
!*
!*  VMS NEWS Makefile v1.1 (including MMS description file creator)
!*
!*  Copyright 1992 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
!*
!*******************************************************************************

Enter a question mark (?) at any time for help.

$ chinese_mode = 0
$ if p1 .eqs. "CHINESE" then chinese_mode = 1
$ HeaderFiles = "header,tcp_header,version"
$ SourceFiles = "analyze,startup,command,cmdshow,cmdconf,cmdpost,cmdsys" + -
		",data,news,smg,net_decnet,cmdstartup,cmddef,errors"
$ SET PROTECTION=(s:rwed,o:rwed,g,w)/DEFAULT
$!
$ CALL CheckCompilers
$ IF MAKE$FATAL .EQS. "TRUE"
$ THEN
$   DELETE/SYMBOL/GLOBAL MAKE$FATAL
$   EXIT
$ ELSE
$   DELETE/SYMBOL/GLOBAL MAKE$FATAL
$ ENDIF
$!
$ CALL GetTCP
$ IF MAKE$TCP .EQS. "***" THEN EXIT
$ CALL CheckHeader "''HeaderFiles',''SourceFiles',tcp_''MAKE$TCP',talk"
$ IF MAKE$TCP .EQS. "***" THEN EXIT
$ CALL GetMMS
$ CALL GetLSE
$ CALL GetMail
$ CALL GetSpecials
$ CALL GetVersion
$ CALL OptionFile
$ CALL GetLocalNodename
$ CALL GetServerNodename
$ CALL GetServerPort
$ CALL GetMailTransport
$ CALL GetTimezone
$ CALL GetOrganisation
$ CALL CreateConfiguration
$ IF MAKE$MMSpres .EQS. "YES"
$ THEN
$   CALL CreateMMS
$   TYPE sys$input
Created all MMS depending files - now starting compilation...

*** No further questions will be asked ***
$   MMS news
$   MMS talk
$ ELSE
$   TYPE sys$input
Created all further required files - now starting compilation...

*** No further questions will be asked ***

$   CALL HelpFile    helpfile news_help
$   MAKE$TalkMode :== "NO"
$   CALL CompileFile analyze
$   CALL CompileFile startup
$   CALL CompileFile command
$   CALL CompileFile cmdsys
$   CALL CompileFile cmdshow
$   CALL CompileFile cmdconf
$   CALL CompileFile cmdpost
$   CALL CompileFile data
$   CALL CompileFile news
$   CALL CompileFile smg
$   CALL CompileFile net_decnet
$   CALL CompileFile tcp_'MAKE$TCP'
$   CALL CldFile     cmddef
$   CALL CldFile     cmdstartup
$   CALL MsgFile     errors
$   CALL LinkFiles   'SourceFiles',tcp_'MAKE$TCP' NEWS
$   MAKE$LSE      :== "NO"
$   MAKE$NEWmail  :== "NO"
$   MAKE$TalkMode :== "YES"
$   CALL CompileFile talk
$   CALL CompileFile tcp_'MAKE$TCP'
$   CALL LinkFiles   talk,tcp_'MAKE$TCP',errors TALK
$ ENDIF
$ CALL SetProtections
$ CALL ShowLicense
$ CALL CleanupSymbols
$ EXIT
!
!
!
$!******************************************************************************
$CheckCompilers:	!Returns global variable MAKE$FATAL[TRUE,FALSE]
$!******************************************************************************
$ SUBROUTINE
$ MAKE$FATAL == "FALSE"
$ IF F$GETSYI("version") .LTS. "V5.0"
$ THEN
$   MAKE$FATAL == "TRUE"
$   WRITE sys$output "%MAKE-F-SYSTEM, NEWS MAKE requires a VAX/VMS system version of V5.0 or newer."
$   EXIT
$ ENDIF
$ IF F$TRNLNM("lmf$dec_c","lmf$license_table") .EQS. ""
$ THEN
$   MAKE$FATAL == "TRUE"
$   WRITE sys$output "%MAKE-F-SOFTWARE, NEWS MAKE requires a standard VAX C compiler."
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetMMS:		!Returns global variable MAKE$MMSpres [YES,NO]
$!******************************************************************************
$ SUBROUTINE
$ MAKE$MMSpres == "NO"
$ IF F$SEARCH("sys$system:mms.exe") .NES. "" THEN MAKE$MMSpres == "YES"
$CheckMMS:
$ IF MAKE$MMSpres .EQS. "YES"
$ THEN
$   INQUIRE/NOPUNCT I_MMS "* MMS found - Shall I use the MMS utility for compilation ? [YES] "
$   IF "''I_MMS'" .EQS. "?"
$   THEN
$     CALL PerformHelp "MMS"
$     GOTO CheckMMS
$   ENDIF
$ ENDIF
$ IF "''I_MMS'" .NES. "" THEN MAKE$MMSpres == I_MMS
$ IF (MAKE$MMSpres .NES. "YES") .AND. (MAKE$MMSpres .NES. "NO")
$ THEN
$   MAKE$MMSpres == "YES"
$   GOTO CheckMMS
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetLSE:		!Returns global variable MAKE$LSE [YES,NO]
$!******************************************************************************
$ SUBROUTINE
$ MAKE$LSE == "NO"
$ IF F$SEARCH("sys$share:lseshr.exe") .NES. "" THEN MAKE$LSE == "YES"
$CheckLSE:
$ IF MAKE$LSE .EQS. "YES"
$ THEN
$   INQUIRE/NOPUNCT I_LSE "* LSESHR found - shall I add the callable LSE editor ? [YES] "
$   IF "''I_LSE'" .EQS. "?"
$   THEN
$     CALL PerformHelp "LSE"
$     GOTO CheckLSE
$   ENDIF
$ ENDIF
$ IF "''I_LSE'" .NES. "" THEN MAKE$LSE = I_LSE
$ IF (MAKE$LSE .NES. "YES") .AND. (MAKE$LSE .NES. "NO") THEN GOTO CheckLSE
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetMail:		!Returns global variable MAKE$NEWmail [YES,NO,NEVER]
$!******************************************************************************
$ SUBROUTINE
$TestMail:
$ nm = "YES"
$ INQUIRE/NOPUNCT i "* Do you have a MAILER supporting TCP/IP MAIL ? [YES] "
$ IF i .EQS. "?"
$ THEN
$   CALL PerformHelp "MAIL_1"
$   GOTO TestMail
$ ENDIF
$ IF i .NES. "" THEN nm = i
$ IF (nm .NES. "YES") .AND. (nm .NES. "NO") .AND. (nm .NES. "NEW") THEN GOTO TestMail
$ IF nm .EQS. "YES"
$ THEN
$CheckMail:
$   MAKE$NEWmail == "NO"
$   INQUIRE/NOPUNCT i "* Is callable MAIL supported as proposed by VMS 5.0 ? [NO] "
$   IF i .EQS. "?"
$   THEN
$     CALL PerformHelp "MAIL_2"
$     GOTO CheckMail
$   ENDIF
$   IF i .NES. "" THEN MAKE$NEWmail == i
$   IF (MAKE$NEWmail .NES. "YES") .AND. (MAKE$NEWmail .NES. "NO") THEN GOTO CheckMail
$ ELSE
$   IF nm .EQS. "NEW"
$   THEN
$     MAKE$NEWmail == "YES"
$   ELSE
$     MAKE$NEWmail == "NEVER"
$   ENDIF
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetSpecials:		!Returns global variable MAKE$Specials
$!******************************************************************************
$ SUBROUTINE
$TestCLI:
$ cli = "NO"
$ INQUIRE/NOPUNCT i "* Shall a restrictive CLI handler be used [NO] ? "
$ IF i .EQS. "?"
$ THEN
$   CALL PerformHelp "CLI"
$   GOTO TestCLI
$ ENDIF
$ IF i .NES. "" THEN cli = i
$ IF (cli .NES. "YES") .AND. (cli .NES. "NO") THEN GOTO TestCLI
$TestLogging:
$ log = "NO"
$ INQUIRE/NOPUNCT i "* Shall the local user logging be enabled [NO] ? "
$ IF i .EQS. "?"
$ THEN
$   CALL PerformHelp "LOGGING"
$   GOTO TestLogging
$ ENDIF
$ IF i .NES. "" THEN log = i
$ IF (log .NES. "YES") .AND. (log .NES. "NO") THEN GOTO TestLogging
$ MAKE$Specials :== ""
$ IF cli .EQS. "YES" THEN MAKE$Specials == MAKE$Specials + ",STRICT_CLI"
$ IF log .EQS. "YES" THEN MAKE$Specials == MAKE$Specials + ",LOGGING"
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetTCP:		!Returns variables MAKE$(TCP,Transport,Device,Include)
$			!MAKE$TCP [short name of software - used for filename]
$			!MAKE$Transport [text string representing transport]
$			!MAKE$Device [string of TCP/IP generic device]
$			!MAKE$Include [list of include directories required]
$!******************************************************************************
$ SUBROUTINE
$!
$ CMUdevice  := "IP:"
$ WINdevice  := "INET:"
$ UCXdevice  := "BG:"
$ PSCdevice  := "TCP:"
$ EXOSdevice := "EX:"
$ Cnt = 0
$ cmu      := "***"
$ win      := "***"
$ ucx      := "***"
$ psc      := "***"
$ exos     := "***"
$ multinet := "***"
$ decnet   := "***"
$ Message = F$ENVIRONMENT("MESSAGE")
$ SET MESSAGE/NOTEXT/NOSEVERITY/NOIDENTIFICATION/NOFACILITY
$ cmu  = F$GETDVI(CMUdevice,"DEVNAM")
$ win  = F$GETDVI(WINdevice,"DEVNAM")
$ ucx  = F$GETDVI(UCXdevice,"DEVNAM")
$ psc  = F$GETDVI(PSCdevice,"DEVNAM")
$ exos = F$GETDVI(EXOSdevice,"DEVNAM")
$ SET MESSAGE'Message'
$ IF (cmu  .NES. "***") .AND. (F$TRNLNM(CMUdevice-":")  .NES. "") THEN cmu  := "***"
$ IF (win  .NES. "***") .AND. (F$TRNLNM(WINdevice-":")  .NES. "") THEN win  := "***"
$ IF (ucx  .NES. "***") .AND. (F$TRNLNM(UCXdevice-":")  .NES. "") THEN ucx  := "***"
$ IF (psc  .NES. "***") .AND. (F$TRNLNM(PSCdevice-":")  .NES. "") THEN psc  := "***"
$ IF (exos .NES. "***") .AND. (F$TRNLNM(EXOSdevice-":") .NES. "") THEN exos := "***"
$ IF F$TRNLNM("multinet") .NES. "" THEN multinet := "TRUE"
$DetectTCPIP:
$ IF cmu .NES. "***" !----- CMU ------------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "CMU/tek"
$   MAKE$Device    ==  CMUdevice
$   MAKE$TCP       == "CMU"
$   MAKE$Include   == "sys$library"
$ ENDIF
$ IF win .NES. "***" !----- WIN ------------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "Wollongong (TWG)"
$   MAKE$Device    ==  WINdevice
$   MAKE$TCP       == "WIN"
$   MAKE$Include   ==  "sys$library,"+ -
                       "twg$tcp:[netdist.include],"+ -
                       "twg$tcp:[netdist.include.sys],"+ -
                       "twg$tcp:[netdist.include.vms],"+ -
                       "twg$tcp:[netdist.include.netinet],"+ -
                       "twg$tcp:[netdist.include.arpa]"
$ ENDIF
$ IF ucx .NES. "***" !----- UCX ------------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "UCX (DEC)"
$   MAKE$Device    ==  UCXdevice
$   MAKE$TCP       == "UCX"
$   MAKE$Include   == "sys$library"
$ ENDIF
$ IF psc .NES. "***" !----- PSC ------------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "Process Software"
$   MAKE$Device    ==  PSCdevice
$   MAKE$TCP       == "PSC"
$   MAKE$Include   == "sys$library"
$ ENDIF
$ IF multinet .NES. "***" !----- Multinet --------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "MultiNet (TGV)"
$   MAKE$Device    ==  WINdevice
$   MAKE$TCP       == "TGV"
$   MAKE$Include   ==  "sys$library,"+ -
                       "multinet_root:[multinet.include],"+ -
                       "multinet_root:[multinet.include.sys],"+ -
                       "multinet_root:[multinet.include.arpa],"+ -
                       "multinet_root:[multinet.include.netinet],"+ -
                       "multinet_root:[multinet.include.vms]"
$ ENDIF
$ IF exos .NES. "***" !----- EXOS ----------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "EXOS"
$   MAKE$Device    ==  EXOSdevice
$   MAKE$TCP       == "EXOS"
$   MAKE$Include   == "sys$library"
$ ENDIF
$ IF decnet .NES. "***" !----- DECNET ------------------------------------------
$ THEN
$   Cnt = Cnt + 1
$   MAKE$Transport == "DECnet"
$   MAKE$Device    == "NL:"
$   MAKE$TCP       == "DUMMY"
$   MAKE$Include   == "sys$library"
$ ENDIF
$ IF (cnt .GT. 1) .OR. (cnt .EQ. 0) !----- Unknown -----------------------------
$ THEN
$SelectTCPIP:
$   WRITE sys$output "Detected devices supporting the following TCP/IP implementations:"
$   IF cmu      .NES. "***" THEN WRITE sys$output "   [C] CMU/tek                 (device ''CMUdevice')"
$   IF ucx      .NES. "***" THEN WRITE sys$output "   [U] UCX (DEC)               (device ''UCXdevice')"
$   IF win      .NES. "***" THEN WRITE sys$output "   [W] Wollongong (TWG)        (device ''WINdevice')"
$   IF psc      .NES. "***" THEN WRITE sys$output "   [P] Process Software        (device ''PSCdevice')"
$   IF multinet .NES. "***" THEN WRITE sys$output "   [M] MultiNet (TGV)          (device ''WINdevice')"
$   IF exos     .NES. "***" THEN WRITE sys$output "   [E] EXOS                    (device ''EXOSdevice')"
$                                WRITE sys$output "   [D] DECnet object           (no special device)"
$                                WRITE sys$output "   [X] Exit MAKEFILE creation"
$   INQUIRE/NOPUNCT line "Which one shall I use for compilation ? "
$   IF (line .EQS. "?") THEN CALL PerformHelp "TCPIP"
$   IF (line .NES. "C") .AND. (line .NES. "U") .AND. (line .NES. "W") .AND. -
       (line .NES. "P") .AND. (line .NES. "M") .AND. (line .NES. "E") .AND. -
       (line .NES. "D") .AND. (line .NES. "X") THEN GOTO SelectTCPIP
$   Cnt = 0
$   cmu      := "***"
$   win      := "***"
$   ucx      := "***"
$   psc      := "***"
$   exos     := "***"
$   multinet := "***"
$   decnet   := "***"
$   IF (line .EQS. "C") THEN cmu=CMUdevice
$   IF (line .EQS. "U") THEN ucx=UCXdevice
$   IF (line .EQS. "W") THEN win=WINdevice
$   IF (line .EQS. "P") THEN psc=PSCdevice
$   IF (line .EQS. "M") THEN multinet="TRUE"
$   IF (line .EQS. "E") THEN exos=EXOSdevice
$   IF (line .EQS. "D") THEN decnet="TRUE"
$   IF (line .NES. "X") THEN GOTO DetectTCPIP
$   WRITE sys$output "%MAKE-F-TCPIP, NEWS MAKE aborted due to unknown TCP/IP software."
$   MAKE$TCP :== "***"
$ ELSE
$   WRITE sys$output "Using TCP/IP implementation of ''MAKE$Transport' with device name ''MAKE$Device'"
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetVersion:		!Returns global variables MAKE$(Version,Major,Minor)
$			!MAKE$Version [text string representing version (X.YY)]
$			!MAKE$Major [major version number]
$			!MAKE$Minor [minor version number]
$			!MAKE$TalkVersion [text string of version (X.YY)]
$!******************************************************************************
$ SUBROUTINE
$ OPEN/READ fd version.h
$ READ fd Line
$ READ fd Line
$ READ fd Line
$ READ fd Line
$ READ fd Line1
$ READ fd Line
$ READ fd Line
$ READ fd Line
$ READ fd Line
$ READ fd Line
$ READ fd Line2
$ CLOSE fd
$ x = F$EXTRACT(17,30,Line1)
$ MAKE$Major   == F$EXTRACT(0,F$LOCATE(".",x),x)
$ MAKE$Minor   == F$EXTRACT(F$LOCATE(".",x)+1,F$LOCATE("""",x)-F$LOCATE(".",x)-1,x)
$ MAKE$Version == MAKE$Major + "." + MAKE$Minor
$ x = F$EXTRACT(21,30,Line2)
$ TalkMajor = F$EXTRACT(0,F$LOCATE(".",x),x)
$ TalkMinor = F$EXTRACT(F$LOCATE(".",x)+1,F$LOCATE("""",x)-F$LOCATE(".",x)-1,x)
$ MAKE$TalkVersion == TalkMajor + "." + TalkMinor
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$OptionFile:		!Creates option file NEWS.OPT
$!******************************************************************************
$ SUBROUTINE
$ NET = "NO"
$ IF F$SEARCH("sys$library:neterror.obj") .NES. "" THEN NET = "YES"
$ OPEN/WRITE fd news.opt
$ WRITE fd "!***********************************"
$ WRITE fd "!*   VMS NEWS linker option file   *"
$ WRITE fd "!***********************************"
$ WRITE fd "!"
$ WRITE fd "!VMS NEWS source files"
$ WRITE fd "!"
$ WRITE fd "news.obj, data.obj, startup.obj, analyze.obj, smg.obj, -"
$ WRITE fd "command.obj, cmdpost.obj, cmdconf.obj, cmdshow.obj, cmdsys.obj, -"
$ WRITE fd "cmdstartup.obj, cmddef.obj, errors.obj, -"
$ WRITE fd "net_decnet.obj, tcp_"+ F$EDIT(MAKE$TCP,"LOWERCASE") +".obj, -"
$ if chinese_mode .eq. 1 then -
  write fd "[-.chirk]term.obj, text.obj, chirk_ch.obj, char.obj, -"
$ WRITE fd "!"
$ WRITE fd "!Additional editors and TCP/IP depended (sharable) libraries"
$ WRITE fd "!"
$ IF NET      .EQS. "YES" THEN WRITE fd "sys$library:neterror.obj, -"
$ IF MAKE$TCP .EQS. "WIN"
$ THEN
$   IF F$SEARCH("twg$tcp:[netdist.lib]twglib.olb") .EQS. ""
$   THEN
$     WRITE fd "twg$tcp:[netdist.lib]libnet.olb/LIBRARY, -"
$     WRITE fd "twg$tcp:[netdist.lib]libnetacc.olb/LIBRARY, -"
$     WRITE fd "twg$tcp:[netdist.lib]libnet.olb/LIBRARY, -"
$   ELSE
$     WRITE fd "twg$tcp:[netdist.lib]twglib.olb/LIBRARY, -"
$   ENDIF
$ ENDIF
$ IF MAKE$TCP .EQS. "UCX" THEN WRITE fd "sys$share:ucx$ipc.olb/LIBRARY, -"
$ IF MAKE$TCP .EQS. "PSC" THEN WRITE fd "tcpip_root:socklib.olb/LIBRARY, -"
$ IF MAKE$TCP .EQS. "TGV" THEN WRITE fd "multinet:multinet_socket_library.exe/SHARE, -"
$ IF MAKE$LSE .EQS. "YES" THEN WRITE fd "sys$share:lseshr.exe/SHARE, -"
$ WRITE fd "!"
$ WRITE fd "!System specific and always required (sharable) libraries"
$ WRITE fd "!"
$ WRITE fd "sys$share:tpushr.exe/SHARE, -"
$ WRITE fd "sys$share:edtshr.exe/SHARE, -"
$ WRITE fd "sys$share:tecoshr.exe/SHARE, -"
$ WRITE fd "sys$share:vaxcrtl.exe/SHARE"
$ WRITE fd "!"
$ WRITE fd "!Basic LINK options"
$ WRITE fd "!"
$ WRITE fd "NAME=""VMS_NEWS_READER"""
$ WRITE fd "IDENTIFICATION=""VMS NEWS ''MAKE$Version'"""
$ WRITE fd "STACK=10"
$ WRITE fd "IOSEGMENT=64,P0BUFS"
$ WRITE fd "!"
$ WRITE fd "![end of file]"
$ CLOSE fd
$ PURGE/NOLOG/NOCONFIRM news.opt
$ OPEN/WRITE fd talk.opt
$ WRITE fd "!***********************************"
$ WRITE fd "!*   VMS TALK linker option file   *"
$ WRITE fd "!***********************************"
$ WRITE fd "!"
$ WRITE fd "!VMS TALK source files"
$ WRITE fd "!"
$ WRITE fd "talk.obj, errors.obj, -"
$ WRITE fd "tcp_"+ F$EDIT(MAKE$TCP,"LOWERCASE") +".obj, -"
$ WRITE fd "!"
$ WRITE fd "!Additional TCP/IP depended (sharable) libraries"
$ WRITE fd "!"
$ IF NET      .EQS. "YES" THEN WRITE fd "sys$library:neterror.obj, -"
$ IF MAKE$TCP .EQS. "WIN"
$ THEN
$   IF F$SEARCH("twg$tcp:[netdist.lib]twglib.olb") .EQS. ""
$   THEN
$     WRITE fd "twg$tcp:[netdist.lib]libnet.olb/LIBRARY, -"
$     WRITE fd "twg$tcp:[netdist.lib]libnetacc.olb/LIBRARY, -"
$     WRITE fd "twg$tcp:[netdist.lib]libnet.olb/LIBRARY, -"
$   ELSE
$     WRITE fd "twg$tcp:[netdist.lib]twglib.olb/LIBRARY, -"
$   ENDIF
$ ENDIF
$ IF MAKE$TCP .EQS. "UCX" THEN WRITE fd "sys$share:ucx$ipc.olb/LIBRARY, -"
$ IF MAKE$TCP .EQS. "PSC" THEN WRITE fd "tcpip_root:socklib.olb/LIBRARY, -"
$ IF MAKE$TCP .EQS. "TGV" THEN WRITE fd "multinet:multinet_socket_library.exe/SHARE, -"
$ WRITE fd "!"
$ WRITE fd "!System specific and always required (sharable) libraries"
$ WRITE fd "!"
$ WRITE fd "sys$share:vaxcrtl.exe/SHARE"
$ WRITE fd "!"
$ WRITE fd "!Basic LINK options"
$ WRITE fd "!"
$ WRITE fd "NAME=""NET_TALKER"""
$ WRITE fd "IDENTIFICATION=""VMS TALK ''MAKE$TalkVersion'"""
$ WRITE fd "STACK=10"
$ WRITE fd "IOSEGMENT=64,P0BUFS"
$ WRITE fd "!"
$ WRITE fd "![end of file]"
$ CLOSE fd
$ PURGE/NOLOG/NOCONFIRM talk.opt
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CreateMMS:		!Creates MMS description file DESCRIP.MMS
$!******************************************************************************
$ SUBROUTINE
$ IF MAKE$LSE .EQS. "YES"
$ THEN
$   LSEDIT = ",LSE"
$ ELSE
$   LSEDIT = ""
$ ENDIF
$ IF MAKE$NEWmail .EQS. "YES"   THEN CALLABLE = ",CALLABLE_MAIL"
$ IF MAKE$NEWmail .EQS. "NO"    THEN CALLABLE = ""
$ IF MAKE$NEWmail .EQS. "NEVER" THEN CALLABLE = ",NO_MAIL"
$ OPEN/WRITE fd descrip.tmp
$ WRITE fd "!"
$ WRITE fd "!==============================================================================="
$ WRITE fd "! Data generated automatically by MAKE.COM"
$ WRITE fd "!==============================================================================="
$ WRITE fd "!"
$ WRITE fd "TCPIP      = ''MAKE$TCP'"
$ WRITE fd "TRANSPORT  = ''MAKE$Transport'"
$ WRITE fd "DEVICE     = ''MAKE$Device'"
$ WRITE fd "LSE        = ''LSEDIT'"
$ WRITE fd "CALLABLE   = ''CALLABLE'"
$ WRITE fd "SPECIALS   = ''MAKE$Specials'"
$ WRITE fd "CC_INCLUDE = ''MAKE$Include'"
$ WRITE fd "MAJOR      = ''MAKE$Major'"
$ WRITE fd "MINOR      = ''MAKE$Minor'"
$ if chinese_mode .eq. 1
$ then
$  write fd "CHINESE    = ,CHINESE_NEWS_READER=TRUE"
$ else
$  write fd "CHINESE    = ,CHINESE_NEWS_READER=FALSE"
$ endif
$ CLOSE fd
$ CREATE descrip.mms
$ DEFINE sys$error  NL:
$ DEFINE sys$output NL:
$ APPEND descrip.tmp,descrip.template descrip.mms
$ DEASSIGN sys$error
$ DEASSIGN sys$output
$ PURGE/NOLOG/NOCONFIRM descrip.mms
$ DELETE/NOLOG/NOCONFIRM descrip.tmp;*
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CheckHeader:		!Scan through source .C and .H files for #includes
$			!On error (e.g. missing headerfile) set termination flag
$!******************************************************************************
$ SUBROUTINE
$ WRITE sys$output "Now scanning through all source files for headerfile check."
$ IF F$SEARCH("sys$scratch:scanall.tmp")  .NES. "" THEN DELETE/NOCONFIRM/NOLOG sys$scratch:scanall.tmp;*
$ IF F$SEARCH("sys$scratch:scanfile.tmp") .NES. "" THEN DELETE/NOCONFIRM/NOLOG sys$scratch:scanfile.tmp;*
$ CREATE sys$scratch:scanall.tmp
$ Num = 0
$CheckLoop:
$   File = F$ELEMENT(Num,",",P1)
$   IF File .EQS. "," THEN GOTO CheckLoopEnd
$   Ext = ".c"
$   IF F$SEARCH("''File'''Ext'") .EQS. "" THEN Ext = ".h"
$   IF F$SEARCH("''File'''Ext'") .EQS. "" THEN GOTO CheckIgnore
$   Message = F$ENVIRONMENT("MESSAGE")
$   SET MESSAGE/NOTEXT/NOSEVERITY/NOIDENTIFICATION/NOFACILITY
$   SEARCH 'File''Ext' "#include <"/OUTPUT=sys$scratch:scanhead.tmp
$   SET MESSAGE'Message'
$   APPEND sys$scratch:scanhead.tmp sys$scratch:scanall.tmp
$CheckIgnore:
$   Num = Num + 1
$ GOTO CheckLoop
$CheckLoopEnd:
$ DELETE/NOCONFIRM/NOLOG sys$scratch:scanhead.tmp;*
$ OPEN/READ  FRead  sys$scratch:scanall.tmp
$ OPEN/WRITE FWrite sys$scratch:scanfile.tmp
$CheckLoop2:
$   READ/END_OF_FILE=CheckLoopEnd2 FRead Line
$   Start  = F$LOCATE("<",Line)
$   Finish = F$LOCATE(">",Line)
$   Header = F$EXTRACT(Start+1,Finish-Start-1,Line)
$   WRITE FWrite Header
$ GOTO CheckLoop2
$CheckLoopEnd2:
$ CLOSE FWrite
$ CLOSE FRead
$ SORT/NODUPLICATE sys$scratch:scanfile.tmp sys$scratch:scanfile.tmp
$ DELETE/NOCONFIRM/NOLOG sys$scratch:scanall.tmp;*
$ PURGE/NOCONFIRM/NOLOG sys$scratch:scanfile.tmp
$ OPEN/READ FRead sys$scratch:scanfile.tmp
$CheckLoop3:
$   READ/END_OF_FILE=CheckLoopEnd3 FRead Line
$   IF F$LOCATE(":",Line) .EQS. F$LENGTH(Line)
$   THEN
$     FullLine = "vaxc$include:" + Line
$   ELSE
$     FullLine = Line
$   ENDIF
$   DEFINE/NOLOG/USER vaxc$include 'MAKE$Include
$   IF (F$SEARCH(FullLine) .EQS. "")
$   THEN
$     WRITE sys$output "Missing header file: ''Line'"
$     MAKE$TCP :== "***"
$   ENDIF
$ GOTO CheckLoop3
$CheckLoopEnd3:
$ CLOSE FRead
$ DELETE/NOCONFIRM/NOLOG sys$scratch:scanfile.tmp;*
$ IF MAKE$TCP .EQS. "***"
$ THEN
$   WRITE sys$output "%MAKE-F-HEADER, NEWS MAKE aborted because required headerfiles are missing."
$ ELSE
$   WRITE sys$output "Passed headerfile check successfully."
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$HelpFile:		!Compiles VMS HELP file
$			!P1 contains the filename of the source
$			!P2 contains the filename of the library
$!******************************************************************************
$ SUBROUTINE
$ IF F$SEARCH("''P2'.HLB") .NES. ""
$ THEN
$   IF F$CVTIME(F$FILE_ATTRIBUTES("''P2'.HLB","RDT")) .GTS. -
       F$CVTIME(F$FILE_ATTRIBUTES("''P1'.HLP","RDT"))
$   THEN
$     WRITE sys$output "Conversion of existing ''P1'.HLP skipped"
$     GOTO HlpEnd
$   ENDIF
$ ENDIF
$ Len=F$FILE_ATTRIBUTE("''P1'.HLP","EOF")
$ WRITE sys$output "Converting ''P1'.HLP (''Len' blocks)..."
$ LIBRARIAN/HELP/CREATE 'P2' 'P1'
$ PURGE/NOLOG/NOCONFIRM 'P1'.hlp
$ PURGE/NOLOG/NOCONFIRM 'P2'.hlb
$ SET FILE/TRUNCATE 'P2'.hlb
$HlpEnd:
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CldFile:		!Compiles VMS CLD file
$			!P1 contains the filename of the source
$!******************************************************************************
$ SUBROUTINE
$ IF F$SEARCH("''P1'.OBJ") .NES. ""
$ THEN
$   IF F$CVTIME(F$FILE_ATTRIBUTES("''P1'.OBJ","RDT")) .GTS. -
       F$CVTIME(F$FILE_ATTRIBUTES("''P1'.CLD","RDT"))
$   THEN
$     WRITE sys$output "Translation of existing ''P1'.CLD skipped"
$     GOTO CldEnd
$   ENDIF
$ ENDIF
$ Len=F$FILE_ATTRIBUTE("''P1'.CLD","EOF")
$ WRITE sys$output "Translating ''P1'.CLD (''Len' blocks)..."
$ SET COMMAND/OBJECT 'P1'.CLD
$CldEnd:
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$MsgFile:		!Compiles VMS MESSAGE file
$			!P1 contains the filename of the source
$!******************************************************************************
$ SUBROUTINE
$ IF F$SEARCH("''P1'.OBJ") .NES. ""
$ THEN
$   IF F$CVTIME(F$FILE_ATTRIBUTES("''P1'.OBJ","RDT")) .GTS. -
       F$CVTIME(F$FILE_ATTRIBUTES("''P1'.MSG","RDT"))
$   THEN
$     WRITE sys$output "Translation of existing ''P1'.MSG skipped"
$     GOTO MsgEnd
$   ENDIF
$ ENDIF
$ Len=F$FILE_ATTRIBUTE("''P1'.MSG","EOF")
$ WRITE sys$output "Translating ''P1'.MSG (''Len' blocks)..."
$ MESSAGE/OBJECT 'P1'.MSG
$MsgEnd:
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CompileFile:		!Compiles VMS C source file
$			!P1 contains the filename of the source
$!******************************************************************************
$ SUBROUTINE
$ IF F$SEARCH("''P1'.OBJ") .NES. ""
$ THEN
$   IF F$CVTIME(F$FILE_ATTRIBUTES("''P1'.OBJ","RDT")) .GTS. -
       F$CVTIME(F$FILE_ATTRIBUTES("''P1'.C","RDT"))
$   THEN
$     IF F$EXTRACT(0,4,P1) .EQS. "TCP_"
$     THEN
$       DELETE/NOCONFIRM/NOLOG tcp_'MAKE$TCP'.obj;*
$     ELSE
$       WRITE sys$output "Compilation of existing ''P1'.C skipped"
$       GOTO CompileEnd
$     ENDIF
$   ENDIF
$ ENDIF
$ DefOpt = ""
$ IF MAKE$LSE      .EQS. "YES" THEN DefOpt = DefOpt + ",LSE"
$ IF MAKE$NEWmail  .EQS. "YES" THEN DefOpt = DefOpt + ",CALLABLE_MAIL"
$ IF MAKE$TalkMode .EQS. "YES" THEN DefOpt = DefOpt + ",FLUSH_LINES"
$ Len=F$FILE_ATTRIBUTE("''P1'.C","EOF")
$ WRITE sys$output "Compiling ''P1'.C (''Len' blocks)..."
$ DEFINE/NOLOG/USER vaxc$include 'MAKE$Include
$ CC 'P1'.C/DEFINE=(TRANSPORT="""''MAKE$Transport'""",DEVICE="""''MAKE$Device'"""'DefOpt')
$CompileEnd:
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$LinkFiles:		!Links source together
$			!P1 contains a list of object files (without .OBJ in it)
$			!P2 contains the executable image name
$!******************************************************************************
$ SUBROUTINE
$ Num = 0
$ Len = 0
$LinkLoop:
$   File = F$ELEMENT(Num,",",P1)
$   IF File .EQS. "," THEN GOTO LinkLoopEnd
$   Len = Len + F$FILE_ATTRIBUTE("''File'.OBJ","EOF")
$   Num = Num + 1
$ GOTO LinkLoop
$LinkLoopEnd:
$ IF F$SEARCH("sys$library:neterror.obj") .NES. ""
$ THEN
$   Len = Len + F$FILE_ATTRIBUTE("sys$library:neterror.obj","EOF")
$ ENDIF
$ WRITE sys$output "Linking ''P2'.EXE (objects have ''Len' blocks)..."
$ IF F$SEARCH("''P2'.err")  .NES. "" THEN DELETE/NOCONFIRM/NOLOG 'P2'.err;*
$ DEFINE/NOLOG sys$error 'P2'.err
$ DEFINE/NOLOG sys$output NL:
$ LINK/EXE='P2'.exe/SYMBOL='P2'.stb/NOTRACE/MAP='P2'.map/FULL -
    'P2'.opt/OPTION
$ DEASSIGN sys$output
$ DEASSIGN sys$error
$LinkEnd:
$ PURGE/NOLOG/NOCONFIRM *.exe
$ PURGE/NOLOG/NOCONFIRM *.opt
$ PURGE/NOLOG/NOCONFIRM *.stb
$ PURGE/NOLOG/NOCONFIRM *.obj
$ PURGE/NOLOG/NOCONFIRM *.hlb
$ PURGE/NOLOG/NOCONFIRM *.err
$ PURGE/NOLOG/NOCONFIRM *.map
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetLocalNodename:	!Returns global variable MAKE$Address
$!******************************************************************************
$ SUBROUTINE
$ IF MAKE$TCP .EQS. "CMU"   THEN Default = F$TRNLNM("INTERNET_HOST_NAME")
$ IF MAKE$TCP .EQS. "WIN"   THEN Default = F$TRNLNM("ARPANET_HOST_NAME")
$ IF MAKE$TCP .EQS. "UCX"   THEN Default = F$TRNLNM("UCX$INET_HOST")
$ IF MAKE$TCP .EQS. "PSC"   THEN Default = "***"
$ IF MAKE$TCP .EQS. "TGV"   THEN Default = "***"
$ IF MAKE$TCP .EQS. "EXOS"  THEN Default = "***"
$ IF MAKE$TCP .EQS. "DUMMY" THEN Default = F$GETSYI("NODENAME")
$ TYPE sys$input
Now setting up the minimum configuration of VMS NEWS:
$RegetLocalNodename:
$ inp = ""
$ INQUIRE/NOPUNCT inp "* Local Nodename [''Default'] ? "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "NODENAME"
$   GOTO RegetLocalNodename
$ ENDIF
$ IF inp .EQS. "" THEN inp = Default
$ IF inp .EQS. "***" THEN GOTO RegetLocalNodename
$ MAKE$Address == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetServerNodename:	!Returns global variable MAKE$Servername
$!******************************************************************************
$ SUBROUTINE
$ inp = ""
$RegetServerNodename:
$ INQUIRE/NOPUNCT inp "* NNTP server name? "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "NNTPSERVER"
$   GOTO RegetServerNodename
$ ENDIF
$ IF inp .EQS. "" THEN GOTO RegetServerNodename
$ MAKE$Servername == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetServerPort:		!Returns global variable MAKE$Serverport
$!******************************************************************************
$ SUBROUTINE
$ IF MAKE$TCP .EQS. "DUMMY"
$ THEN
$   Default = "NNTP="
$ ELSE
$   Default = "119"
$ ENDIF
$ReGetServerPort:
$ inp = ""
$ INQUIRE/NOPUNCT inp "* NNTP server port? [''Default'] "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "NNTPPORT"
$   GOTO ReGetServerPort
$ ENDIF
$ IF inp .EQS. "" THEN inp = Default
$ MAKE$Serverport == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetMailTransport:	!Returns global variable MAKE$MailTrans
$!******************************************************************************
$ SUBROUTINE
$ inp = ""
$RegetMailTransport:
$ INQUIRE/NOPUNCT inp "* Default MAIL transport? "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "MAILTRANS"
$   GOTO RegetMailTransport
$ ENDIF
$ IF inp .EQS. "" THEN GOTO RegetMailTransport
$ MAKE$MailTrans == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetOrganisation:	!Returns global variable MAKE$Organisation
$!******************************************************************************
$ SUBROUTINE
$ inp = ""
$RegetOrganisation:
$ INQUIRE/NOPUNCT inp "* Local organisation text? "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "ORGANISATION"
$   GOTO RegetOrganisation
$ ENDIF
$ IF inp .EQS. "" THEN GOTO RegetOrganisation
$ MAKE$Organisation == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$GetTimezone:		!Returns global variable MAKE$Timezone
$!******************************************************************************
$ SUBROUTINE
$ inp = ""
$RegetTimezone:
$ INQUIRE/NOPUNCT inp "* Local Timezone? "
$ IF inp .EQS. "?"
$ THEN
$   CALL PerformHelp "TIMEZONE"
$   GOTO RegetTimezone
$ ENDIF
$ IF inp .EQS. "" THEN GOTO RegetTimezone
$ MAKE$Timezone == inp
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CreateConfiguration:	!Updates configuration file NEWS_CONFIG.DAT
$!******************************************************************************
$ SUBROUTINE
$ WRITE sys$output "Updating configuration file NEWS_CONFIG.DAT..."
$ CREATE sys$scratch:config.tmp
$ OPEN/APPEND fd sys$scratch:config.tmp
$ WRITE fd """''MAKE$Address'"""
$ WRITE fd """''MAKE$Organisation'"""
$ WRITE fd """''MAKE$Timezone'"""
$ WRITE fd """''MAKE$Serverport'"""
$ WRITE fd """''MAKE$Servername'"""
$ WRITE fd """''MAKE$MailTrans'"""
$ CLOSE fd
$ Mess = F$ENVIRONMENT("MESSAGE")
$ SET MESSAGE/NOFACILITY/NOSEVERITY/NOIDENTIFICATION/NOTEXT
$ EDIT/TPU/NOSECTION/NODISPLAY/COMMAND=sys$input sys$scratch:config.tmp
!-------------------------------------------------------------------------------
PROCEDURE DO_TOP()
  ON_ERROR
    RETURN;
  ENDON_ERROR;
  MOVE_VERTICAL(-10000);
ENDPROCEDURE;
!-------------------------------------------------------------------------------
PROCEDURE DO_SEARCH(XPatt,NewPatt)
LOCAL XLine,XRest;
  ON_ERROR
     Found_Range := 0;
    RETURN;
  ENDON_ERROR;
  Found_Range := SEARCH(XPatt,FORWARD,EXACT);
  POSITION(Found_Range);
  ERASE_LINE;
  COPY_TEXT(XPatt + " " + NewPatt);
  SPLIT_LINE;
  MOVE_VERTICAL(1);
ENDPROCEDURE;
!-------------------------------------------------------------------------------
SET(SUCCESS,OFF);
info_buf := CREATE_BUFFER("{info}",GET_INFO(COMMAND_LINE,"FILE_NAME"));
work_buf := CREATE_BUFFER("{work}","news_config.dat");
POSITION(info_buf);
LocalAddr  := CURRENT_LINE; MOVE_VERTICAL(1);
LocalOrg   := CURRENT_LINE; MOVE_VERTICAL(1);
LocalTime  := CURRENT_LINE; MOVE_VERTICAL(1);
NNTPport   := CURRENT_LINE; MOVE_VERTICAL(1);
NNTPserver := CURRENT_LINE; MOVE_VERTICAL(1);
MAILsoft   := CURRENT_LINE; MOVE_VERTICAL(1);
POSITION(work_buf);
DO_SEARCH("Address:",LocalAddr);      DO_TOP();
DO_SEARCH("Organisation:",LocalOrg);  DO_TOP();
DO_SEARCH("Timezone:",LocalTime);     DO_TOP();
DO_SEARCH("Serverport:",NNTPport);    DO_TOP();
DO_SEARCH("Servername:",NNTPserver);  DO_TOP();
DO_SEARCH("Mail_Trans:",MAILsoft);
WRITE_FILE(work_buf);
QUIT;
EXIT;
!-------------------------------------------------------------------------------
$ SET MESSAGE'Mess
$ DELETE/NOLOG/NOCONFIRM sys$scratch:config.tmp;*
$ PURGE/NOLOG/NOCONFIRM news_config.dat
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$SetProtections:	!Sets file protections
$!******************************************************************************
$ SUBROUTINE
$ TYPE sys$input
Setting required file protections for package...
$ i = MAKE$Major*1000+MAKE$Minor
$ IF F$SEARCH("NEWS.EXE") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:RE) news.exe
$   RENAME news.exe news.exe;'i'
$ ENDIF
$ IF F$SEARCH("NEWS_CONFIG.DAT") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:R) news_config.dat
$   RENAME news_config.dat news_config.dat;'i'
$ ENDIF
$ IF F$SEARCH("NEWS_HELP.HLB") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:R) news_help.hlb
$   RENAME news_help.hlb news_help.hlb;'i'
$ ENDIF
$ IF F$SEARCH("NEWS_RFC977.DAT") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:R) news_rfc977.dat
$   RENAME news_rfc977.dat news_rfc977.dat;'i'
$ ENDIF
$ IF F$SEARCH("NEWS_RFC1036.DAT") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:R) news_rfc1036.dat
$   RENAME news_rfc1036.dat news_rfc1036.dat;'i'
$ ENDIF
$ IF F$SEARCH("NEWS_DEFAULT.RC") .NES. ""
$ THEN
$   SET PROT=(S:RWED,O:RWED,G,W:R) news_default.rc
$   RENAME news_default.rc news_default.rc;'i'
$ ENDIF
$ IF F$SEARCH("TALK.EXE") .NES. "" THEN SET PROT=(S:RWED,O:RWED,G,W:RE) talk.exe
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$ShowLicense:		!Displays the copyright message
$!******************************************************************************
$ SUBROUTINE
$ INQUIRE/NOPUNCT dummy "Press <RETURN> to continue... "
$ TYPE sys$input

 +----------------------------------------------------------------------------+
 | VMS NEWS 1.24, distribution version                                        |
 | Copyright 1990,1991,1992 by Bernd Onasch (University of Karlsruhe)         |
 |                                                                            |
 | VMS TALK 0.91                                                              |
 | Copyright 1992 by Bernd Onasch (University of Karlsruhe)                   |
 |                                                                            |
 | Permission is granted to any individual or institution to use, copy,       |
 | or redistribute this software as long as all of the original files are     |
 | included unmodified, that it is not sold for profit, and that this copy-   |
 | right notice is retained. If this software is modifed, then it may be used |
 | locally but shall never be copied or redistributed at all. The modified    |
 | version shall not be offered locally as official version or inofficial     |
 | patch anywhere.                                                            |
 +----------------------------------------------------------------------------+
 | Please send an E-MAIL of this installation to (I won't do it automatically)|
 |          Bernd Onasch                   ONASCH@ira.uka.de                  |
 |          University of Karlsruhe        ONASCH@informatik.uni-karlsruhe.de |
 |          Informatik Rechnerabteilung    PSI%45050365300::ONASCH            |
 |          Kaiserstrasse 12               CCC_ONAS@DULRUU51.BITNET           |
 |          7500 Karlsruhe (FRG)                                              |
 +----------------------------------------------------------------------------+
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$CleanupSymbols:	!Removes local symbols again
$!******************************************************************************
$ SUBROUTINE
$ DELETE/SYMBOL/GLOBAL MAKE$MMSpres
$ DELETE/SYMBOL/GLOBAL MAKE$LSE
$ DELETE/SYMBOL/GLOBAL MAKE$NEWmail
$ DELETE/SYMBOL/GLOBAL MAKE$Specials
$ DELETE/SYMBOL/GLOBAL MAKE$TCP
$ DELETE/SYMBOL/GLOBAL MAKE$Transport
$ DELETE/SYMBOL/GLOBAL MAKE$Device
$ DELETE/SYMBOL/GLOBAL MAKE$Include
$ DELETE/SYMBOL/GLOBAL MAKE$Version
$ DELETE/SYMBOL/GLOBAL MAKE$Major
$ DELETE/SYMBOL/GLOBAL MAKE$Minor
$ DELETE/SYMBOL/GLOBAL MAKE$TalkVersion
$ DELETE/SYMBOL/GLOBAL MAKE$Address
$ DELETE/SYMBOL/GLOBAL MAKE$Organisation
$ DELETE/SYMBOL/GLOBAL MAKE$Timezone
$ DELETE/SYMBOL/GLOBAL MAKE$Serverport
$ DELETE/SYMBOL/GLOBAL MAKE$Servername
$ DELETE/SYMBOL/GLOBAL MAKE$MailTrans
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$PerformHelp:		!Displays a brief help text
$!******************************************************************************
$ SUBROUTINE
$ IF P1 .EQS. "TCPIP"
$ THEN
$   TYPE sys$input
  This program to compile VMS NEWS requires the knowledge which TCP/IP
  package you have installed on your system. Because it detected more
  than one device that is known as TCP/IP device it has to ask you for
  the proper TCP/IP software product.
  You have to use the same TCP/IP product everywhere where you use this
  version on VMS NEWS because it is linked against the TCP/IP libraries
  that have to be present always.
$ ENDIF
$ IF P1 .EQS. "MMS"
$ THEN
$   TYPE sys$input
  You can use the VAX/VMS make utility called MMS when answering "YES".
  Answering "NO" forces me to not use the MMS utility and to emulate the
  facilities VAX MMS has.
$ ENDIF
$ IF P1 .EQS. "LSE"
$ THEN
$   TYPE sys$input
  You can add the possible use of LSEDIT here. Answering "YES" inserts the
  callback functions to VMS NEWS (and requires then always when running a
  LSEDIT on the system). Answering "NO" disables the feature of callable LSE.
$ ENDIF
$ IF P1 .EQS. "MAIL_1"
$ THEN
$   TYPE sys$input
  Here you have to tell the installation if your host has Internet Mail or
  not. Answering "NO" disables Internet Mail at all within VMS NEWS. Answering
  "YES" enables the Internet Mailing facilities of VMS NEWS. "NEW" specifies
  that you Internet Mailer is able to perform callable MAIL as provided since
  VMS 5.0.
$ ENDIF
$ IF P1 .EQS. "MAIL_2"
$ THEN
$   TYPE sys$input
  Here you have to tell the installation if your Internet Mailer is able to
  perform callable MAIL (answer "YES") or not (answer "NO"). If you do not
  know exactly, the answer "NO" is the better choice.
$ ENDIF
$ IF P1 .EQS. "CLI"
$ THEN
$   TYPE sys$input
  To prevent misleading startup tries of VMS NEWS, you may disable the
  possibility of starting NEWS with "RUN" or within a symbol using "$".
  Answering with "YES" disables VMS NEWS startup via "RUN" and "$". Answering
  "NO" forces VMS NEWS to accept every calling mechanism and try to guess
  how it's called.
$ ENDIF
$ IF P1 .EQS. "LOGGING"
$ THEN
$   TYPE sys$input
  On sites with real security interests it seems to be needed to log
  every users news access. NEWS is able to log every users newsgroups
  access (but not to every article access).
  It is recommended to use this option ONLY on such sites - otherwise
  it may run into problems of privacy and freedom of information!
  Answering "YES" enables logging to a hardcoded file in the system
  managers directory.
$ ENDIF
$ IF P1 .EQS. "NODENAME"
$ THEN
$   TYPE sys$input
  Insert here the local E-MAIL address of your host. Normally this name
  is the same as the Internet Domain Name Service name of your host.
  On VAXclusters the E-MAIL address is sometimes the same on the whole
  cluster and differs from the Internet name.
  The variable $NODE instead of the host entry inserts on run-time the
  DECnet name as hostname (e.g. $NODE.domain.edu)
  The variable $LOGICAL inserts the logical name translation of
  NNTP_LOCALHOST (e.g. $LOGICAL.edu or just $LOGICAL)
$ ENDIF
$ IF P1 .EQS. "NNTPSERVER"
$ THEN
$   TYPE sys$input
  Insert your favorite NNTP server here. If you do not know where the
  next NNTP server is, try asking your network administrator. There is
  no way beyond knowing to find NNTP servers.
  When you access NNTP over DECnet, then insert here the DECnet nodename
  or nodenumber (without "::").
  If your host has problems with Domain Name Resolving then better enter
  the Internet Address Number here.
$ ENDIF
$ IF P1 .EQS. "NNTPPORT"
$ THEN
$   TYPE sys$input
  Insert the port of the above given NNTP server here. By default, Internet
  NNTP servers use port 119. When accessing NNTP over DECnet, you have to
  enter the DECnet object name or number (including the "=" at the end) here.
$ ENDIF
$ IF P1 .EQS. "MAILTRANS"
$ THEN
$   TYPE sys$input
  Insert the VMS MAIL prefix used by your Internet Mailer here. You have to
  encapsule the whole prefix in quotes ("...") to keep the required ones in
  mind of DCL.
  SMTP over DECnet should look like """NODE::"
  DEC's UCX Mailer uses by default "smtp%"""
  MX (from Joe Madison) uses by default "mx%"""
  PMDF (from InnoSoft) uses by default "in%"""
$ ENDIF
$ IF P1 .EQS. "ORGANISATION"
$ THEN
$   TYPE sys$input
  Insert a text string that represents you local organisation name (e.g.
  "University of Kansas, Comp. Sci. Dept.")
$ ENDIF
$ IF P1 .EQS. "TIMEZONE"
$ THEN
$   TYPE sys$input
  Insert the timezone code of your site here. (e.g. MET, CET, GMT+01)
  This character string has to be one that is understood by the NNTP server
  you want to use (unfortunately the format is not standardizied).
$ ENDIF
$ EXIT
$ ENDSUBROUTINE
!
!
!
$!******************************************************************************
$![end of file]
$!******************************************************************************
