/******************************************************************************
 *
 * VMS NEWS (part NEWS)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * MAIN startup file
 * ----------------------------------------------------------------------------
 *           bool article_start(int num)
 *                article_show_lines()
 *                article_end()
 *          char *article_search(char *pattern)
 *                article_line(int num,bool flag)
 *                article_redraw(int pos)
 *            int article_up(int screen,int num)
 *            int article_down(int screen,int num)
 *                article_header()
 *                article_handle(int article)
 * ----------------------------------------------------------------------------
 *                xhdr_call(char *topic,int start,int finish,int flag)
 *                group_start()
 *                group_end()
 *          char *group_line(int screen,int cursor)
 *                group_draw(char *text,int pos,bool flag)
 *                group_redraw(int screen,int cursor,bool cls)
 *            int group_up(int screen,int num)
 *            int group_down(int screen,int num)
 *                group_header()
 *                group_handle(char *group)
 * ----------------------------------------------------------------------------
 *            int newsgroups_next(int num,int anz)
 *            int newsgroups_last(int num,int anz)
 *            int newsgroups_diff(int low,int high)
 *          char *newsgroups_line(int screen,int cursor)
 *                newsgroups_draw(char *text,int pos,bool flag)
 *                newsgroups_redraw(int screen,int cursor,bool cls)
 *            int newsgroups_up(int screen,int num)
 *            int newsgroups_down(int screen,int num)
 *                newsgroups_header(bool flag)
 *                newsgroups_handle()
 * ----------------------------------------------------------------------------
 *                main()
 *
 ******************************************************************************/

#module NEWS "SYS V1.24"
#include "header.h"
#include <prvdef.h>

globalref int news_table;

/******************************************************************************/

bool article_start(num)
int num;
{
  char txt[256];

  header_lines=0; article_lines=0;
  sprintf(txt,"%s %d\r\n",CMD_ARTICLE,num);
  do_send(txt); nntp_data.article++;
  while (!header_lines) wait_sync();
  if (header_lines<0) { articles[articlepos].unread=FALSE; return FALSE; }
  while (do_getarticle) wait_sync();
  articles[articlepos].unread=FALSE;
  return TRUE;
}

/*----------------------------------------------------------------------------*/

article_show_lines()
{
  int anz,pos,per;

  if (noscr) return;
  anz=article_lines-article_top;
  if (!anz) { inp_comment("<End of display>"); return; }
  if ((pos=articlescreen-article_top+xROWS-4)>anz) pos=anz;
  per=(100*pos)/anz;
  if (pos==anz) inp_comment("<End of display>");
  else inp_comment("<Move with CURSOR - %d/%d lines (%d\%\%)>",pos,anz,per);
  set_cursor(input_id,1,7);
}

/*----------------------------------------------------------------------------*/

article_end()
{
  int i;

  for(i=0;i<header_lines;i++) if (header[i]!=NIL) { free(header[i]); header[i]=NIL; }
  header_lines=0;
  if (article_lines==0) return;
  for(i=0;i<article_lines;i++) if (article_text[i]!=NIL) { free(article_text[i]); article_text[i]=NIL; }
  article_lines=0;
}

/*----------------------------------------------------------------------------*/

char *article_search(pattern)
char *pattern;
{
  int i=0;
  char *tmp;

  while(i<header_lines && strncmp(pattern,header[i],strlen(pattern))) i++;
  if (i==header_lines) tmp="<none>\0";
  else {
    tmp=header[i]; while (*tmp!=' ' && *tmp) tmp++;
    while (*tmp==' ') tmp++;
  }
  return(tmp);
}

/*----------------------------------------------------------------------------*/

article_line(num,flag)
int num;
bool flag;
{
  char txt[256];

  if (noscr) return;
  if (num<0) {
    if (conf[NEWS_NUM_HEADERDISPLAY].value || (internal_mode&0x20))
      put_text(text_id,header[num-article_top],SMG$M_BOLD,0,flag);
    else {
      switch (-num) {
        case 4:  sprintf(txt,"Subject:      %-*.*s",xCOLS-14,xCOLS-14,article_search("Subject")); break;
        case 3:  sprintf(txt,"Date:         %-*.*s",xCOLS-14,xCOLS-14,article_search("Date")); break;
        case 2:  sprintf(txt,"From:         %-*.*s",xCOLS-14,xCOLS-14,article_search("From")); break;
        case 1:  sprintf(txt,"Organization: %-*.*s",xCOLS-14,xCOLS-14,article_search("Organization")); break;
        default: break;
      }
      if (num> -5) put_text(text_id,txt,SMG$M_BOLD,0,flag);
    }
  } else if (num<article_lines) put_text(text_id,article_text[num],0,0,flag);
}

/*----------------------------------------------------------------------------*/

article_redraw(pos)
int pos;
{
  int i;

  if (noscr) return;
  clear_display(text_id);
  set_cursor(text_id,1,1);
  for(i=pos;i-pos<xROWS-4;i++) article_line(i,TRUE);
}

/*----------------------------------------------------------------------------*/

int article_up(screen,num)
int screen,num;
{
  int i;

  for (i=0;i<num;i++) if (screen>article_top) {
    set_cursor(text_id,1,1);
    article_line(screen,FALSE);
    article_line(--screen,FALSE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

int article_down(screen,num)
int screen,num;
{
  int i;

  for (i=0;i<num;i++) if (screen+xROWS-4<article_lines) {
    set_cursor(text_id,xROWS-4,1);
    article_line(screen+xROWS-5,TRUE);
    article_line(++screen+xROWS-5,TRUE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

article_header()
{
  show_header(" VMS NEWS v%s --- %s, %s.#%d (%d - %d)",
    VERSION,groups[grouppos].name,(internal_mode&0x20?"Head":"Art"),
    articles[articlepos].number,groups[grouppos].use_start,groups[grouppos].finish);
}

/*----------------------------------------------------------------------------*/

article_handle(article)
int article;
{
  uword key=0;
  int i;
  char txt[256];

  internal_mode= 3|(internal_mode&0x20);
  article_header();
  if(!article_start(articles[article].number)) { article_end(); return; }
  if (internal_mode&0x20) article_lines=0;
  articlescreen=article_top;
  article_redraw(articlescreen);
  while (key!=0xffff) {
    article_show_lines();
    key=noscr?SMG$K_TRM_SPACE:read_key(kbd_id,0,0);
    for (i=0;i<34;i++) if (key==fkeys[i].smgvalue) {
      strcpy(txt,fkeys[i].command); key=0;
      if (*txt) {
        set_cursor(input_id,1,1);
        cli$dcl_parse(c$dsc(txt),&news_table,0,0,0);
        cli$dispatch();
        if (internal_mode&0x10 && internal_mode>0) key=0xffff;
        if (internal_mode<0) { key=0xffff; if (internal_mode!= -1) internal_mode=3; }
      }
    }
    if (key) switch (key) {
      case SMG$K_TRM_CR:
        set_cursor(input_id,1,1);
        cli$dcl_parse(c$dsc("DIR"),&news_table,0,0,0); cli$dispatch();
        if (internal_mode<0) { key=0xffff; if (internal_mode!= -1) internal_mode=3; }
        break;
      case SMG$K_TRM_CTRLW:
      case SMG$K_TRM_CTRLL:
        redraw_screen(paste_id); break;
      case SMG$K_TRM_CTRLR:
        set_cursor(input_id,1,1);
        cmd_quit(); break;
      case SMG$K_TRM_CTRLZ:
        cmd_exit(); break;
      case lower_chars:
      case upper_chars:
      case all_digits:
      case SMG$K_TRM_SPACE:
        set_cursor(input_id,1,1);
        cli_handle(key);
        if (internal_mode&0x10 && internal_mode>0) key=0xffff;
        if (internal_mode<0) { key=0xffff; if (internal_mode!= -1) internal_mode=3; }
        break;
      default:
        break;
    }
  }
  article_end();
}

/******************************************************************************/

xhdr_call(topic,start,finish,flag)
char *topic;
int start,finish,flag;
{
  char txt[256],*ptr,*p;

  ptr=txt; p=topic; while (*p) *ptr++ = toupper(*p++); *ptr='\0';
  if (flag) inp_comment("[Request for %s data]",txt);
  if (start==0 && finish==0) {
    articleanz=0;
    sprintf(txt,"%s %s %d-%d\r\n",CMD_XHDR,topic,groups[grouppos].use_start,groups[grouppos].finish);
  } else sprintf(txt,"%s %s %d-%d\r\n",CMD_XHDR,topic,start,finish);
  xhdr_mode=TRUE; nntp_data.xhdr++; do_articlelist= -1; do_send(txt);
  while (do_articlelist!=0) wait_sync();
}

/******************************************************************************/

group_start()
{
  int tim=1,a,b,c,m,n,flag;
  char txt[256];
  struct TmpArtList *art_tmp;
  extern int compare2();

  a=groups[grouppos].use_start;
  b=min(a+XHDR_INTERVAL,groups[grouppos].finish);
  c=0;
  if (!all_article && groups[grouppos].registered) {
    art_tmp = (struct TmpArtList *)malloc(sizeof(struct TmpArtList)
		*(groups[grouppos].finish-groups[grouppos].use_start+1));
    group_start_parser(grouppos,art_tmp);
  }

  while (TRUE) {
    if (!all_article && groups[grouppos].registered) {
      art_tmp = (struct TmpArtList *)malloc(sizeof(struct TmpArtList)
		*(groups[grouppos].finish-groups[grouppos].use_start+1));
      group_start_parser(grouppos,art_tmp);
      articleanz=c;
      flag=TRUE;
      for (n=a; n<=b; n++) {
        if (art_tmp[n-groups[grouppos].use_start].unread) {
	  for(m=n+1; m<=b; m++)
	    if (!art_tmp[m-groups[grouppos].use_start].unread)
	      break;
	  xhdr_call("subject",n,m-1,flag);
	  flag=FALSE;
	  n = m+1;
        }
      }
      if (articleanz!=c) {
        if (conf[NEWS_NUM_GROUPLINES].value) { 
	  articleanz=c;
	  flag=TRUE;
          for (n=a; n<=b; n++) {
            if (art_tmp[n-groups[grouppos].use_start].unread) {
	      for(m=n+1; m<=b; m++)
	        if (!art_tmp[m-groups[grouppos].use_start].unread)
	          break;
	      xhdr_call("lines",n,m-1,flag);
	      flag=FALSE;
	      n = m + 1;
	    }
          }
        }
        if (conf[NEWS_NUM_GROUPAUTHORS].value) { 
	  articleanz=c; 
	  flag=TRUE;
          for (n=a; n<=b; n++) {
            if (art_tmp[n-groups[grouppos].use_start].unread) {
	      for(m=n+1; m<=b; m++)
	        if (!art_tmp[m-groups[grouppos].use_start].unread)
	          break;
	      xhdr_call("from",n,m-1,flag);
	      flag=FALSE;
	      n = m+1;
	    }
          }
        }
        if (conf[NEWS_NUM_GROUPDATE].value) { 
	  articleanz=c; 
	  flag=TRUE;
          for (n=a; n<=b; n++) {
            if (art_tmp[n-groups[grouppos].use_start].unread) {
	      for(m=n+1; m<=b; m++)
	        if (!art_tmp[m-groups[grouppos].use_start].unread)
	          break;
	      xhdr_call("date",n,m-1,flag);
	      flag=FALSE;
	      n = m+1;
	    }
          }
        }
        if (conf[NEWS_NUM_SORTGROUP].value==2) {
          articleanz=c; 
	  flag=TRUE;
          for (n=a; n<=b; n++) {
            if (art_tmp[n-groups[grouppos].use_start].unread) {
	      for(m=n+1; m<=b; m++)
	        if (!art_tmp[m-groups[grouppos].use_start].unread)
	          break;
	      xhdr_call("message-id",n,m-1,flag);
	      flag=FALSE;
	      n = m + 1;
	    }
          }
          articleanz=c; 
	  flag=TRUE;
          for (n=a; n<=b; n++) {
            if (art_tmp[n-groups[grouppos].use_start].unread) {
	      for(m=n+1; m<=b; m++)
	        if (!art_tmp[m-groups[grouppos].use_start].unread)
	          break;
	      xhdr_call("references",n,m-1,flag);
	      flag=FALSE;
	      n = m+1;
	    }
          }
        }
        c=articleanz;
      }
    } else {
      articleanz=c; xhdr_call("subject",a,b,TRUE);
      if (articleanz!=c) {
        if (conf[NEWS_NUM_GROUPLINES].value) { articleanz=c; xhdr_call("lines",a,b,TRUE); }
        if (conf[NEWS_NUM_GROUPAUTHORS].value) { articleanz=c; xhdr_call("from",a,b,TRUE); }
        if (conf[NEWS_NUM_GROUPDATE].value) { articleanz=c; xhdr_call("date",a,b,TRUE); }
        if (conf[NEWS_NUM_SORTGROUP].value==2) {
          articleanz=c; xhdr_call("message-id",a,b,TRUE);
          articleanz=c; xhdr_call("references",a,b,TRUE);
        }
        c=articleanz;
      }
    }
    a=b+1; b=min(a+XHDR_INTERVAL,groups[grouppos].finish);
    if (a>groups[grouppos].finish) break;
  }
  if (!all_article && groups[grouppos].registered) {
    free(art_tmp);
  }
  if (conf[NEWS_NUM_SORTGROUP].value==1)
    qsort(articles,articleanz,sizeof(struct ArtList),compare2);
  if (conf[NEWS_NUM_SORTGROUP].value==2) group_thread_sort();
  if (!noscr) put_text(input_id,NEWS_PROMPT,0,0,TRUE);
}

/*----------------------------------------------------------------------------*/

group_end()
{
  int i;

  if (*oldgroup) return;
  for (i=0;i<oldanz;i++) {
    if (articles[i].subject!=NIL)    { free(articles[i].subject); articles[i].subject=NIL; }
    if (articles[i].from!=NIL)       { free(articles[i].from); articles[i].from=NIL; }
    if (articles[i].date!=NIL)       { free(articles[i].date); articles[i].date=NIL; }
    if (articles[i].keywords!=NIL)   { free(articles[i].keywords); articles[i].keywords=NIL; }
    if (articles[i].summary!=NIL)    { free(articles[i].summary); articles[i].summary=NIL; }
    if (articles[i].message_id!=NIL) { free(articles[i].message_id); articles[i].message_id=NIL; }
    if (articles[i].references!=NIL) { free(articles[i].references); articles[i].references=NIL; }
    articles[i].lines=0;
    articles[i].number=0;
  }
  oldanz=0; oldgroup[0]='\0';
}

/*----------------------------------------------------------------------------*/

char *group_line(scr,curs)
int scr,curs;
{
  char txt[256],subj[256],from[256]="\0",*tp,lines[20];
  int i;

  if ((i=articles[scr].lines)>0) sprintf(lines,"%d",i);
  else strcpy(lines,(i==0)?" ":"Err");
  if (articles[scr].date!=NIL && conf[NEWS_NUM_GROUPDATE].value) {
    tp=articles[scr].date; while (!isdigit(*tp) && *tp) tp++;
    strcpy(txt,tp); tp=txt;
    while (*tp!=' ' && *tp) tp++; while (*tp==' ') tp++;
    while (*tp!=' ' && *tp) tp++; *tp++ ='\0';
    i=atoi(tp)%100; sprintf(subj,"%6.6s %02d  %s",txt,i,articles[scr].subject);
  } else { strncpy(subj,articles[scr].subject,255); subj[255]='\0'; }
  if (articles[scr].from!=NIL) {
    strcpy(txt,articles[scr].from); tp=txt;
    if ((tp=strchr(txt,'<'))!=NULL) {
      do tp--; while (*tp==' '); *++tp='\0';
      if (*--tp=='"') { *tp='\0'; tp=txt+1; } else tp=txt;
      strcpy(from,tp);
    } else if ((tp=strchr(txt,'('))!=NULL) {
      tp++; strcpy(from,tp); from[strlen(from)-1]='\0';
    }
    if (conf[NEWS_NUM_GROUPAUTHORS].value==1 && !*from) {
      tp=txt; while (*tp && *tp!=' ' && *tp!='!' && *tp!='%' && *tp!='@') tp++;
      if (*tp) *tp='\0'; strcpy(from,txt);
    }
    if (!*from) strcpy(from,txt);
  }

  if (*from) {
    if (conf[NEWS_NUM_GROUPLINES].value) {
      sprintf(txt,"%s %5d %-*.*s %-14.14s %4s",(curs==scr?"==>":"   "),
        articles[scr].number,xCOLS-30,xCOLS-30,subj,from,lines);
    } else {
      sprintf(txt,"%s %5d %-*.*s %-14.14s",(curs==scr?"==>":"   "),
        articles[scr].number,xCOLS-25,xCOLS-25,subj,from);
    }
  } else
    if (conf[NEWS_NUM_GROUPLINES].value) {
      sprintf(txt,"%s %5d %-*.*s %4s",(curs==scr?"==>":"   "),
        articles[scr].number,xCOLS-15,xCOLS-15,subj,lines);
    } else {
      sprintf(txt,"%s %5d %-*.*s",(curs==scr?"==>":"   "),
        articles[scr].number,xCOLS-10,xCOLS-10,subj);
    }
  if (articles[scr].unread && conf[NEWS_NUM_DUMPTERM].value) txt[9]='*';
  return(txt);
}

/*----------------------------------------------------------------------------*/

group_draw(text,pos,flag)
char *text;
int pos;
bool flag;
{
  int j;
  char mask[256];

  if (noscr) return;
  if (!articles[pos].unread || !groups[grouppos].registered ||
      conf[NEWS_NUM_DUMPTERM].value) put_text(text_id,text,0,0,flag);
  else {
    for (j=0;j<strlen(text);j++) mask[j]=(j<10)?SMG$M_BOLD:SMG$M_NOATTR;
    mask[strlen(text)]='\0';
    put_multi(text_id,text,mask,0,flag);
  }
}

/*----------------------------------------------------------------------------*/

group_redraw(screen,cursor,cls)
int screen,cursor;
bool cls;
{
  int i;
  char txt[256];

  if (noscr) return;
  if (cls) clear_display(text_id);
  set_cursor(text_id,1,1);
  for(i=screen;i-screen<xROWS-4;i++) if (i<articleanz) {
    strcpy(txt,group_line(i,cursor)); group_draw(txt,i,TRUE);
  }
  if (!cls) while (i<xROWS-4) {
    strcpy(txt,"                                                                               ");
    put_text(text_id,txt,0,0,TRUE);
    i++;
  }
}

/*----------------------------------------------------------------------------*/

int group_up(screen,num)
int screen,num;
{
  int i;
  char txt[256];

  if (articlepos) {
    set_cursor(text_id,articlepos-screen+1,1);
    strcpy(txt,group_line(articlepos,articlepos-1));
    group_draw(txt,articlepos,FALSE);
    for (i=0;i<num;i++) if (articlepos) {
      articlepos--; if (articlepos<screen) screen--;
      strcpy(txt,group_line(articlepos,articlepos+1));
      group_draw(txt,articlepos,FALSE);
    }
    set_cursor(text_id,articlepos-screen+1,1);
    strcpy(txt,group_line(articlepos,articlepos));
    group_draw(txt,articlepos,FALSE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

int group_down(screen,num)
int screen,num;
{
  int i;
  char txt[256];

  if (articlepos<articleanz-1) {
    set_cursor(text_id,articlepos-screen+1,1);
    strcpy(txt,group_line(articlepos,articlepos+1));
    group_draw(txt,articlepos,TRUE);
    for (i=0;i<num;i++) if (articlepos<articleanz-1) {
      articlepos++; if (articlepos-screen>xROWS-5) screen++;
      strcpy(txt,group_line(articlepos,articlepos-1));
      group_draw(txt,articlepos,TRUE);
    }
    set_cursor(text_id,articlepos-screen+1,1);
    strcpy(txt,group_line(articlepos,articlepos));
    group_draw(txt,articlepos,TRUE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

group_header()
{
  show_header(" VMS NEWS v%s --- %s (#%d) %d - %d",VERSION,groups[grouppos].name,
    groups[grouppos].articles,groups[grouppos].use_start,groups[grouppos].finish);
}

/*----------------------------------------------------------------------------*/

group_handle(groupnam)
char *groupnam;
{
  int i;
  uword key=0;
  char tmp[256],txt[256];
  globalvalue int NEWS$_NOARTSRV,NEWS$_GRPSEL,NEWS$_ARTSEL,NEWS$_NONEWART,
	NEWS$_LACKITEM;

#ifdef LOGGING
  write_logging(groupnam);
#endif
  old_read= -1;
  internal_mode=2|(internal_mode&0x10);
  if (strcmp(groups[grouppos].name,oldgroup) ||
      (internal_mode2!=2 && groups[grouppos].registered)) {
    sprintf(tmp,"%s %s\r\n",CMD_GROUP,groupnam);
    groups[grouppos].articles= -1;
    do_send(tmp); nntp_data.group++;
    while (groups[grouppos].articles<0) wait_sync();
    groups[grouppos].use_start=groups[grouppos].start;
  }
  if (groups[grouppos].articles==0) {
    strcpy(fao,c$asc(groups[grouppos].name)); geterror(fac,NEWS$_NOARTSRV,fao);
    oldgroup[0]='\0';
    return;
  }
  group_header();
  if (strcmp(groups[grouppos].name,oldgroup) ||
      (internal_mode2!=2 && oldanz<groups[grouppos].articles)) {
    strcpy(fao,c$asc(groups[grouppos].name));
    if (all_article)
       geterror(fac,NEWS$_GRPSEL,fao,groups[grouppos].articles);
    else
       geterror(fac,NEWS$_GRPSEL, fao,groups[grouppos].unread);
    if ((internal_mode2==2 || internal_mode&0x10) && groups[grouppos].registered) {
      groups[grouppos].use_start=group_search_start(grouppos);
      sprintf(prefix,"<%d ",groups[grouppos].use_start-1);
      if (groups[grouppos].use_start>groups[grouppos].finish) {
        strcpy(fao,c$asc(groups[grouppos].name)); geterror(fac,NEWS$_NONEWART,fao);
        internal_mode2=0; return;
      }
    } else strcpy(prefix,"");
    group_end();
    group_start();
    if (articleanz == 0) {
      strcpy(fao,c$asc(groups[grouppos].name));
      geterror(fac,NEWS$_LACKITEM,fao);
      internal_mode2=0; return;
    }
    strcpy(oldgroup,groups[grouppos].name); oldanz=articleanz;
    if (groups[grouppos].registered) group_read_parser(grouppos);
    articlepos=0; subjectscreen=0;
  }
  internal_mode2=0;
  if (internal_mode&0x10) {
    for (i=0;i<articleanz;i++) if (articles[i].unread) break;
    if (i==articleanz || !groups[grouppos].registered) goto grpend;
    else {
      articlepos=i;
      subjectscreen=articlepos-xROWS+5; if (subjectscreen<0) subjectscreen=0;
    }
  } else {
    clear_display(text_id);
    cli$dcl_parse(c$dsc(conf[NEWS_NUM_GROUPENTRY].text),&news_table,0,0,0);
    cli$dispatch();
  }
  while (key!=0xffff) {
    if (internal_mode&0x10) key=SMG$K_TRM_CR;
    else key=noscr?SMG$K_TRM_SPACE:read_key(kbd_id,NEWS_PROMPT,input_id);
    for (i=0;i<34;i++) if (key==fkeys[i].smgvalue) {
      strcpy(txt,fkeys[i].command); key=0;
      if (*txt) {
        cli$dcl_parse(c$dsc(txt),&news_table,0,0,0);
        cli$dispatch();
        if (internal_mode&0x10 && internal_mode>0) {
          for (i=articlepos;i<articleanz;i++) if (articles[i].unread) break;
          if (i==articleanz || !groups[grouppos].registered) goto grpend;
          else {
            articlepos=i;
            subjectscreen=articlepos-xROWS+5; if (subjectscreen<0) subjectscreen=0;
            key=SMG$K_TRM_CR;
          }
        }
        if (internal_mode<0) { internal_mode *= -1; key=0xffff; }
      }
    }
    if (noscr) geterror(fac,NEWS$_ARTSEL,articles[articlepos].number,groups[grouppos].use_start,groups[grouppos].finish,articleanz);
    if (key) switch (key) {
      case SMG$K_TRM_CR:
        article_handle(articlepos);
        old_read=articles[articlepos].number;
        if (internal_mode&0x10 && internal_mode>0) {
          for (i=articlepos+1;i<articleanz;i++) if (articles[i].unread) break;
          if (i==articleanz || !groups[grouppos].registered) goto grpend;
          else {
            articlepos=i;
            subjectscreen=articlepos-xROWS+5; if (subjectscreen<0) subjectscreen=0;
          }
        } else if (internal_mode<0) { key=0xffff; internal_mode=2;
        } else {
          group_header();
          internal_mode=2;
          group_redraw(subjectscreen,articlepos,TRUE);
        }
        break;
      case SMG$K_TRM_CTRLW:
      case SMG$K_TRM_CTRLL:
        redraw_screen(paste_id); break;
      case SMG$K_TRM_CTRLR:
        cmd_quit(); break;
      case SMG$K_TRM_CTRLZ:
        cmd_exit(); break;
      case lower_chars:
      case upper_chars:
      case all_digits:
      case SMG$K_TRM_SPACE:
        cli_handle(key);
        if (internal_mode<0) { internal_mode *= -1; key=0xffff; }
        if (internal_mode&0x20) {
          article_handle(articlepos);
          if (internal_mode<0) { key=0xffff; internal_mode=2;
          } else {
            group_header();
            internal_mode=2;
            group_redraw(subjectscreen,articlepos,TRUE);
          }
        }
        if (internal_mode&0x10) {
          for (i=articlepos;i<articleanz;i++) if (articles[i].unread) break;
          if (i==articleanz || !groups[grouppos].registered) goto grpend;
          else {
            articlepos=i;
            subjectscreen=articlepos-xROWS+5; if (subjectscreen<0) subjectscreen=0;
          }
        }
        break;
      default:
        break;
    }
  }
grpend:
  if (groups[grouppos].registered) {
    group_save_parser(grouppos);
    if (conf[NEWS_NUM_AUTOSAVE].value) write_resource(FALSE);
  }
}

/******************************************************************************/

int newsgroups_next(num,anz)
int num,anz;
{
  int i,cnt,last= -1;

  i=num+1; if (i>=groupanz) return(-1);
  cnt=0; while (cnt<anz) {
    while (i<groupanz) {
      if ((!registered_mode || groups[i].registered) &&
          (allgroups_mode || groups[i].articles>0) &&
          (!unreadonly_mode || groups[i].unread>0) &&
          (!pattern_mode || groups[i].pattern)) break;
      i++;
    }
    if (i>=groupanz) break;
    last=i; cnt++; if (cnt<anz) i++;
  }
  if (anz>1 && i==groupanz) i=last;
  if (i<groupanz) return(i);
  else return(-1);
}

/*----------------------------------------------------------------------------*/

int newsgroups_last(num,anz)
int num,anz;
{
  int i,cnt,last= -1;

  i=num-1; if (i<0) return(-1);
  cnt=0; while (cnt<anz) {
    while (i>=0) {
      if ((!registered_mode || groups[i].registered) &&
          (allgroups_mode || groups[i].articles>0) &&
          (!unreadonly_mode || groups[i].unread>0) &&
          (!pattern_mode || groups[i].pattern)) break;
      i--;
    }
    if (i<0) break;
    last=i; cnt++; if (cnt<anz) i--;
  }
  if (anz>1 && i== -1) i=last;
  if (i>=0) return(i);
  else return(-1);
}

/*----------------------------------------------------------------------------*/

int newsgroups_diff(low,high)
int low,high;
{
  int cnt,pos,end;

  pos=low; end=high; if (low>high) { pos=high; end=low; }
  cnt=0;
  while (pos<end) {
    if((pos=newsgroups_next(pos,1))<0) break;
    cnt++;
  }
  return(cnt);
}

/*----------------------------------------------------------------------------*/

char *newsgroups_line(num,curs)
int num,curs;
{
  char t1[16],t2[16],t3[8],txt[256];
  int start;

  start=newsgroups_diff(newsgroups_next(-1,1),num)+1;
  if (groups[num].articles==0) strcpy(t1,"     ");
  else sprintf(t1,"%5d",groups[num].articles);
  if (groups[num].unread==0) strcpy(t2,"     ");
  else sprintf(t2,"%5d",groups[num].unread);
  if (!groups[num].registered && groups[num].unread) strcpy(t2,"    -");
  switch (groups[num].mode) {
    case NEWS_GRP_MODERATED: strcpy(t3,"Mod"); break;
    case NEWS_GRP_POSTING:   strcpy(t3,posting?"   ":"Dis"); break;
    case NEWS_GRP_NOPOSTING: strcpy(t3,"Dis"); break;
    case NEWS_GRP_CROSSREF:  strcpy(t3,"Xrf"); break;
  }
  sprintf(txt,"%s %4d %-*s %s %s %s",(num==curs?"==>":"   "),
    start,xCOLS-25,groups[num].name,t2,t1,t3);
  return(txt);
}

/*----------------------------------------------------------------------------*/

newsgroups_draw(text,pos,flag)
char *text;
int pos;
bool flag;
{
  int j;
  char mask[256];

  if (noscr) return;
  if (!groups[pos].registered) put_text(text_id,text,0,0,flag);
  else {
    for (j=0;j<strlen(text);j++) mask[j]=(j<8)?SMG$M_BOLD:SMG$M_NOATTR;
    mask[strlen(text)]='\0';
    put_multi(text_id,text,mask,0,flag);
  }
}

/*----------------------------------------------------------------------------*/

newsgroups_redraw(screen,cursor,cls)
int screen,cursor;
bool cls;
{
  int i,pos;
  char txt[256];

  if (noscr) return;
  if (cls) clear_display(text_id);
  set_cursor(text_id,1,1);
  i=0; pos=screen; while (i<xROWS-4) {
    if (pos>=0) {
      strcpy(txt,newsgroups_line(pos,cursor)); newsgroups_draw(txt,pos,TRUE);
    } else break;
    i++; pos=newsgroups_next(pos,1);
  }
  if (!cls) while (i<xROWS-4) {
    strcpy(txt,"                                                                               ");
    put_text(text_id,txt,0,0,TRUE);
    i++;
  }
}

/*----------------------------------------------------------------------------*/

int newsgroups_up(screen,num)
int screen,num;
{
  int i,pos;
  char txt[256];

  if (grouppos) {
    set_cursor(text_id,newsgroups_diff(screen,grouppos)+1,1);
    strcpy(txt,newsgroups_line(grouppos,grouppos-1));
    newsgroups_draw(txt,grouppos,FALSE);
    i=0; pos=grouppos; while (i<num) {
      pos=newsgroups_last(pos,1);
      if (pos>=0) {
        grouppos=pos; if (grouppos<screen) screen=pos;
        strcpy(txt,newsgroups_line(grouppos,grouppos+1));
        newsgroups_draw(txt,grouppos,FALSE);
      } else break;
      i++;
    }
    set_cursor(text_id,newsgroups_diff(screen,grouppos)+1,1);
    strcpy(txt,newsgroups_line(grouppos,grouppos));
    newsgroups_draw(txt,grouppos,FALSE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

int newsgroups_down(screen,num)
int screen,num;
{
  int i,pos;
  char txt[256];

  if (grouppos<groupanz-1) {
    set_cursor(text_id,newsgroups_diff(screen,grouppos)+1,1);
    strcpy(txt,newsgroups_line(grouppos,grouppos+1));
    newsgroups_draw(txt,grouppos,TRUE);
    i=0; pos=grouppos; while (i<num) {
      pos=newsgroups_next(pos,1);
      if (pos>=0) {
        grouppos=pos;
        if (newsgroups_diff(screen,grouppos)>xROWS-5) screen=newsgroups_next(screen,1);
        strcpy(txt,newsgroups_line(grouppos,grouppos-1));
        newsgroups_draw(txt,grouppos,TRUE);
      } else break;
      i++;
    }
    set_cursor(text_id,newsgroups_diff(screen,grouppos)+1,1);
    strcpy(txt,newsgroups_line(grouppos,grouppos));
    newsgroups_draw(txt,grouppos,TRUE);
  }
  return(screen);
}

/*----------------------------------------------------------------------------*/

newsgroups_header(flag)
bool flag;
{
  int i;
  char *t;
  bool x;

  x= !unreadonly_mode;
  if (!pattern_mode) {
    if (registered_mode && allgroups_mode)   t=x?"REGISTERED":"REG,UNREAD";
    if (registered_mode && !allgroups_mode)  t=x?"REG,USED":"REG,USED,UNREAD";
    if (!registered_mode && allgroups_mode)  t="TOTAL";
    if (!registered_mode && !allgroups_mode) t="USED";
  } else {
    if (registered_mode && allgroups_mode)
      t=x?"REG,PTN":"REG,UNREAD,PTN";
    if (registered_mode && !allgroups_mode)
      t=x?"REG,USED,PTN":"REG,USED,UNREAD,PTN";
    if (!registered_mode && allgroups_mode)  t="TOTAL,PTN";
    if (!registered_mode && !allgroups_mode) t="USED,PTN";
  }

  if (pattern_mode || registered_mode || !allgroups_mode || unreadonly_mode)
    i=newsgroups_diff(newsgroups_next(-1,1),newsgroups_last(groupanz,1))+1;
  else i=groupanz;
  show_header(" VMS NEWS v%s --- Newsgroups [%s] %d (Posting %s)",VERSION,t,i,posting?"OK":"none");
  newsgroups_redraw(groupscreen,grouppos,flag);
}

/*----------------------------------------------------------------------------*/

newsgroups_handle()
{
  int i;
  uword key=0;
  char txt[256];
  bool art_new;
  char *ptr,*p,*pt;
  char delim;
  int *article_read;
  int val1, val2;
  globalvalue int NEWS$_NOMORUNR,NEWS$_NOART,NEWS$_NONEWART;

  internal_mode=1;
  if (conf[NEWS_NUM_NEWSENTRY].value&1) allgroups_mode=FALSE;
  if (conf[NEWS_NUM_NEWSENTRY].value&2) registered_mode=TRUE;
  if (conf[NEWS_NUM_NEWSENTRY].value&4) unreadonly_mode=TRUE;
  groupscreen=grouppos=newsgroups_next(-1,1);
  if (groupscreen<0) {
    groupscreen=grouppos=0;
    allgroups_mode=TRUE; registered_mode=FALSE; unreadonly_mode=FALSE;
  }
  newsgroups_redraw(groupscreen,grouppos,TRUE);
  while (TRUE) {
    if (internal_mode2) key=SMG$K_TRM_CR;
    else if (internal_mode&0x10) key=SMG$K_TRM_CR;
    else if (internal_mode&0x20 && noscr) { key=SMG$K_TRM_CR; internal_mode=1; }
    else key=noscr?SMG$K_TRM_SPACE:read_key(kbd_id,NEWS_PROMPT,input_id);
    for (i=0;i<34;i++) if (key==fkeys[i].smgvalue) {
      strcpy(txt,fkeys[i].command); key=0;
      if (*txt) {
        cli$dcl_parse(c$dsc(txt),&news_table,0,0,0);
        cli$dispatch();
        if (internal_mode&0x10 && internal_mode>0) {
          for (i=grouppos;i<groupanz;i++)
            if (groups[i].unread>0 && groups[i].registered) break;
          if (i==groupanz) {
            geterror(fac,NEWS$_NOMORUNR);
            internal_mode=1;
            newsgroups_header(TRUE);
          } else {
            grouppos=i;
            groupscreen=newsgroups_last(grouppos,xROWS-5); if (groupscreen<0) groupscreen=0;
            key=SMG$K_TRM_CR;
          }
        }
        if (internal_mode<0) { internal_mode *= -1; newsgroups_header(TRUE); }
      }
    }
    if (key) switch (key) {
      case SMG$K_TRM_CR:
        if (groups[grouppos].articles == 0) {
          strcpy(fao,c$asc(groups[grouppos].name)); geterror(fac,NEWS$_NOART,fao);
          internal_mode2=0;
	} else if (!all_article && groups[grouppos].registered 
		&& groups[grouppos].unread == 0) {
          strcpy(fao,c$asc(groups[grouppos].name)); 
	  geterror(fac,NEWS$_NONEWART,fao);
          internal_mode2=0;
        } else {
          art_new = TRUE;
          pt = groups[grouppos].read_art;
          if(!all_article && pt != NIL) {
            article_read=(int *)malloc(sizeof(int)
                 *(groups[grouppos].finish-groups[grouppos].start+1));
            for(i=0;i <= groups[grouppos].finish-groups[grouppos].start;i++)
              article_read[i]=0;
            p = (char *)malloc((strlen(pt) + 1)*sizeof(char));
            strcpy(p, pt);
            pt = p;
            while (*p == ' ') p++;
            if (*p=='<') {
              ptr= ++p; while (*p && *p!=' ') p++; if (*p) *p++ ='\0';
              val1=atoi(ptr); for(i=groups[grouppos].start;i <= val1;i++)
              article_read[i-groups[grouppos].start] = 1;
            }
            while (*p) {
              ptr=p; while (*p && *p!=' ' && *p!='-') p++;
              delim = *p; if (*p) *p++ ='\0'; val1=val2=atoi(ptr);
              if (delim == '-') {
                ptr=p; while (*p && *p!=' ') p++; if (*p) *p++ ='\0';
                val2=atoi(ptr);
              }
              for(i=val1;i<=val2;i++) {
                if (i<=groups[grouppos].finish && groups[grouppos].start<=i)
                  article_read[i-groups[grouppos].start] = 1;
              }
            }
            art_new = FALSE;
            for (i=0; i <= groups[grouppos].finish-groups[grouppos].start; i++){
              if (article_read[i] != 1) {
                art_new = TRUE;
                break;
              }
            }
            free(pt);
            free(article_read);
          }

          if (!art_new) {
            strcpy(fao,c$asc(groups[grouppos].name));
            geterror(fac,NEWS$_NONEWART,fao);
          } else {
            group_handle(groups[grouppos].name);
            if (internal_mode&0x10 && internal_mode>0) {
              for (i=grouppos+1;i<groupanz;i++)
                if (groups[i].unread>0 && groups[i].registered) break;
              if (i==groupanz) {
                geterror(fac,NEWS$_NOMORUNR);
                internal_mode=1;
                newsgroups_header(TRUE);
              } else {
                grouppos=i;
                groupscreen=newsgroups_last(grouppos,xROWS-5); if (groupscreen<0) groupscreen=0;
              }
            } else {
              if (unreadonly_mode && groups[grouppos].unread==0) {
                i=newsgroups_next(grouppos,1);
                if (i<0) i=newsgroups_last(grouppos,1);
                if (i<0) {
                  unreadonly_mode=FALSE;
                  groupscreen=grouppos=newsgroups_next(-1,1);
                } else { if (groupscreen==grouppos) groupscreen=i; grouppos=i; }
              }
              if (registered_mode && !groups[grouppos].registered) {
                i=newsgroups_next(grouppos,1);
                if (i<0) i=newsgroups_last(grouppos,1);
                if (i<0) {
                  registered_mode=FALSE;
                  groupscreen=grouppos=newsgroups_next(-1,1);
                } else { if (groupscreen==grouppos) groupscreen=i; grouppos=i; }
              }
              if (pattern_mode && !groups[grouppos].pattern) {
                i=newsgroups_next(grouppos,1);
                if (i<0) i=newsgroups_last(grouppos,1);
                if (i<0) {
                  pattern_mode=FALSE;
                  groupscreen=grouppos=newsgroups_next(-1,1);
                } else { if (groupscreen==grouppos) groupscreen=i; grouppos=i; }
              }
              newsgroups_header(TRUE); internal_mode=1;
            }
          }
        }
        break;
      case SMG$K_TRM_CTRLW:
      case SMG$K_TRM_CTRLL:
        redraw_screen(paste_id); break;
      case SMG$K_TRM_CTRLR:
        cmd_quit(); break;
      case SMG$K_TRM_CTRLZ:
        cmd_exit(); break;
      case lower_chars:
      case upper_chars:
      case all_digits:
      case SMG$K_TRM_SPACE:
        cli_handle(key);
        if (internal_mode&0x10 && internal_mode>0) {
          for (i=grouppos;i<groupanz;i++)
            if (groups[i].unread>0 && groups[i].registered) break;
          if (i==groupanz) {
            geterror(fac,NEWS$_NOMORUNR);
            internal_mode=1;
            newsgroups_header(TRUE);
          } else {
            grouppos=i;
            groupscreen=newsgroups_last(grouppos,xROWS-5); if (groupscreen<0) groupscreen=0;
          }
        }
        if (internal_mode<0) { internal_mode *= -1; newsgroups_header(TRUE); }
        break;
      default:
        break;
    }
  }
}

/******************************************************************************/

main()
{
  char enbflg=0;
  quad prv={PRV$M_SYSPRV,0};

  sys$setprv(&enbflg,&prv,0,0);		/* remove possible installed SYSPRV   */
  display_order();			/* define PROFILE data display order  */
  read_configuration();			/* read global/local configuration    */
  read_parameters();			/* check command line parameters      */
  window_setup();			/* setup SMG$ based window system     */
  if (!conf[NEWS_NUM_PORT].value) {	/* show a nice header before starting */
    decnet=TRUE;
    show_header(" (c)1990 VMS NEWS v%s using DECnet by Bernd Onasch",VERSION);
  } else show_header(" (c)1990 VMS NEWS v%s using %s by Bernd Onasch",VERSION,TRANSPORT);
  if (decnet)				/* open network communication channel */
    decnet_start(conf[NEWS_NUM_SERVER].text,conf[NEWS_NUM_PORT].text);
  else {
    net_start(conf[NEWS_NUM_SERVER].text,conf[NEWS_NUM_PORT].value);
    net_info();
  }
  news_start(FALSE);                    /* start chatting with NNTP server    */
  if (conf[NEWS_NUM_CLOCK].value)
    clock_handle(TRUE);			/* enable clock - if anybody wants it */
  newsgroups_handle();			/* start reading - in NEWSGROUPS mode */
  sys$exit(SS$_NORMAL);			/* i think we never reach this        */
}

/******************************************************************************/
