/******************************************************************************
 *
 * VMS NEWS - Additional program TALK
 *
 * Copyright 1992 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************/

#module TALK "TALK V0.92"
#include <stdio.h>
#include <curses.h>
#include <ctype.h>
#include <descrip.h>
#include <climsgdef.h>
#include <ssdef.h>
#include <iodef.h>
#include <jpidef.h>
#include <dvidef.h>
#include <varargs.h>
#include "version.h"

/******************************************************************************/

typedef char					bool;
typedef char					byte;
typedef short int				word;
typedef unsigned char				ubyte;
typedef unsigned short int			uword;
typedef unsigned long				ulong;
typedef struct { unsigned long l1; long l2; }	quad;

/*** VMS default item_list_3 structure ***/
struct ItemList {
	short buffer_length;
	short item_code;
	long buffer_address;
	long return_length_address;
};

/*** TCP/IP connection structure ***/
struct TCPdata {
	ulong foreign_port;
	char  foreign_host[128];
	ubyte foreign_ip[4];
	ulong local_port;
	char  local_host[128];
	ubyte local_ip[4];
	ulong send_bytes;
	ulong send_packets;
	ulong received_bytes;
	ulong received_packets;
};

/******************************************************************************/

#define BELL		0x07
#define TELNET_NOECHO	0xfb
#define TELNET_ECHO	0xfc

/******************************************************************************/

#define NETBUFFER	1024
#define MAXHIST		30
#define NIL		((void *) 0)

#define min(a,b)	((a)<(b)?(a):(b))
#define max(a,b)	((a)>(b)?(a):(b))
#define upcase(c)	(islower(c)?toupper(c):(c))
#define locase(c)	(isupper(c)?tolower(c):(c))
#define isspace(c)	(strchr(" .,:;()[]{}<>",(c))!=0)
#define isterminator(c)	(strchr(" ?!.,;:-",(c))!=0)
#define ringplus(a,b)	(((a)<(b)-1)?(a)+1:0)
#define ringminus(a,b)	((a)?(a)-1:(b)-1)
#define SHOWHELP(text)	{ int tmp;\
			  tmp=col; col=0;\
			  putchunk("  ",FALSE,tmpwin);\
			  putchunk(text,FALSE,tmpwin);\
			  putchunk("\n",FALSE,tmpwin);\
			  col=tmp;\
			}

/******************************************************************************/

globaldef bool			do_netexit=FALSE;
globaldef char			outl[NETBUFFER],*nr_pos=outl,
				inpchar,inpline[256],histbuf[MAXHIST][256],
				escmode=0,edit_mode=1,inp_dis=1,
				logfile[256],fao[256],fao2[256];
globaldef uword			chan,net_chan=0;
globaldef int			net_chan_tcp=0,
				inpx=0,scrpag=0,scrwid=0,crsr=0,scrcrsr=0,col=0,
				histptr=0,histptrt=0;
globaldef unsigned int		iosb[2],read_iosb[2];
globaldef FILE			*out,*inp=NULL;
globaldef WINDOW		*msgwin,*inpwin,*tmpwin=NULL;
globaldef struct TCPdata	tcp_data;

/******************************************************************************/

int stricmp(src1,src2)
char *src1,*src2;
{
  while(*src1) {
    if (!(*src2)) return(upcase(*src1));
    if (upcase(*src1)!=upcase(*src2))
      return(upcase(*src1)-upcase(*src2));
    src1++; src2++;
  }
  return(-upcase(*src2));
}

/******************************************************************************/

int strincmp(src1,src2,cnt)
char *src1,*src2;
int cnt;
{
  while(*src1 && cnt--) {
    if (!*src2) return(upcase(*src1));
    if (upcase(*src1) != upcase(*src2))
      return(upcase(*src1)-upcase(*src2));
    src1++; src2++;
  }
  return(cnt?-upcase(*src2):0);
}

/******************************************************************************/

bool in_ast()
{
  int i,erg;
  i=JPI$_ASTACT;
  lib$getjpi(&i,0,0,&erg,0,0);
  return (erg>0);
}

/******************************************************************************/

int *c$_tmphead = NIL;
int *c$_asthead = NIL;

int *c$alloc_tmp(size)
int size;
{
  int *tmp;

  if (in_ast()) {
    tmp=malloc(size+4); *tmp=c$_asthead; c$_asthead=tmp;
    return(c$_asthead+1);
  } else {
    tmp=malloc(size+4); *tmp=c$_tmphead; c$_tmphead=tmp;
    return(c$_tmphead+1);
  }
}

/******************************************************************************/

c$dsc(c$_str)
char *c$_str;
{
  struct dsc$descriptor *c$_tmpdesc;

  c$_tmpdesc=c$alloc_tmp(8);
  c$_tmpdesc->dsc$w_length = strlen(c$_str);
  c$_tmpdesc->dsc$b_dtype  = DSC$K_DTYPE_T;
  c$_tmpdesc->dsc$b_class  = DSC$K_CLASS_S;
  c$_tmpdesc->dsc$a_pointer= c$_str;
  return(c$_tmpdesc);
}

/******************************************************************************/

c$ldsc(c$_str,c$_len)
char *c$_str;
int c$_len;
{
  struct dsc$descriptor *c$_tmpdesc;

  c$_tmpdesc=c$alloc_tmp(8);
  c$_tmpdesc->dsc$w_length = c$_len;
  c$_tmpdesc->dsc$b_dtype  = DSC$K_DTYPE_T;
  c$_tmpdesc->dsc$b_class  = DSC$K_CLASS_S;
  c$_tmpdesc->dsc$a_pointer= c$_str;
  return(c$_tmpdesc);
}

/******************************************************************************/

char *c$asc(c$_str)
char *c$_str;
{
  char tmp[256];

  sprintf(tmp,"%c%s",strlen(c$_str),c$_str);
  return(tmp);
}

/******************************************************************************/

int c$cks(c$_status)
int c$_status;
{
  int *c$_tmp;

  if (!(c$_status&1) && c$_status!=SS$_ABORT) {
    lib$signal(c$_status);
    if (net_chan) net_end(0);
    sys$exit(SS$_NORMAL);
  }
  if (in_ast()) while (c$_asthead!=NIL) {
    c$_tmp= *c$_asthead; free(c$_asthead); c$_asthead=c$_tmp;
  } else while (c$_tmphead!=NIL) {
    c$_tmp= *c$_tmphead; free(c$_tmphead); c$_tmphead=c$_tmp;
  }
  return(c$_status);
}

/******************************************************************************/

char *geterror(va_alist)	/* Facility,MessageID,Parameter(s) */
va_dcl
{
  va_list args;
  char *fmt,tmp[256],msg[256];
  int i;
  ubyte otherargs[4];
  uword msglen;
  ulong msgvec,msgcode[8];

  for (i=0;i<8;i++) msgcode[i]=0;
  for (i=0;i<256;i++) { msg[i]='\0'; tmp[i]='\0'; }
  va_start(args);
  va_count(msgcode[1]);
  msgvec=va_arg(args,long);
  msgcode[0]=va_arg(args,long);
  for(i=2;i<msgcode[1];i++) msgcode[i]=va_arg(args,long);
  va_end(args);
  c$cks(sys$getmsg(msgcode[0],&msglen,c$ldsc(msg,256),msgvec&0x0f,otherargs));
  if (otherargs[1]!=0)
    sys$faol(c$dsc(msg),&msglen,c$ldsc(tmp,256),&msgcode[2]);
  else strcpy(tmp,msg);
  putchunk(tmp,TRUE); putchunk("\r\n",TRUE);
  net_end(0);
  sys$dassgn(chan);
  sys$exit(SS$_NORMAL);
  return(tmp);
}

/******************************************************************************/

spawn()
{
  int substatus;
  struct dsc$descriptor *descr;

  wrefresh(inpwin);
  puts("");
  puts("-------------------------------------");
  puts("Re-Enter TALK with the command LOGOUT");
  puts("-------------------------------------");
  descr=0;
  c$cks(lib$spawn(descr,0,0,0,0,0,&substatus,0,0,0,c$dsc("TALK> "),0));
  delwin(newwin(scrpag,scrwid,0,0));
  wrefresh(msgwin); wrefresh(inpwin);
}

/******************************************************************************/

open_window()
{
  int i,device,item;

  c$cks(sys$assign(c$dsc("TT:"),&chan,0,0));
  item=DVI$_TT_PAGE;   c$cks(lib$getdvi(&item,&chan,0,&scrpag,0,0));
  item=DVI$_DEVBUFSIZ; c$cks(lib$getdvi(&item,&chan,0,&scrwid,0,0));
  item=DVI$_DEVTYPE;   c$cks(lib$getdvi(&item,&chan,0,&device,0,0));
  if (device==0) puts("TALK does not support unknown terminal types!");
  if (scrwid<40) puts("TALK does not support very tall windows.");
  if (scrpag<10) puts("TALK does not support small sized windows.");
  if (device==0 || scrwid<40 || scrpag<10) {
    sys$cancel(chan); sys$dassgn(chan); sys$exit(SS$_NORMAL);
  }
  initscr();
  msgwin=newwin(scrpag-1,scrwid,0,0);
  wclear(msgwin); wrefresh(msgwin);
  inpwin=newwin(1,scrwid,scrpag-1,0);
  wsetattr(inpwin,_BOLD); wclear(inpwin); wrefresh(inpwin);
}

/******************************************************************************/

putchunk(text,flag,window)
char *text;
bool flag;
{
  char *ptr,txt[NETBUFFER];
  ubyte c;

  if (flag && out) fputs(text,out);
  strcpy(ptr=txt,text);
  while (*ptr) {
    if (col==scrwid) { wrefresh(window); scroll(window); wrefresh(window); col=0; }
    c= *ptr++;
    if (c<0x20 || c>=0xf0) switch (c) {
      case BELL:	  mvwaddch(window,scrpag-2,col,c); break;
      case '\t':	  mvwaddch(window,scrpag-2,col++,' ');
			  while((col%8)>0) mvwaddch(window,scrpag-2,col++,' ');
			  break;
      case '\r':	  break;
      case '\n':	  wrefresh(window); scroll(window); wrefresh(window);
			  col=0; break;
      case TELNET_NOECHO: inp_dis=0; break;
      case TELNET_ECHO:	  inp_dis=1; break;
      default:		  mvwaddch(window,scrpag-2,col++,c);
    }
    else mvwaddch(window,scrpag-2,col++,c);
  }
  wrefresh(window);
  wmove(inpwin,inpx,0); wrefresh(inpwin);
}

/******************************************************************************/

showinpline(input,linlen,flag,curs)
char *input;
int linlen,flag,curs;
{
  int start,cnt;
  char *tmp,t[256],*tp;

  if (flag!=1) {
    start=curs-scrcrsr;
    if (scrcrsr<9 && curs>8)
          { scrcrsr=9;                  start=curs-9; }
    if (scrcrsr>scrwid-10 && curs<linlen-9)
          { scrcrsr=scrwid-10;          start=curs-scrwid+10; }
    if (scrcrsr>scrwid-10 && curs>=linlen-9 && linlen>scrwid && curs!=linlen)
          { scrcrsr=scrwid-linlen+curs; start=linlen-scrwid; }
    if (scrcrsr==scrwid && curs==linlen)
          { scrcrsr=scrwid-1;           start=linlen-scrwid+1; flag=1; }
  } else {
    if (linlen<scrwid) { scrcrsr=linlen; start=0; }
    else { scrcrsr=scrwid-1; start=linlen-scrwid+1; }
  }
  tmp=t; cnt=0; tp=input; input+=start;
  if (start) { *tmp++ = '\253'; input++; cnt++; }
  while (*input && cnt<scrwid-1) { *tmp++ = *input++; cnt++; }
  if (cnt==scrwid-1 && start+scrwid<linlen) *tmp++ = '\273';
  else if (*input) *tmp++ = *input;
  *tmp++ =' '; *tmp='\0';
  if (flag==1) { wmove(inpwin,0,0); wclrtoeol(inpwin); }
  if (flag!=2) {
    mvwaddstr(inpwin,0,0,t); wmove(inpwin,0,scrcrsr); wrefresh(inpwin); }
}

/******************************************************************************/

kbdast_meta(inpchar)
char inpchar;
{
  char txt[80],atime[80],buffer[256];

  switch (inpchar) {
    case 'A'-64:
      if (edit_mode&0x02) edit_mode&=0x01;
      else edit_mode=1-(edit_mode&0x01);
      escmode=0; break;
    case '\\'-64:
      kbdast_norm('\\');
      escmode=0; break;
    case 'i': case 'I':
      if (inp) {
        putchunk("Already redirected input stream.\n",FALSE,msgwin);
        putchunk("Please wait 'til that one finished...\n",FALSE,msgwin);
      } else {
        putchunk("Input filename: ",FALSE,msgwin); wgetstr(msgwin,buffer);
        putchunk(buffer,FALSE,msgwin); putchunk("\n",FALSE,msgwin);
        wrefresh(inpwin);
        if (*buffer) {
          if (!(inp=fopen(buffer,"r"))) { fclose(inp); inp=NULL; }
          sys$wake(0,0);
        }
      }
      escmode=0; break;
    case 'o': case 'O':
      if (out) {
        fclose(out); out=NULL; logfile[0]='\0';
      } else {
        putchunk("Output filename: ",FALSE,msgwin); wgetstr(msgwin,buffer);
        putchunk(buffer,FALSE,msgwin); putchunk("\n",FALSE,msgwin);
        wrefresh(inpwin);
        if (*buffer)
          if (!(out=fopen(buffer,"a"))) { fclose(out); out=NULL; }
        if (out) strcpy(logfile,buffer);
      }
      escmode=0; break;
    case 'H'-64:
      tmpwin=newwin(scrpag-1,scrwid,0,0);
      wclear(tmpwin); wrefresh(tmpwin);
      sprintf(txt,"TALK %s command options:",TALKVERSION);
      SHOWHELP(txt)
      SHOWHELP("  Control commands (preceeded by Control-\\)")
      SHOWHELP("    Ctrl-H This HELP page                 Ctrl-\\ Send command character")
      SHOWHELP("    Ctrl-D Display connection statistics  Ctrl-E Toggle echo of input text")
      SHOWHELP("    S      Spawn a subprocess             Ctrl-A Toggle INS/OWR permanent")
      SHOWHELP("    I      Redirect input stream")
      SHOWHELP("    O      Toggle file logging")
      SHOWHELP("  Miscellaneous commands")
      SHOWHELP("    Ctrl-S Hold display (XOFF)       Ctrl-W Redraw screen")
      SHOWHELP("    Ctrl-Q Continue display (XON)    Ctrl-L Redraw screen")
      SHOWHELP("    Ctrl-Z Abort and exit TALK")
      SHOWHELP("  Line Editing")
      SHOWHELP("    Ctrl-J Move one word left        DELETE Delete character")
      SHOWHELP("    Ctrl-K Move one word right       Ctrl-N Delete word")
      SHOWHELP("    Ctrl-H Start of line             Ctrl-F Erase to end of line")
      SHOWHELP("    Ctrl-E End of line               Ctrl-U Delete line")
      SHOWHELP("    Ctrl-A Toggle Insert/Overwrite   Ctrl-X Delete line")
      SHOWHELP(" ")
      SHOWHELP("  <Press any key to continue>")
      escmode=0; break;
    case 'D'-64:
      tmpwin=newwin(scrpag-1,scrwid,0,0);
      wclear(tmpwin); wrefresh(tmpwin);
      sprintf(txt,"TALK %s connection statistics:",TALKVERSION);
      SHOWHELP(txt)
      sprintf(txt,"  TCP/IP software:  %s",TRANSPORT);
      SHOWHELP(txt)
      sprintf(txt,"  Local host name:  %s",tcp_data.local_host);
      SHOWHELP(txt)
      sprintf(txt,"  Local IP number:  %u.%u.%u.%u",tcp_data.local_ip[0],tcp_data.local_ip[1],tcp_data.local_ip[2],tcp_data.local_ip[3]);
      SHOWHELP(txt)
      sprintf(txt,"  Local port:       %u (%u.%u)",tcp_data.local_port,tcp_data.local_port>>8,tcp_data.local_port&0xff);
      SHOWHELP(txt)
      sprintf(txt,"  Remote host name: %s",tcp_data.foreign_host);
      SHOWHELP(txt)
      sprintf(txt,"  Remote IP number: %u.%u.%u.%u",tcp_data.foreign_ip[0],tcp_data.foreign_ip[1],tcp_data.foreign_ip[2],tcp_data.foreign_ip[3]);
      SHOWHELP(txt)
      sprintf(txt,"  Remote port:      %u (%u.%u)",tcp_data.foreign_port,tcp_data.foreign_port>>8,tcp_data.foreign_port&0xff);
      SHOWHELP(txt)
      if (*logfile) {
        sprintf(txt,"  Logfile:          %s",logfile);
        SHOWHELP(txt)
      }
      sprintf(txt,"  Send bytes:  %8.8u   Received bytes:  %8.8u",tcp_data.send_bytes,tcp_data.received_bytes);
      SHOWHELP(txt)
      sprintf(txt,"  Send packets:%8.8u   Received packets:%8.8u",tcp_data.send_packets,tcp_data.received_packets);
      SHOWHELP(txt)
      SHOWHELP(" ")
      SHOWHELP("  <Press any key to continue>")
      escmode=0; break;
    case 'E'-64:
      inp_dis=1-inp_dis;
      escmode=0; break;
    case 's': case 'S':
      spawn();
      escmode=0; break;
    default:
      escmode=0; break;
  }
}

/******************************************************************************/

kbdast_csi(inpchar)
char inpchar;
{
  switch (inpchar) {
    case 'A':
      if (ringminus(histptrt,MAXHIST)!=histptr && *histbuf[ringminus(histptrt,MAXHIST)]) {
        histptrt=ringminus(histptrt,MAXHIST);
        memcpy(inpline,histbuf[histptrt],256);
        crsr=inpx=strlen(inpline); showinpline(inpline,inpx,1,crsr);
      }
      escmode=0; break;
    case 'B':
      if (histptrt!=histptr && ringplus(histptrt,MAXHIST)!=histptr) {
        histptrt=ringplus(histptrt,MAXHIST);
        memcpy(inpline,histbuf[histptrt],256);
      } else { inpline[0]='\0'; histptrt=histptr; }
      crsr=inpx=strlen(inpline); showinpline(inpline,inpx,1,crsr);
      escmode=0; break;
    case 'C':
      if (crsr!=inpx) { crsr++; scrcrsr++; showinpline(inpline,inpx,0,crsr); }
      escmode=0; break;
    case 'D':
      if (crsr!=0) {crsr--; scrcrsr--; showinpline(inpline,inpx,0,crsr); }
      escmode=0; break;
    default:
      escmode=0; break;
  }
}

/******************************************************************************/

kbdast_esc(inpchar)
char inpchar;
{
  if (inpchar=='[') escmode=2;
  else escmode=0;
}

/******************************************************************************/

kbdast_norm(inpchar)
char inpchar;
{
  int i;

  switch (inpchar) {
    case '['-64:
      escmode=1; break;
    case '['+64:
      escmode=2; break;
    case '\\'-64:
      escmode=3; break;
    case 'T'-64:
    case 'Y'-64:
    case 'C'-64:
      break;
    case 'L'-64:
    case 'W'-64:
      delwin(newwin(scrpag,scrwid,0,0));
      wrefresh(msgwin); wrefresh(inpwin);
      break;
    case 'A'-64:
      if (edit_mode&0x02) edit_mode=1-(edit_mode&0x01);
      else edit_mode=3-edit_mode;
      break;
    case 'H'-64:
      if (inpx) { crsr=0; scrcrsr=0; showinpline(inpline,inpx,0,crsr); }
      break;
    case 'E'-64:
      if (inpx) {
        crsr=inpx; scrcrsr=(inpx<scrwid-1?inpx:scrwid-1);
        showinpline(inpline,inpx,0,crsr);
      }
      break;
    case 'N'-64:
      if (inpx>0 && !isspace(inpline[crsr])) {
        while (crsr>0 && !isspace(inpline[crsr-1])) {
          i=crsr; while (i!=inpx) { inpline[i-1]=inpline[i]; i++; }
          crsr--; scrcrsr--; inpx--; inpline[inpx]='\0'; showinpline(inpline,inpx,0,crsr);
        }
        while (crsr<inpx && !isspace(inpline[crsr])) {
          i=crsr+1; while (i!=inpx) { inpline[i-1]=inpline[i]; i++; }
          inpx--; inpline[inpx]='\0'; showinpline(inpline,inpx,0,crsr);
        }
        while (crsr<inpx && isspace(inpline[crsr])) {
          i=crsr+1; while (i!=inpx) { inpline[i-1]=inpline[i]; i++; }
          inpx--; inpline[inpx]='\0'; showinpline(inpline,inpx,0,crsr);
        }
      }
      break;
    case 'J'-64:
      if (crsr>0 && !isspace(inpline[crsr-1])) {
        scrcrsr--; crsr--; showinpline(inpline,inpx,2,crsr);
        while (crsr>0 && !isspace(inpline[crsr])) {
          scrcrsr--; crsr--; showinpline(inpline,inpx,2,crsr); }
      }
      while (crsr>0 && isspace(inpline[crsr-1])) {
        scrcrsr--; crsr--; showinpline(inpline,inpx,2,crsr); }
      showinpline(inpline,inpx,0,crsr);
      break;
    case 'K'-64:
      while (crsr<inpx && isspace(inpline[crsr])) {
        scrcrsr++; crsr++; showinpline(inpline,inpx,2,crsr); }
      while (crsr<inpx && !isspace(inpline[crsr])) {
        scrcrsr++; crsr++; showinpline(inpline,inpx,2,crsr); }
      showinpline(inpline,inpx,0,crsr);
      break;
    case 'U'-64:
    case 'X'-64:
      crsr=inpx=0; inpline[0]='\0'; showinpline(inpline,inpx,1,crsr); break;
    case 'F'-64:
      inpline[crsr]='\0'; crsr=inpx=strlen(inpline);
      showinpline(inpline,inpx,1,crsr); break;
    case 127:
      if (inpx && crsr) {
        i=crsr; while (i!=inpx) { inpline[i-1]=inpline[i]; i++; }
        crsr--; scrcrsr--; inpx--; inpline[inpx]='\0';
        showinpline(inpline,inpx,0,crsr);
      }
      break;
    case 13:
      inpline[inpx]='\0';
      if (strcmp(histbuf[histptr?(histptr-1):(MAXHIST-1)],inpline)) {
        if (*inpline) {
          memcpy(histbuf[histptr],inpline,256);
          histptr=ringplus(histptr,MAXHIST);
        }
      }
      histptrt=histptr;
      inpline[inpx++]='\n'; inpline[inpx]=0;
      if (inp_dis) {
        wsetattr(msgwin,_BOLD); putchunk(inpline,TRUE,msgwin); wclrattr(msgwin,_BOLD);
      }
      inpline[inpx-1]='\r'; inpline[inpx++]='\n'; inpline[inpx]=0;
      net_send(inpline);
      crsr=scrcrsr=inpx=0; inpline[0]='\0';
      if (edit_mode&0x02) edit_mode=1-(edit_mode&0x01);
      wmove(inpwin,0,0); wclrtoeol(inpwin); wrefresh(inpwin);
      break;
    default:
      if (inpx<250 || ((edit_mode&0x01) && crsr<250)) {
        if (edit_mode&0x01) {
          if (crsr<inpx) inpline[crsr]=inpchar;
          else { inpline[inpx++]=inpchar; inpline[inpx]='\0'; }
          crsr++; scrcrsr++;
        } else {
          if (crsr<inpx) {
            i=inpx; while(i>=crsr) { inpline[i+1]=inpline[i]; i--; }
            inpline[crsr]=inpchar; inpx++; crsr++; scrcrsr++;
          } else {
            inpline[inpx++]=inpchar; inpline[inpx]='\0'; crsr++; scrcrsr++;
          }
        }
        showinpline(inpline,inpx,0,crsr);
      }
  }
}

/******************************************************************************/

kbdast()
{
  uword *i_o_size;

  i_o_size=iosb;
  if ((!(*(i_o_size+1))) && (inpchar=='Z'-64)) {
    net_end(0);
    sys$dassgn(chan);
    sys$exit(SS$_NORMAL);
  }
  c$cks(*i_o_size);
  if (tmpwin) { delwin(tmpwin); tmpwin=NULL; wrefresh(msgwin); wrefresh(inpwin);
  } else switch (escmode) {
    case 0: kbdast_norm(inpchar); break;
    case 1: kbdast_esc(inpchar);  break;
    case 2: kbdast_csi(inpchar);  break;
    case 3: kbdast_meta(inpchar); break;
  }
  c$cks(sys$qio(0,chan,IO$_READVBLK|IO$M_NOFILTR|IO$M_NOECHO,iosb,kbdast,0,&inpchar,1,0,0,0,0));
}

/******************************************************************************/

analyze_line(text,flag)
char *text;
bool flag;
{
  putchunk(text,flag,msgwin);
}

/******************************************************************************/

main(argc,argv)
int argc;
char *argv[];
{
  char *ptr,*srvptr,*portptr,*logptr,srv[256],txt[256];
  uword *i_o_size;
  int port;

  if (argc>1) srvptr=argv[1]; else srvptr=getenv("HOST");
  if (srvptr) {
    srv[0]='\0'; ptr=srv; while(*srvptr) *ptr++ = toupper(*srvptr++); *ptr='\0';
  } else srv[0]='\0';
  if (argc>2) portptr=argv[2]; else portptr=getenv("PORT");
  if (portptr) port=atoi(portptr); else port= -1;
  if (argc>3) logptr=argv[3]; else logptr=getenv("LOGFILE");
  if (logptr) {
    logfile[0]='\0'; ptr=logfile; while(*logptr) *ptr++ = toupper(*logptr++); *ptr='\0';
  } else logfile[0]='\0';
  if (!*srv || port<=0 || !strcmp(srv,"?")) {
    sprintf(txt,"TALK %s -- More than a slightly enhanced TELNET program",TALKVERSION);
    puts(txt);
    puts("             Copyright 1992 by Bernd Onasch (Very Mad Students)");
    puts(" ");
    puts("Usage: TALK <host> <port> [logfile]");
    puts("       <host>    IP Hostname or Hostnumber");
    puts("       <port>    IP Port to connect to");
    puts("       [logfile] Optional file to log input and output to");
    sys$exit(SS$_NORMAL);
  }
  open_window();
  if (*logfile)
    if (!(out=fopen(logfile,"a"))) { fclose(out); out=NULL; }
  if (!out) logfile[0]='\0';
  sprintf(txt,"TALK %s Trying to connect %s port %u (Abort with Ctrl-Y)\n",TALKVERSION,srv,port);
  putchunk(txt,TRUE,msgwin);
  net_start(srv,port);
  net_info();
  sprintf(txt,"Connected to port %u on %s (%u.%u.%u.%u)\n",
    tcp_data.foreign_port,tcp_data.foreign_host,
    tcp_data.foreign_ip[0],tcp_data.foreign_ip[1],tcp_data.foreign_ip[2],tcp_data.foreign_ip[3]);
  putchunk(txt,TRUE,msgwin);
  putchunk("Press Ctrl-\\ Ctrl-H for HELP, press Ctrl-Z to abort.\n",TRUE,msgwin);
  c$cks(sys$qio(0,chan,IO$_READVBLK|IO$M_NOFILTR|IO$M_NOECHO,iosb,kbdast,0,
                &inpchar,1,0,0,0,0));
  while (TRUE) {
    sys$hiber();
    if (inp) {
      while (fgets(txt,250,inp)) {
        if (inp_dis) putchunk(txt,TRUE,msgwin);
        ptr=txt+strlen(txt)-1;
        if (*ptr=='\n' || *ptr=='\r') *ptr-- ='\0';
        if (*ptr=='\n' || *ptr=='\r') *ptr-- ='\0';
        strcat(txt,"\r\n"); i_o_size=iosb; net_send(txt); c$cks(*i_o_size);
        wrefresh(inpwin); sleep(1);
      }
      fclose(inp); inp=NULL;
    }
  }
  sys$exit(SS$_NORMAL);
}

/******************************************************************************/
